/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


// 
// File: BaseTypedef.h
// Version: 1.0
// Contains: 
// Copyright:	 1998 by Mustek Systems, Inc., all rights reserved.
//

#ifndef __BASETYPE__
#define __BASETYPE__

#include <asm/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/time.h>
#include "ForWhat.h"

#define	IN	
#define	OUT	
typedef	int 	HANDLE;
typedef __u8 *	PUCHAR;
typedef __u16	USHORT;
typedef __u16 *	PSHORT;
typedef __u16 * PUSHORT;

typedef unsigned long *	LPDWORD;
typedef unsigned int 	ULONG;
typedef unsigned int *	PULONG;
typedef int *	LPOVERLAPPED;
typedef void*	PVOID;
typedef	PULONG	LPCTSTR;


#ifndef huge
#define huge
#endif

#ifndef far
#define far
#endif

#ifndef FAR
#define FAR far
#endif

#ifndef NEAR
#define NEAR
#endif

#ifndef CONST
#define CONST const
#endif

#ifndef EXPORT
#define EXPORT
#endif

// Boolean function
#undef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0

// MessageBox
#define IDOK 1
#define MB_OK 1

// Message action
#define PM_REMOVE 		1
#define PM_NOREMOVE 	2

// Variable structure
#define MSG int

// Variable type
typedef unsigned char BOOL;
typedef unsigned char BOOLEAN;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef long LONG;
typedef unsigned long DWORD;
typedef BOOL far *LPBOOL;
typedef char* LPSTR;
typedef BYTE far *LPBYTE;
typedef const char *LPCSTR;
typedef const void far *LPCVOID;
typedef int far *LPINT;
typedef char *LPTSTR;
typedef WORD far *LPWORD;
typedef unsigned int *PUINT;
typedef unsigned int UINT;
typedef void* LPVOID;
typedef unsigned char UCHAR;
//typedef unsigned int size_t;

#define LPMSG MSG *

// Data Operation
//#define MAKEWORD ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8 ))
//#define MAKELONG ((LONG)(((WORE)(a)) | ((DWORD)((WORD)(b))) << 16 ))
#define LOWORD(l) ((WORD)(l))
#define HIWORD(l) ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w) ((BYTE)(w))
#define HIBYTE(w) ((BYTE)(((WORD)(w) >> 8) & 0xFF))

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))

// Handle
//#define HINSTANCE int
//#define HWND int
typedef int HINSTANCE;
typedef int HWND;
#define	INVALID_HANDLE_VALUE 0
// Functions...

#ifdef __cplusplus
extern "C" {
#endif
int MessageBox(
	HWND	hWnd,
	LPCTSTR	lpText,
	LPCTSTR	lpCaption,
	UINT	uType
);
BOOL PeekMessage(LPMSG a1, HWND a2, UINT a3, UINT a4, UINT a5);
BOOL TranslateMessage(const MSG * a1);
long DispatchMessage(const MSG * a2);
void AfxMessageBox(char *buf);
HINSTANCE AfxGetInstanceHandle(void);
DWORD GetTickCount(void);
void* _fmalloc(unsigned int theSize);
void _ffree(void* memblock);
void Sleep(DWORD DelayTime);
void ShowUp(const char* pszFormat, ...);

#ifdef __cplusplus
}
#endif

#endif
