/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#ifndef __CLASS_FILTER_HEADER__
#define __CLASS_FILTER_HEADER__

#include "BaseTypedef.h"
#include "common.h"
class CFilter
{
public: // constructor
	CFilter();
	~CFilter();
public:	// filter functions
	void DeMoire(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void UnSharpMask(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void DeMoire_LoRes1(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void DeMoire_LoRes2(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void Emboss(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void Sharpen(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void Blur(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void Flip(LPSTR lpSource,DS_SCANMODE ScanMode,DWORD ScanLines,DWORD BytesPerLine);
	void Invert(LPSTR lpSource,DS_SCANMODE scanMode,DWORD ScanLines,DWORD BytesPerLine);
	void AutoLevel(LPSTR lpSource, DS_SCANMODE scanMode, DWORD ScanLines, DWORD BytesPerLine);
	void QBETDetectAutoLevel(void* pDIB, DWORD ImageWidth, DWORD ImageHeight);
	void QBetChange(LPSTR lpSource, DS_SCANMODE scanMode, DWORD ScanLines, DWORD BytesPerLine);
private:
	int ImageMatrix[3][3];
	int Coef[3][3];
	BYTE MatrixCalculate();
	LPSTR m_lpBuffer1;
	LPSTR m_lpBuffer2;
	void DataProcessor(LPSTR lpSource, DS_SCANMODE ScanMode, DWORD ScanLines, DWORD BytesPerLine);
	void AllocateBuffer(DWORD BytesPerLine);
	void ReleaseBuffer();
};

#endif
