/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include "Fraction.h"

CFraction::CFraction()
{
	m_lDenominator = 1;
	m_lNumerator = 0;
	m_isAutoReduction = false;
}
CFraction::CFraction(long Integer)
{
	m_lDenominator = 1;
	m_lNumerator = Integer;
	m_isAutoReduction = false;
}
CFraction::CFraction(long Numerator,long Denominator)
{
	m_lDenominator = Denominator;
	m_lNumerator = Numerator;
	m_isAutoReduction = false;
	Reduction();
}
CFraction::CFraction(long Integer,long Numerator,long Denominator)
{
	m_lDenominator = Denominator;
	m_lNumerator = Numerator + Integer*Denominator;
	m_isAutoReduction = false;
	Reduction();
}
CFraction::~CFraction()
{
}
void CFraction::Reduction()
{
	if(m_lDenominator == 1) return;
	//long MinX = min(m_lNumerator,m_lDenominator);
	long lDivisor = 2;
	
	do
	{
		if((m_lNumerator%lDivisor)==0 && (m_lDenominator%lDivisor)==0)
		{
			m_lNumerator /= lDivisor;
			m_lDenominator /= lDivisor;
		}
		else
			lDivisor++;
	} while( lDivisor <= min(m_lNumerator,m_lDenominator) );
}
