/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include <gtk/gtk.h>
#include <string.h>

gchar FaxNumber[256];
GtkWidget * window;
GtkWidget * widget;
GtkWidget * combo;

void FaxNumber_OKClicked ( GtkButton * button, gpointer data )
{
  gchar * tmp = gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( combo ) -> entry ) );
  gchar * tmp2 = gtk_entry_get_text( GTK_ENTRY ( widget ) );
  strcat( tmp, " "); 
  strcpy(FaxNumber, tmp);
  strcat(FaxNumber, tmp2);
  gtk_widget_destroy ( window );
}


void FaxNumber_CancelClicked ( GtkButton * button, gpointer data )
{
  gtk_widget_destroy ( window );
}


void CloseTheFaxNumberDialog ( GtkWidget * window, gpointer data ) 
{
   gtk_main_quit () ;
}

GtkWidget * MakeWindow ()
{
   GtkWidget * window;

   window = gtk_window_new ( GTK_WINDOW_TOPLEVEL );
   gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE );
   gtk_container_set_border_width( GTK_CONTAINER ( window ), 10 );
   gtk_window_set_default_size ( GTK_WINDOW ( window ) , 320, 80 );
   gtk_window_set_title ( GTK_WINDOW ( window ), "Ready to Fax" );
   gtk_window_set_position ( GTK_WINDOW ( window ), GTK_WIN_POS_MOUSE );
   gtk_signal_connect ( GTK_OBJECT ( window ), "destroy", 
			GTK_SIGNAL_FUNC ( CloseTheFaxNumberDialog ),
			NULL );
   gtk_window_set_modal ( GTK_WINDOW ( window ), TRUE );
   
   return window;
   
}

GtkWidget * MakeSeparator ()
{
  GtkWidget * line;
  GtkWidget * box;

  box = gtk_hbox_new ( TRUE, 5 );

  line = gtk_hseparator_new ();
  gtk_box_pack_start ( GTK_BOX ( box ), line, FALSE, TRUE, 0 );
  gtk_widget_show ( line );

  return box;
}


GtkWidget * MakeEntryBox ()
{

   GtkWidget * box;

   box = gtk_hbox_new ( TRUE, 5 );

   widget = gtk_label_new ( "Please enter the fax number  :" );
   gtk_box_pack_start( GTK_BOX ( box ), widget, FALSE, TRUE, 0 );
   gtk_widget_show ( widget );

   widget = gtk_entry_new ();
   gtk_box_pack_start( GTK_BOX ( box ), widget, FALSE, TRUE, 0 );
   gtk_widget_show ( widget );

   return box;
}


GtkWidget *  MakeComboBox ()
{
  
  GtkWidget * box;
  GList * combolist;

 
  box = gtk_hbox_new ( TRUE, 5 );
  
  combo = gtk_label_new ( "Please enter the device path :" );
  gtk_box_pack_start( GTK_BOX ( box ), combo, FALSE, TRUE, 0 );
  gtk_widget_show ( combo );

  combolist=NULL;
  combolist = g_list_append ( combolist, "/dev/modem" );
  combolist = g_list_append ( combolist, "/dev/cua1" );
  combolist = g_list_append ( combolist, "/dev/ttyS1" );
  combo=gtk_combo_new();
  gtk_combo_set_popdown_strings ( GTK_COMBO ( combo ), combolist );
  gtk_box_pack_start( GTK_BOX ( box ), combo, FALSE, TRUE, 0 );
  gtk_widget_show ( combo );

  g_list_free( combolist );
  
  return box;   
}


GtkWidget * MakeButtons ()
{
   GtkWidget * box;
   GtkWidget * button;
  
   box = gtk_hbox_new ( TRUE, 5 );
  
   button = gtk_button_new_with_label ( "O K" );
   gtk_signal_connect ( GTK_OBJECT ( button ),
			"clicked", GTK_SIGNAL_FUNC ( FaxNumber_OKClicked ), NULL );
   gtk_box_pack_end( GTK_BOX ( box ), button, FALSE, TRUE, 0 );
   gtk_widget_show ( button );
   
   button = gtk_button_new_with_label ( "Cancel" );
   gtk_signal_connect ( GTK_OBJECT ( button ),
			"clicked", GTK_SIGNAL_FUNC ( FaxNumber_CancelClicked ), NULL );
   gtk_box_pack_end( GTK_BOX ( box ), button, FALSE, TRUE, 0 );
   gtk_widget_show ( button );
   
   return box;
   
}


gchar * GetFaxNumberDialog ( gint argc, gchar * argv[] )
{
    
   GtkWidget * entrybox;
   GtkWidget * mainbox;
   GtkWidget * buttonbox;
   GtkWidget * combobox;
   GtkWidget * separator;


   
   gtk_init ( &argc, &argv );
     
   window = MakeWindow();
   entrybox = MakeEntryBox();
   combobox = MakeComboBox();
   buttonbox = MakeButtons();
   separator = MakeSeparator();
  
   mainbox = gtk_vbox_new ( FALSE, 10 );
   gtk_box_pack_start ( GTK_BOX ( mainbox ), combobox, FALSE, FALSE, 0 );
   gtk_box_pack_start ( GTK_BOX ( mainbox ), entrybox, FALSE, FALSE, 0 );
   gtk_box_pack_start ( GTK_BOX ( mainbox ), separator, FALSE, FALSE, 0 );
   gtk_box_pack_start ( GTK_BOX ( mainbox ), buttonbox, FALSE, FALSE, 0 );
  
  
   gtk_widget_show ( entrybox );
   gtk_widget_show ( buttonbox );
   gtk_widget_show ( combobox );
   gtk_widget_show ( separator );
  
   gtk_container_add ( GTK_CONTAINER ( window ), mainbox );
   gtk_widget_show ( mainbox );
   gtk_widget_show ( window );
  
   gtk_main ();
   return FaxNumber;
}











