/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


//#define EXPORT extern "C" __declspec(dllexport)

#include "BaseTypedef.h"

typedef char * LPSTR;

#define ERR_SPI_NONE				0
#define ERR_SPI_VERSION				1
#define ERR_SPI_INTERFACE			2
#define ERR_SPI_PORTADDR			3
#define ERR_SPI_PORTMODE			4
#define ERR_SPI_SLIDEKIT			5
#define ERR_SPI_ADF					6
#define ERR_SPI_ISDOWNLOADGAMMA		7
#define ERR_SPI_INPUTGAMMA			8
#define ERR_SPI_OUTPUTGAMMA			9
#define ERR_SPI_ISTRIGGPREDCAN		10
#define ERR_SPI_ISTRIGGSCAN			11
#define ERR_SPI_ISTRIGGAP			12
#define ERR_SPI_FRAME				13
#define ERR_SPI_SCANMODE			14
#define ERR_SPI_LINEARTTHREASHOLD	15
#define ERR_SPI_PIXELFLAVOR			16
#define ERR_SPI_SCANSOURCE			17
#define ERR_SPI_GAMMATABLE			18
#define ERR_SPI_CCALIBRATION		19
#define ERR_SPI_RB					20
#define ERR_SPI_RT					21
#define ERR_SPI_POWERDELAY			22
#define ERR_SPI_EXPOSETIME			23
#define ERR_SPI_DELAYTIME			24
#define ERR_SPI_ALLOCATEMEM			25
#define ERR_SPI_CARRLAGE			26
#define ERR_SPI_STOPSCAN			27
#define ERR_SPI_CLOSE				28
#define ERR_SPI_READIMAGE			29
#define ERR_SPI_REVERSE_RGB			30
#define ERR_SPI_POWERON				31
#define ERR_SPI_POWEROFF			32
#define ERR_SPI_TRIGPRESCAN			33
#define ERR_SPI_TRIGSCAN			34
#define ERR_SPI_TRIGAP				35
#define ERR_SPI_ADFPAPER			36
#define ERR_SPI_NOTCONNECT			37
#define ERR_SPI_PRINTING			38
#define ERR_SPI_PROGRAMMING			39
#define ERR_SPI_HARDWARE			40
#define ERR_SPI_NONSTI				41
#define ERR_SPI_CANCELSCAN			42	
#define ERR_SPI_ACKPROGRESSCALLBACK	43
#define ERR_SPI_ONEPAGEDONE			44

typedef struct PB_Version_def
{
	WORD	Err_Code;
	BYTE	Major;
	BYTE	Minor;
}VerStruct;

typedef struct PB_DevInfo_def
{
	WORD	Err_Code;
	WORD	InterFace;
	WORD	PortAddr;
	WORD	PortMode;
	WORD	Info_Len;
	LPSTR	Info;
	BYTE	SlideKit_Install;
	BYTE	ADF_Install;
	BYTE	IsDownLoadGamma;
	BYTE	InputGammaBits;
	BYTE	OutputGammaBits;
	BYTE	IsTriggerPrescan;
	BYTE	IsTriggerscan;
	BYTE	IsTriggerAP;
}GetDevInfoStruct;

typedef struct PB_GammaInfo_def
{
		WORD	Err_Code;
		WORD	ScanMode;
		WORD	GammaInputBits;
		WORD	GammaOutputBits;
}GammaInfoStruct;

typedef struct PB_SetParameters_def
{
	WORD	Err_Code;
	WORD	Frame[4];
	WORD	Set_DPI;
	WORD	Scan_Mode;
	WORD	LineArt_Threshold;
	BYTE	Pixel_Flavor;
	BYTE	Scan_Source;
	LPVOID	GammaTable;
}SetParametersStruct;

typedef struct PB_GetParameters_def
{
	WORD	Err_Code;
	WORD	Rtn_XDPI;
	WORD	Rtn_YDPI;
	DWORD	Scan_Linebytes;
	DWORD	Scan_Lines;
}GetParametersStruct;


typedef struct PB_StartScan_def
{
	WORD	Err_Code;

}StartScanStruct;

typedef struct PB_Common_def
{
	WORD	Err_Code;
}CommonStruct;

typedef struct PB_Image_def
{
	WORD	Err_Code;
	WORD	Reverse_RGB;
	WORD	Buf_Lines;
	WORD	Txf_Lines;
	LPSTR	Buf_Address;
}ImgStruct;

typedef struct PB_PowerControl_def
{
	WORD	Err_Code;
	BYTE	LampSwitch;
}PowerControlStruct;

typedef struct PD_DevStatus_def
{
	WORD	Err_Code;
	BYTE	TriggerPrescan;
	BYTE	TriggerScan;
	BYTE	TriggerAP;
	BYTE	ADF_PaperPresent;
}DeviceStatusStruct;
/*
EXPORT BOOL _Open(void);
EXPORT BOOL GetVersionInfo(VerStruct *lpVersionInfo);
EXPORT BOOL GetDeviceInfo(GetDevInfoStruct *lpDeviceInfo);
EXPORT BOOL SetPArameters(SetParametersStruct *lpSetPar);
EXPORT BOOL GetParameters(GetParametersStruct *lpGetPar);
EXPORT BOOL StartScan(StartScanStruct *lpStartScan);
EXPORT BOOL CarriageHome(CommonStruct *lpCommon);
EXPORT BOOL StopScan(CommonStruct *lpCommon);
EXPORT BOOL _Close(void);
*/
