/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#ifndef __Scan_Module_Global__
#define __Scan_Module_Global__

#include "SpExport.h"
#include "common.h"
#include "FRuler.h"

class CSourceBuffer;

typedef struct 
{
	char Bri;
	char Con;
	char Gam;
} VRGBE;

class CScanModuleGlobal
{
public:
	CScanModuleGlobal();
	~CScanModuleGlobal();
	void Attach();
	void Detach();
	void CreateGammaTable(int input_gamma, int output_gamma, DS_ENHANCE brightness, 
		DS_ENHANCE contrast, DS_GAMMA gamma,DS_SCANMODE scanmode);
	void GenerateGammaCode(VRGBE color, int input_level, int OutputLevel,WORD* lpCode);
	void BltRGBLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
	void BltGrayLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
	void BltTextLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
	void DecRGBLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
	void DecGrayLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
	void DecTextLines(LPDS_BLOCKDESCRIPTOR pImageBlock);
private:
	void GetTextOneLine(char* pBuffer);		
public:
	bool m_bDSOpen;
	bool m_bScanning;

	// variables for ADF default image modifiers offset
	
	int m_nADFBrightOffset;
	int m_nADFBWBrightOffset;
	int m_nADFContrastOffset;
	float m_fADFGammaOffset;

	DS_IMAGEDESCRIPTOR m_ScanJob;
	
	DWORD m_dwLineByte; // the number of bytes per line (raw data)
	DWORD m_dwSrcLength;	// the height of source
	
	WORD* m_pEnhance;
	
	DWORD m_nImageWidth; // the number of pixel per line ( after interplation or down sample)
	DWORD m_nImageHeight;// the nmber of lines ( after interpolation or down sample)
	DWORD m_nLinesTransfered;
	
	
	CFastRuler* m_pHRuler;
	CFastRuler* m_pVRuler;	
	DS_UINT32 m_u32DestXRes; // resolution of cooked data in horizental direction
	DS_UINT32 m_u32DestYRes; // resolution of cooked data in vertical direction
	DS_UINT32 m_u32SrcXRes;  // resolution of raw data in horizental direction
	DS_UINT32 m_u32SrcYRes;  // resolution of raw data in vertical direction
	DS_INT32 m_nHBound;
	DS_INT32 m_nVBound;
	DS_INT32 m_nBound2;
	DS_INT32 m_nBound;
	DS_INT32 m_nHalfBound;
	
	CSourceBuffer* m_pSourceBuffer;
	SM_RESIZE m_rsResize;
	BOOL m_bDownSampleProcess;
	BOOL m_bDownloadGamma;
	
	char* m_pLowerSrcLine;
	char* m_pUpperSrcLine;
			
private:
	BOOL m_bGetGammaMaps;

};

#endif
