/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#ifndef __SCANMODULE_INTERNAL__
#define __SCANMODULE_INTERNAL__
#include "common.h"

/*****************************************************************/
/*                                                               */ 
/*	Basic data type definitions                              */
/*                                                               */ 
/*****************************************************************/
typedef unsigned long DS_FILTER, *LPDS_FILTER;
typedef unsigned long DS_DESCREEN, *LPDS_DESCREEN;

/*****************************************************************/
/*                                                               */ 
/*	Constants definitions                                    */
/*                                                               */ 
/*****************************************************************/
// Constants for DS_FILTER
const DS_FILTER 	DSFT_NONE = 0x0000;
const DS_FILTER		DSFT_BLUR = 0x0001;
const DS_FILTER		DSFT_BLURMORE = 0x0002;
const DS_FILTER		DSFT_SHARPEN = 0x0004;
const DS_FILTER		DSFT_SHARPENMORE = 0x0008;
const DS_FILTER		DSFT_INVERT = 0x0010;
const DS_FILTER		DSFT_FLIP = 0x0020;
const DS_FILTER		DSFT_EMBOSS = 0x0040;
const DS_FILTER		DSFT_UNSHARPENMASK = 0x0080;

// Constants for DS_DESCREEN
const DS_DESCREEN   DSDE_NONE = 0x0000;
const DS_DESCREEN   DSDE_NEWSPAPER = 0x0001;
const DS_DESCREEN   DSDE_MAGAZINE = 0x0002;
const DS_DESCREEN   DSDE_ARTPAINT = 0x0004;

/*****************************************************************/
/*                                                               */ 
/*	Structure definitions for Scan module UI module              */
/*                                                               */ 
/*****************************************************************/

typedef struct {
	DS_DESCREEN		dsDescreen;
	DS_FILTER		ftFilter;
	bool			isColorMatch;	
	DS_LANGUAGE		lgLanguage;				
} SM_PRIVATE;

typedef struct {
	UINT	nCompressRate;
	char	sCompressPath[256];
	DS_IMAGEDESCRIPTOR pScanJobs[10];
} FAST_SCAN_STRUCT;


#endif









