/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#define LINUX

#ifdef WIN32
#include <windows.h>
#include <stdio.h>
#endif

#ifdef MAC
#include "String.h"
#include <stdio.h>
#include "Win2Mac.H"
#include "math.h"
#include "Profile.h"
//#include <stdlib.h>

//#include <string.h>
#include <ctype.h>
#endif
#include <stdio.h>
#include "BaseTypedef.h"
#include "sci.h"
#include "gt680x.h"

#include "gtscanner.h"
#define DARKWIDTH 30

#ifndef MUSINI
#define	MUSINI  // Set for read mustek ini
#endif

/////////////////////////
char    DebugBuffer2[64];
extern  USHORT DelayTime;
/////////////////////////
UCHAR	RDark,GDark,BDark;
BOOL    mysuccess=TRUE;
USHORT  FACTOR=100;
USHORT  RAWDATA;

USHORT  gRedStart=4;
USHORT  gRedStop=325;
USHORT  gGreenStart=4;
USHORT  gGreenStop=325;
USHORT  gBlueStart=4;
USHORT  gBlueStop=325;

BOOL PollingMotor(HANDLE hDevice)
{

	UCHAR	iobuffer[64];
	int		i;
	ULONG	nBytes;
	BOOL    success;

retry1:

	iobuffer[0]=0x17;
	iobuffer[1]=0x01;
	success=SendUSBCommand(
                              hDevice,
                              GrandTech_Scanner_Vendor_USB_Send_Command,
                              iobuffer, 
		                      64,
		                      iobuffer,
		                      64,
		                      &nBytes);
	if((iobuffer[3] == 0x01) || (iobuffer[3] == 0x03))
	{
		Sleep(100);
		goto retry1;
	}


  return success;
} 
BOOL EndScan41(HANDLE hDevice)
{

	UCHAR	iobuffer[64];
	int		i;
	ULONG	nBytes;
	BOOL    success;

	for(i=0;i<8;i++)
	{
    iobuffer[i*8]=0x41;
    iobuffer[i*8+1]=0x01; 
    iobuffer[i*8+2]=0x00; 
    iobuffer[i*8+3]=0x00; 
    iobuffer[i*8+4]=0x00; 
    iobuffer[i*8+5]=0x00; 
    iobuffer[i*8+6]=0x00; 
    iobuffer[i*8+7]=0x00; 
	}  
	success=STISendUSBCommand(
                              hDevice,
                              GrandTech_Scanner_Vendor_USB_Send_Command,
                              iobuffer, 
		                      64,
		                      iobuffer,
		                      64,
		                      &nBytes);


  return success;
}


BOOL
ProcessCommandSetGTAFEGain(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   R_Offset,
        IN      UCHAR   R_Gain,
        IN      UCHAR   G_Offset,
        IN      UCHAR   G_Gain,
        IN      UCHAR   B_Offset,
        IN      UCHAR   B_Gain
        )
{
	BOOL success;

	if(R_Gain>31){
		R_Gain+=12;
	}else if(R_Gain>51){
		R_Gain=63;
	}

	if(G_Gain>31){
		G_Gain+=12;
	}else if(G_Gain>51){
		G_Gain=63;
	}

	if(B_Gain>31){
		B_Gain+=12;
	}else if(B_Gain>51){
		B_Gain=63;
	}

	success = ProcessCommandSetAFEGain(ShowMessagehWnd,
					       ShowMessageFlag,
					       ScannerHandle,
					       CommunicationProtocol,
					       R_Offset,
					       R_Gain,
					       G_Offset,
					       G_Gain,
					       B_Offset,
					       B_Gain);


    return success;
}

void calc_blackwhite(UCHAR *pwhite,
					 UCHAR *pblack,
					 USHORT CalibrateH,
					 USHORT *offset,
					 USHORT *__MaxBlack,
					 USHORT *__MaxWhite,
					 USHORT DeviceType,
					 USHORT calwidth,
					 USHORT realheight,
					 USHORT cDPI)
{
	USHORT segment;
	ULONG blackAcc=0;
	ULONG whiteAcc=0;
	ULONG blackcount=0;
	ULONG whitecount=0;
	ULONG AverageBlack;
	ULONG AverageWhite;
	ULONG HistoWhite[204]; 
	ULONG HistoBlack[204];
	ULONG MaxWhite=0;
	ULONG MinBlack=255;
    USHORT startblack=((10*calwidth)/MAXWIDTH);
	USHORT endblack=  ((20*calwidth)/MAXWIDTH);
	USHORT startwhite=(((MAXWIDTH*20/100)*calwidth)/MAXWIDTH);
	USHORT endwhite=  (((MAXWIDTH*80/100)*calwidth)/MAXWIDTH);
	USHORT CISstart=  0;
	USHORT CISend  =  calwidth;
    USHORT i,j;
	UCHAR *p;
    USHORT temp;
	
	if(cDPI >=300)
	{
		segment=50;
	}else if(cDPI >=75)
	{
        segment=25;
	}else 
	{
		segment=10;
	}
    startwhite=(startwhite/segment)*segment;
	endwhite=(endwhite/segment)*segment;
	CISstart=0;//(CISstart/50)*50;
	CISend=(CISend/segment)*segment;
	for(i=0;i<204;i++)
	{
      HistoWhite[i]=0; 
	  HistoBlack[i]=0; 
	}
	if(DeviceType==DT_CIS)
	{
    
/////  CIS  /////////////////////////////////////////////////////	
    	for(i=0;i<(realheight);i++)
		{
            p=pwhite+(i*MAXWIDTH);
            for(j=CISstart;j<CISend;j++)
			{
		      whiteAcc+=*(p+j);
		      whitecount++;
			  HistoWhite[(j/segment)]+=*(p+j);
			}
		}
		for(i=(CISstart/segment) ; i<(CISend/segment) ; i++)
		{
			HistoWhite[i]=(HistoWhite[i]/(segment*realheight));
		}
		for(i=(CISstart/segment) ; i<(CISend/segment) ; i++)
		{
            if(HistoWhite[i]>MaxWhite)
			{
				MaxWhite=HistoWhite[i];
			}
		}
	    for(i=0;i<(realheight);i++)
		{
            p=pblack+(i*MAXWIDTH);
            for(j=CISstart;j<CISend;j++)
			{
		       blackAcc+=*(p+j);
		       blackcount++;
			   HistoBlack[(j/segment)]+=*(p+j);
			}
		}
		for(i=(CISstart/segment) ; i<(CISend/segment) ; i++)
		{
			HistoBlack[i]=(HistoBlack[i]/(segment*realheight));
		}
		for(i=(CISstart/segment) ; i<(CISend/segment) ; i++)
		{
            if(HistoBlack[i]<MinBlack)
			{
				MinBlack=HistoBlack[i];
			}
		}
	}
////////// CCD ////////////////////////////////////////////////
	else
	{
		for(i=0;i<(realheight);i++)
		{
            p=pwhite+(i*calwidth);
            for(j=0;j<calwidth;j++)
			{
				if(j>=startblack && j<=endblack)
				{ 
					blackAcc+=*(p+j);
		            blackcount++;
				}
				if(j>=startwhite && j<=endwhite)
				{
		            whiteAcc+=*(p+j);
		            whitecount++;
					HistoWhite[(j/segment)]+=*(p+j);
				}
			}
		}
		for(i=(startwhite/segment) ; i<(endwhite/segment) ; i++)
		{
			HistoWhite[i]=(HistoWhite[i]/(segment*realheight));
		}
		for(i=(startwhite/segment) ; i<(endwhite/segment) ; i++)
		{
            if(HistoWhite[i]>MaxWhite)
			{
				MaxWhite=HistoWhite[i];
			}
		}



	}
//////////////////////////////////////////////////////////
	AverageBlack=blackAcc/blackcount;
    AverageWhite=whiteAcc/whitecount;
	
	if(DeviceType==DT_CIS)
	{
	   *__MaxBlack=(USHORT)MinBlack;
	   *__MaxWhite=(USHORT)MaxWhite; 
	   temp=(USHORT)(MinBlack+MaxWhite);
	}else
	{
       *__MaxBlack=(USHORT)AverageBlack;
	   *__MaxWhite=(USHORT)MaxWhite; 
	   temp=(USHORT)(AverageBlack+MaxWhite);
	}
    
	*offset=temp/2;
	return;
	
}


void sort(USHORT WhiteSort[],USHORT realh)
{
	int i,j;
	USHORT temp;

	for(i=0;i<realh;i++)
	{
		for(j=0;j<(realh-i);j++)
		{
           if(WhiteSort[j+1]<WhiteSort[j])
		   {
             temp=WhiteSort[j+1];
			 WhiteSort[j+1]=WhiteSort[j];
             WhiteSort[j]=temp;
		   }
		}
	}
}

void calc_shadding3(UCHAR *pimage,
				   UCHAR *pdarkimage,
				   USHORT realw,
				   USHORT realh,
				   PUCHAR *ShadeTbl,
				   USHORT DeviceType,
				   UCHAR  DarkValue)
{
	float myfactor=(float)(FACTOR/100.0);
	int    SortStart,SortEnd,SortTotal;
	int    darktotal;
	int    darkcount;
	USHORT i,j;
	USHORT whitebound=120;
	UCHAR  *pdata;
	USHORT temp3;
	float  tempblack;
	float  tempwhite;
	float  temp1;
//	float  temp2;
//	float  leftwhite,rightwhite;
	UCHAR *ptbl;
	UCHAR MaxWhite=0;
//	UCHAR MaxWhiteIndex;
	UCHAR MaxBlack=0;
//	UCHAR MaxBlackIndex;

	ULONG *pAverageBlack;
    ULONG *pAverageWhite;
	ULONG WhiteTotal;
	ULONG BlackTotal;

//	UCHAR WhiteHisto[300];
//	UCHAR BlackHisto[300];
	USHORT WhiteSort[100];
	USHORT DarkSort[100];
 
	pAverageBlack=(ULONG *)malloc(MAXWIDTH*4);
	pAverageWhite=(ULONG *)malloc(MAXWIDTH*4);

    SortStart=(realh*20)/100;
	SortEnd=(realh*80)/100;
	SortTotal=SortEnd-SortStart+1;
	for(i=0;i<realw;i++)
	{
      for(j=0;j<realh;j++)
	  {
		  pdata=pimage+i+(realw*j);
          temp3=*pdata;
		  WhiteSort[j]=temp3;
	  }
	  ////////////////////////
	//  if(i==300)
	  //{
		//  i=i;
	 // }
	  WhiteTotal=0;
	  sort(WhiteSort,realh);
	  //for(j=0;j<realh;j++)
	  for(j=SortStart;j<=SortEnd;j++)
	  {
        WhiteTotal+=WhiteSort[j];
	  }
        
	   
	  //////////////////////////////////////////
      *(pAverageWhite+i)=WhiteTotal/SortTotal; 
      //  *(pAverageWhite+i)=WhiteTotal/realh;
	  //*(pAverageWhite+i)=MaxWhiteIndex;

	}

    darktotal=0;
	darkcount=0;
	for(i=0;i<realw;i++)
	{
      darktotal=0;
	  darkcount=0; 
      for(j=0;j<realh;j++)
	  {
		  pdata=pdarkimage+i+(realw*j);
          temp3=*pdata;
		  darktotal+=temp3;
		  darkcount++;
		  DarkSort[j]=temp3;
	  }
	  ///////////////////////////////////
	  // if(i==300)
	 // {
	//	  i=i;
	  //}
	  BlackTotal=0;
//	  sort(DarkSort,realh);
	  for(j=SortStart;j<=SortEnd;j++)
	  //for(j=0;j<10;j++)
	  {
        BlackTotal+=DarkSort[j];
	  }
        
	  //////////////////////////////////////////
      //*(pAverageBlack+i)=BlackTotal/10;
	  //*(pAverageBlack+i)=BlackTotal/SortTotal;
      *(pAverageBlack+i)=darktotal/darkcount;
	  //*(pAverageBlack+i)=MaxBlackIndex;

	}
	

	//////////////////////////////////////////////////////////
    for(i=0;i<realw;i++)
	{
		//if(i==1180)
		//{
		//	i=i;
		//}
	//	if(DeviceType==DT_CCD)
	//	{
	//		tempblack=DarkValue;
	//	}else
		{
			//tempblack=darktotal/darkcount;
			tempblack=(float)*(pAverageBlack+i);
			//tempblack-=1;
			
		}
    
	
           tempwhite=(float)*(pAverageWhite+i);
	
       //tempblack=0;  
	   //tempwhite=255;	
		ptbl=ShadeTbl[i];
		for(j=0;j<256;j++)
		{
	   
			if((tempwhite - tempblack)==0)
			{
               temp1=j;
			}else
			{
     

               temp1=(float)j;
			   temp1=temp1-tempblack;
			   temp1*=255.0;
			   temp1=temp1/((tempwhite - tempblack)*myfactor);
			   //temp1+=5;
			   if(temp1<0) temp1=0;
			   if(temp1>255) temp1=255;
			   
			}
			*ptbl=(unsigned char)(temp1+0.5);
			ptbl++;

		}
		
		
	}
	
	free(pAverageBlack);
	free(pAverageWhite);

}


//----------------------------------------------------------------------------------
void calc_shadding4(UCHAR *pimage,
				    UCHAR *pdarkimage,
				    USHORT realw,
				    USHORT realh,
				    PUCHAR *ShadeTbl,
				    USHORT DeviceType,
				    UCHAR  DarkValue)
{
	float myfactor=(float)(FACTOR/100.0);
	int    SortStart,SortEnd,SortTotal;
	int    darktotal;
	int    darkcount;
	USHORT i,j;
	USHORT whitebound=120;
	UCHAR  *pdata;
	USHORT temp3;
	float  tempblack;
	float  tempwhite;
	float  temp1;
//	float  temp2;
//	float  leftwhite,rightwhite;
	UCHAR *ptbl;
	UCHAR MaxWhite=0;
//	UCHAR MaxWhiteIndex;
	UCHAR MaxBlack=0;
//	UCHAR MaxBlackIndex;

	ULONG *pAverageBlack;
    ULONG *pAverageWhite;
	ULONG WhiteTotal;
	ULONG BlackTotal;

//	UCHAR WhiteHisto[300];
//	UCHAR BlackHisto[300];
	USHORT WhiteSort[100];
	USHORT DarkSort[100];
 
	pAverageBlack=(ULONG *)malloc(MAXWIDTH*4);
	pAverageWhite=(ULONG *)malloc(MAXWIDTH*4);

    SortStart=(realh*20)/100;
	SortEnd=(realh*80)/100;
	SortTotal=SortEnd-SortStart+1;
	for(i=0;i<realw;i++)
	{
      for(j=0;j<realh;j++)
	  {
		  pdata=pimage+i+(realw*j);
          temp3=*pdata;
		  WhiteSort[j]=temp3;
	  }
	  ////////////////////////
	//  if(i==300)
	  //{
		//  i=i;
	 // }
	  WhiteTotal=0;
	  sort(WhiteSort,realh);
	  //for(j=0;j<realh;j++)
	  for(j=SortStart;j<=SortEnd;j++)
	  {
        WhiteTotal+=WhiteSort[j];
	  }
        
	   
	  //////////////////////////////////////////
      *(pAverageWhite+i)=WhiteTotal/SortTotal; 
      //  *(pAverageWhite+i)=WhiteTotal/realh;
	  //*(pAverageWhite+i)=MaxWhiteIndex;

	}

    darktotal=0;
	darkcount=0;
	for(i=0;i<realw;i++)
	{
      darktotal=0;
	  darkcount=0; 
      for(j=0;j<realh;j++)
	  {
		  pdata=pdarkimage+i+(realw*j);
          temp3=*pdata;
		  darktotal+=temp3;
		  darkcount++;
		  DarkSort[j]=temp3;
	  }
	  ///////////////////////////////////
	  // if(i==300)
	 // {
	//	  i=i;
	  //}
	  BlackTotal=0;
//	  sort(DarkSort,realh);
	  for(j=SortStart;j<=SortEnd;j++)
	  //for(j=0;j<10;j++)
	  {
        BlackTotal+=DarkSort[j];
	  }
        
	  //////////////////////////////////////////
      //*(pAverageBlack+i)=BlackTotal/10;
	  //*(pAverageBlack+i)=BlackTotal/SortTotal;
      *(pAverageBlack+i)=darktotal/darkcount;
	  //*(pAverageBlack+i)=MaxBlackIndex;

	}
	

	//////////////////////////////////////////////////////////
    for(i=0;i<realw;i++)
	{
		//if(i==1180)
		//{
		//	i=i;
		//}
		if(DeviceType==DT_CCD)
		{
			tempblack=DarkValue;
             // tempblack=0;
		}else 
		{
			//tempblack=darktotal/darkcount;
			tempblack=(float)*(pAverageBlack+i);
			//tempblack-=1;
			
		}
    
	
           tempwhite=(float)*(pAverageWhite+i);
	
       //tempblack=0;  
	   //tempwhite=255;	
		ptbl=ShadeTbl[i];
		for(j=0;j<256;j++)
		{
	   
			if((tempwhite - tempblack)==0)
			{
               temp1=j;
			}else
			{
     

               temp1=(float)j;
			   temp1=temp1-tempblack;
			   temp1*=255.0;
			   temp1=temp1/((tempwhite - tempblack)*myfactor);
			   //temp1+=5;
			   if(temp1<0) temp1=0;
			   if(temp1>255) temp1=255;
			   
			}
			*ptbl=(unsigned char)(temp1+0.5);
			ptbl++;

		}
		
		
	}
	
	free(pAverageBlack);
	free(pAverageWhite);

}


//----------------------------------------------------------------------------------

//----------------------------------------------------------------------------------

void  read_calibrate(HANDLE ScannerHandle,
					USHORT StartY,
					USHORT CalibrateH,
					USHORT DeviceType,
					UCHAR  *RBuffer,
					UCHAR  *GBuffer,
					UCHAR  *BBuffer,
				    UCHAR  R_Offset,
				    UCHAR  R_Gain,
				    UCHAR  G_Offset,
				    UCHAR  G_Gain,
				    UCHAR  B_Offset,
				    UCHAR  B_Gain,
				    USHORT XDPI,
				    USHORT YDPI,
				    USHORT *realw,
				    USHORT *realh,
				    USHORT StartX,
				    UCHAR  IsDark,
				    UCHAR  MotorMove,
					UCHAR  IsPixel,
					USHORT  CalWidth,
					UCHAR   HomeBeforeScan,
                    UCHAR   HomeAfterScan,
					USHORT  ScanType1
					)
{

	BOOL          success;
    DWORD         readsize;
	HWND          ShowMessagehWnd       =(HWND)NULL;
    ULONG         ShowMessageFlag       =FALSE;
    ULONG         CommunicationProtocol =GrandTech_Scanner_Vendor_USB_Send_Command;
	USHORT        Width;
    USHORT        Height;
	USHORT        SWWidth;
    USHORT        SWHeight;
	USHORT        ScanType              =ColorMode;
    USHORT	      DataWidth             =8;
    USHORT        ModeReserved1         =0;
    USHORT        TestMode              =TestModeDisable;
    USHORT        BufferSize            =BufferSize16K;
    USHORT        DataAttribute         =DA_Normal;
    USHORT        BusProtocol           =GrandTech_Scanner_Vendor_USB_Send_Command;
    USHORT        ModeReserved3         =0;
    UCHAR         StillAfterScan        =0;
    UCHAR         StillBeforeScan       =0;
    UCHAR         BackingIfBufFull      =0;
    UCHAR         MotorReserved         =0;
    UCHAR         LampOffOnScan         =IsDark;
    UCHAR         AutoBandwidth         =0;
    UCHAR         MiscReserved          =0;
    USHORT        MotorBackwardStepsIfBufferFull=0;

	UCHAR         LampOrder=LampOrder_RGB;
    UCHAR         LampStep =0;

    UCHAR         iobuffer[64]; 
	USHORT        *h_ImageWorkingBuffer;
	UCHAR         *TempBuffer2;
	UCHAR         *TempBuffer3;
	USHORT        i,j;
	USHORT        h_LineNumber;
	UCHAR         h_ColorNumber;
#ifdef WIN32
	DWORD         status;
	HANDLE        h_hEvents;
    OVERLAPPED    h_Overlapped;
	DWORD		  h_dwError;
#endif
    ULONG         nBytesRead; 
	USHORT        loopcount;
	

	UCHAR	*pRS,*pGS,*pBS;
	UCHAR   *pRT,*pBT,*pGT;

    StillAfterScan=HomeAfterScan;
    StillBeforeScan=HomeBeforeScan;
	mysuccess=TRUE;
    
	if(DeviceType == DT_CCD && IsPixel == TRUE)
	{
		MiscReserved=0x01;
		DataWidth=8;

	}else if(DeviceType == DT_CIS)
	{
		MiscReserved=0x00;
		LampOrder=LampOrder_BGR;
        
	}
	else if(DeviceType == DT_CCD)
	{
        MiscReserved=0x02;
		DataWidth=8;

	}
    
	
	pRT=RBuffer;
	pGT=GBuffer;
	pBT=BBuffer; 
    //--------------------------------

	h_ImageWorkingBuffer =(PUSHORT) malloc(64 * 1024 * 4);
    TempBuffer2 = (PUCHAR)malloc(MAXWIDTH);

	TempBuffer3 = (PUCHAR)malloc(MAXWIDTH*3);

	success = ProcessCommandRetrieveNecessaryInfo2(
		                   ShowMessagehWnd,
                           ShowMessageFlag,
                           ScannerHandle,
                           CommunicationProtocol,
                           LampOrder,
                           LampStep,
                           ScanType,
                           XMAXDPI,
                           XMAXDPI,
                           XDPI,
                           YDPI,
                           CalWidth,
                           CalibrateH,
                           &Width,
                           &Height,
                           &SWWidth,
                           &SWHeight,
  					(PVOID)h_ImageWorkingBuffer);

	    success = ProcessCommandSetScanWindow2( 
		              	ShowMessagehWnd,
                        ShowMessageFlag,
                        ScannerHandle,
                        CommunicationProtocol,
                        StartX,
                        StartY,
                        Width,
                        Height,
						XDPI,
                        SWWidth,
                        SWHeight,
                        ScanType,
                        DataWidth,
                        ModeReserved1,
                        TestMode,
                        BufferSize,
                        DataAttribute,
                        BusProtocol,
                        DeviceType,
                        ModeReserved3,
                        StillAfterScan,
                        StillBeforeScan,
                        MotorMove,
                        BackingIfBufFull,
                        MotorReserved,
						LampOffOnScan,
                        AutoBandwidth,
                        MiscReserved,
                        YDPI,
                        MotorBackwardStepsIfBufferFull);
        
       if(DeviceType==DT_CIS)
		{
			success=ProcessCommandSetExposureTime(
                         ShowMessagehWnd,
                         FALSE,
                         ScannerHandle,
                         GrandTech_Scanner_Vendor_USB_Send_Command,
                         gRedStart,
                         gRedStop,
                         gGreenStart,
                         gGreenStop,
                         gBlueStart,
                         gBlueStop);
		}


	    success = ProcessCommandSetGTAFEGain(
			               ShowMessagehWnd,
                           ShowMessageFlag,
                           ScannerHandle,
                           CommunicationProtocol,
					       R_Offset,
					       R_Gain,
					       G_Offset,
					       G_Gain,
					       B_Offset,
					       B_Gain);
        if(DeviceType==DT_CCD)
		{
			if(IsDark)
			{
				iobuffer[0]=0x00;
			}else
			{
				iobuffer[0]=0x03;
			}
			success=ProcessCommandMiscControl(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command,
                           0x25,
						   0x25,
						   (PVOID)iobuffer,
						   (PVOID)iobuffer);
		//	Sleep(100);
		}
#ifdef GT6816
	success=PollingMotor(ScannerHandle);
#endif		
	    success = ProcessCommandSetStartScan(ShowMessagehWnd,
						 FALSE,
						 ScannerHandle,
						 GrandTech_Scanner_Vendor_USB_Send_Command);
		//Sleep(300);

	    success = ProcessCommandWaitScannerReady(ShowMessagehWnd,
						     FALSE,
						     ScannerHandle,
						     GrandTech_Scanner_Vendor_USB_Send_Command,
						     1000);
	//	Sleep(100);
		if(success==FALSE)
		{
			//MessageBox(NULL,"wait fail","",MB_OK);
		}
		if(IsPixel)
		{
			loopcount=SWHeight;
		}else
		{
			loopcount=SWHeight*3;
		}
	    for	(i = 0;i < loopcount ;i++) 
		{

#ifdef WIN32
			 memset(&h_Overlapped,0,sizeof(h_Overlapped));
			 h_hEvents=CreateEvent(NULL,TRUE,FALSE,NULL); 
		     h_Overlapped.hEvent = h_hEvents;
	         h_Overlapped.Offset = 0;
#endif
			 if(IsPixel)
			 {
		
#ifdef WIN32              							
                 readsize=SWWidth*3; 
				 success=ReadFile(ScannerHandle,
			             TempBuffer3,
			             readsize, 
			             &h_dwError,
                         &h_Overlapped); 

#else
				 readsize=SWWidth*3; 
				 success= ProcessCommandReadImage(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
                            				DataWidth,
							SWWidth*3,
							TempBuffer3,
							SWWidth*3,
                          				&nBytesRead,
							(LPOVERLAPPED)NULL);
							
            
#endif 			
				 
			 }else
			 {

#ifdef WIN32
				 readsize=SWWidth;
				 success=ReadFile(ScannerHandle,
			              TempBuffer2,
			              readsize, 
			              &h_dwError,
                          &h_Overlapped);
#else
				 readsize=SWWidth;
                 success=ProcessCommandReadImage(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
                            DataWidth,
							SWWidth,
							TempBuffer2,
							SWWidth,
                            &nBytesRead,
							(LPOVERLAPPED)NULL);

#endif
                
			 }

#ifdef WIN32 
			 status=WaitForSingleObject(h_hEvents,12000);
			 success=GetOverlappedResult(ScannerHandle,&h_Overlapped,&nBytesRead,TRUE);
#endif
			 if(nBytesRead != readsize)
			 {
				 mysuccess=FALSE;
				 goto error1;
			 }else
			 {
				 mysuccess=TRUE;
			 }

			 success	= ProcessCommandGetLineAndColor(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
							i,
							h_ImageWorkingBuffer,
							&h_LineNumber,
							&h_ColorNumber);
			 if(!IsPixel)
			 {
				 switch(h_ColorNumber)
				 {
	                case 1:
					
						memcpy(BBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth);
						break;
                    case 2:
						memcpy(GBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth); 
						break;
					case 3:
						memcpy(RBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth);
						break;

				 }
			 }else
			 {
				 switch(LampOrder)
				 {
				   case LampOrder_RGB:
					   pRS=TempBuffer3;
					   pGS=TempBuffer3+1;
                       pBS=TempBuffer3+2;
					   break;
                   case LampOrder_BGR:
					   pBS=TempBuffer3;
					   pGS=TempBuffer3+1;
                       pRS=TempBuffer3+2;
					   break;
				 }
				 for(j=0;j<SWWidth;j++)
				 {
                   *pRT=*pRS;
				   *pGT=*pGS;
				   *pBT=*pBS;
				   pRT++;
				   pRS+=3;
				   pGT++;
				   pGS+=3;
				   pBT++;
				   pBS+=3;

				 }
			 }
        }

	    
#ifdef GT6816
		success=EndScan41(ScannerHandle);
#else
		Sleep(100);
		success = ProcessCommandSetEndScan(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command);

#endif
        if(DeviceType==DT_CCD)
		{
		  iobuffer[0]=0x03;
		
		  success=ProcessCommandMiscControl(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command,
                           0x25,
						   0x25,
						   (PVOID)iobuffer,
						   (PVOID)iobuffer);
		}
		
error1:
	    free(TempBuffer2);
		free(TempBuffer3);
	    free(h_ImageWorkingBuffer);

		*realw=SWWidth;
		*realh=SWHeight;
	
		return ;

}



/*
void  read_calibrate(HANDLE ScannerHandle,
					USHORT StartY,
					USHORT CalibrateH,
					USHORT DeviceType,
					UCHAR  *RBuffer,
					UCHAR  *GBuffer,
					UCHAR  *BBuffer,
				    UCHAR  R_Offset,
				    UCHAR  R_Gain,
				    UCHAR  G_Offset,
				    UCHAR  G_Gain,
				    UCHAR  B_Offset,
				    UCHAR  B_Gain,
				    USHORT XDPI,
				    USHORT YDPI,
				    USHORT *realw,
				    USHORT *realh,
				    USHORT StartX,
				    UCHAR  IsDark,
				    UCHAR  MotorMove,
					UCHAR  IsPixel,
					USHORT  CalWidth,
					UCHAR   HomeBeforeScan,
                    UCHAR   HomeAfterScan,
					USHORT  ScanType2
					)
{

	BOOL          success;
    DWORD         readsize;
	HWND          ShowMessagehWnd       =NULL;
    ULONG         ShowMessageFlag       =FALSE;
    ULONG         CommunicationProtocol =GrandTech_Scanner_Vendor_USB_Send_Command;
	USHORT        Width;
    USHORT        Height;
	USHORT        SWWidth;
    USHORT        SWHeight;
	USHORT        ScanType              =ColorMode;
    USHORT	      DataWidth             =8;
    USHORT        ModeReserved1         =0;
    USHORT        TestMode              =TestModeDisable;
    USHORT        BufferSize            =BufferSize16K;
    USHORT        DataAttribute         =DA_Normal;
    USHORT        BusProtocol           =GrandTech_Scanner_Vendor_USB_Send_Command;
    USHORT        ModeReserved3         =0;
    UCHAR         StillAfterScan        =0;
    UCHAR         StillBeforeScan       =0;
    UCHAR         BackingIfBufFull      =0;
    UCHAR         MotorReserved         =0;
    UCHAR         LampOffOnScan         =IsDark;
    UCHAR         AutoBandwidth         =0;
    UCHAR         MiscReserved          =0;
    USHORT        MotorBackwardStepsIfBufferFull=0;

	UCHAR         LampOrder=LampOrder_RGB;
    UCHAR         LampStep =0;

    UCHAR         iobuffer[64]; 
	USHORT        *h_ImageWorkingBuffer;
	UCHAR         *TempBuffer2;
	UCHAR         *TempBuffer3;
	USHORT        i,j;
	USHORT        h_LineNumber;
	UCHAR         h_ColorNumber;
#ifdef WIN32
	DWORD         status;
	HANDLE        h_hEvents;
    OVERLAPPED    h_Overlapped;
	DWORD		  h_dwError;
#endif
    DWORD         nBytesRead; 
	USHORT        loopcount;
	

	UCHAR	*pRS,*pGS,*pBS;
	UCHAR   *pRT,*pBT,*pGT;

    StillAfterScan=HomeAfterScan;
    StillBeforeScan=HomeBeforeScan;
	mysuccess=TRUE;

	//sprintf(DebugBuffer2,"IsPixel %d",IsPixel);
	//MessageBox(NULL,DebugBuffer2,"",MB_OK);
	//sprintf(DebugBuffer2,"ScanType %d",ScanType);
	//MessageBox(NULL,DebugBuffer2,"",MB_OK);

	if(DeviceType == DT_CCD && IsPixel == TRUE)
	{
		MiscReserved=0x01;
		DataWidth=8;

	}else if(DeviceType == DT_CIS)
	{
		MiscReserved=0x00;
		LampOrder=LampOrder_BGR;
        
	}
	else if(DeviceType == DT_CCD)
	{
        MiscReserved=0x02;
		DataWidth=8;

	}
    
	
	pRT=RBuffer;
	pGT=GBuffer;
	pBT=BBuffer; 
    //--------------------------------

	h_ImageWorkingBuffer =(PUSHORT) malloc(64 * 1024 * 4);
    TempBuffer2 = (PUCHAR)malloc(MAXWIDTH);

	TempBuffer3 = (PUCHAR)malloc(MAXWIDTH*3);

	success = ProcessCommandRetrieveNecessaryInfo2(
		                   ShowMessagehWnd,
                           ShowMessageFlag,
                           ScannerHandle,
                           CommunicationProtocol,
                           LampOrder,
                           LampStep,
                           ScanType,
                           XMAXDPI,
                           XMAXDPI,
                           XDPI,
                           YDPI,
                           CalWidth,
                           CalibrateH,
                           &Width,
                           &Height,
                           &SWWidth,
                           &SWHeight,
  						   h_ImageWorkingBuffer);

	    success = ProcessCommandSetScanWindow2( 
		              	ShowMessagehWnd,
                        ShowMessageFlag,
                        ScannerHandle,
                        CommunicationProtocol,
                        StartX,
                        StartY,
                        Width,
                        Height,
						XDPI,
                        SWWidth,
                        SWHeight,
                        ScanType,
                        DataWidth,
                        ModeReserved1,
                        TestMode,
                        BufferSize,
                        DataAttribute,
                        BusProtocol,
                        DeviceType,
                        ModeReserved3,
                        StillAfterScan,
                        StillBeforeScan,
                        MotorMove,
                        BackingIfBufFull,
                        MotorReserved,
						LampOffOnScan,
                        AutoBandwidth,
                        MiscReserved,
                        YDPI,
                        MotorBackwardStepsIfBufferFull);
        
       if(DeviceType==DT_CIS)
		{
			success=ProcessCommandSetExposureTime(
                         ShowMessagehWnd,
                         FALSE,
                         ScannerHandle,
                         GrandTech_Scanner_Vendor_USB_Send_Command,
                         gRedStart,
                         gRedStop,
                         gGreenStart,
                         gGreenStop,
                         gBlueStart,
                         gBlueStop);
		}


	    success = ProcessCommandSetGTAFEGain(
			               ShowMessagehWnd,
                           ShowMessageFlag,
                           ScannerHandle,
                           CommunicationProtocol,
					       R_Offset,
					       R_Gain,
					       G_Offset,
					       G_Gain,
					       B_Offset,
					       B_Gain);
        if(DeviceType==DT_CCD)
		{
			if(IsDark)
			{
				iobuffer[0]=0x00;
			}else
			{
				iobuffer[0]=0x03;
			}
			success=ProcessCommandMiscControl(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command,
                           0x25,
						   0x25,
						   iobuffer,
						   iobuffer);
		}
		
	    success = ProcessCommandSetStartScan(ShowMessagehWnd,
						 FALSE,
						 ScannerHandle,
						 GrandTech_Scanner_Vendor_USB_Send_Command);

	    success = ProcessCommandWaitScannerReady(NULL,
						     FALSE,
						     ScannerHandle,
						     GrandTech_Scanner_Vendor_USB_Send_Command,
						     1000);
		Sleep(100);
		if(success==FALSE)
		{
			//MessageBox(NULL,"wait fail","",MB_OK);
		}
		//if((IsPixel) || (ScanType==GreenMode))
		if((IsPixel))
		{
			loopcount=SWHeight;
		}else
		{
			loopcount=SWHeight*3;
		}

	    for	(i = 0;i < loopcount ;i++) 
		{

#ifdef WIN32
			 h_hEvents=CreateEvent(NULL,TRUE,FALSE,NULL); 
		     h_Overlapped.hEvent = h_hEvents;
	         h_Overlapped.Offset = 0;
#endif
			 if(IsPixel)
			 {
		
#ifdef WIN32              							
                 readsize=SWWidth*3; 
				 success=ReadFile(ScannerHandle,
			             TempBuffer3,
			             readsize, 
			             &h_dwError,
                         &h_Overlapped); 

#else
				 readsize=SWWidth*3; 
				 success= ProcessCommandReadImage(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
                            DataWidth,
							SWWidth*3,
							TempBuffer3,
							SWWidth*3,
                            &nBytesRead,
							NULL);
							
            
#endif 			
				 
			 }else
			 {

#ifdef WIN32
				 readsize=SWWidth;
				 success=ReadFile(ScannerHandle,
			              TempBuffer2,
			              readsize, 
			              &h_dwError,
                          &h_Overlapped);
#else
				 readsize=SWWidth;
                 success=ProcessCommandReadImage(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
                            DataWidth,
							SWWidth,
							TempBuffer2,
							SWWidth,
                            &nBytesRead,
							NULL);

#endif
                
			 }

#ifdef WIN32 
			 status=WaitForSingleObject(h_hEvents,12000);
			 success=GetOverlappedResult(ScannerHandle,&h_Overlapped,&nBytesRead,TRUE);
#endif
			 if(nBytesRead != readsize)
			 {
				 mysuccess=FALSE;
				 goto error1;
			 }else
			 {
				 mysuccess=TRUE;
			 }

			 success	= ProcessCommandGetLineAndColor(ShowMessagehWnd,
							FALSE,
							ScannerHandle,
							GrandTech_Scanner_Vendor_USB_Send_Command,
							i,
							h_ImageWorkingBuffer,
							&h_LineNumber,
							&h_ColorNumber);
			 if(!IsPixel)
			 {   
				 

				 //sprintf(DebugBuffer,"ScanType %d",ScanType);
				 //MessageBox(NULL,DebugBuffer,"",MB_OK);
				 //sprintf(DebugBuffer,"h_ColorNumber %d",h_ColorNumber);
				 //MessageBox(NULL,DebugBuffer,"",MB_OK);
				 //sprintf(DebugBuffer,"h_LineNumber %d",h_LineNumber);
				 //MessageBox(NULL,DebugBuffer,"",MB_OK);
       
				// if(ScanType==GreenMode)
				// {
                 //  memcpy(GBuffer+(i*SWWidth),TempBuffer2,SWWidth); 

				// }else
				// {
				   switch(h_ColorNumber)
				   {
	                case 1:
					
						memcpy(BBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth);
						break;
                    case 2:
						memcpy(GBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth); 
						break;
					case 3:
						memcpy(RBuffer+(h_LineNumber*SWWidth),TempBuffer2,SWWidth);
						break;

				   }
				// }
			 }else
			 {
				 switch(LampOrder)
				 {
				   case LampOrder_RGB:
					   pRS=TempBuffer3;
					   pGS=TempBuffer3+1;
                       pBS=TempBuffer3+2;
					   break;
                   case LampOrder_BGR:
					   pBS=TempBuffer3;
					   pGS=TempBuffer3+1;
                       pRS=TempBuffer3+2;
					   break;
				 }
				 for(j=0;j<SWWidth;j++)
				 {
                   *pRT=*pRS;
				   *pGT=*pGS;
				   *pBT=*pBS;
				   pRT++;
				   pRS+=3;
				   pGT++;
				   pGS+=3;
				   pBT++;
				   pBS+=3;

				 }
			 }
        }

	    
#ifdef OSLO
		success=EndScan41(ScannerHandle);
#else
		Sleep(100);
		success = ProcessCommandSetEndScan(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command);

#endif
        if(DeviceType==DT_CCD)
		{
		  iobuffer[0]=0x03;
		
		  success=ProcessCommandMiscControl(ShowMessagehWnd,
					       FALSE,
					       ScannerHandle,
					       GrandTech_Scanner_Vendor_USB_Send_Command,
                           0x25,
						   0x25,
						   iobuffer,
						   iobuffer);
		}
		
error1:
	    free(TempBuffer2);
		free(TempBuffer3);
	    free(h_ImageWorkingBuffer);

		*realw=SWWidth;
		*realh=SWHeight;
	
		return ;

}
*/
BOOL gtcalibrate(HANDLE ScannerHandle,
				USHORT StartY,
				USHORT CalibrateH,
				USHORT DeviceType,
			    UCHAR *R_Offset,
			    UCHAR *R_Gain,
			    UCHAR *G_Offset,
			    UCHAR *G_Gain,
			    UCHAR *B_Offset,
			    UCHAR *B_Gain,
			    UCHAR myOffsetInit,
			    UCHAR IsPixel,
			    USHORT CalDPI,
			    USHORT *leftbound,
				USHORT CalWidth,
				USHORT *_RedStop,
				USHORT *_GreenStop,
				USHORT *_BlueStop,
				USHORT ScanType )
{
	   
	    BOOL   SearchTmax=TRUE;
       
	    USHORT CISGAINSTEP=2;
        USHORT CISEXPSTEP=10;
		USHORT ExpDist;

	    UCHAR HomeBeforeScan=0;
        UCHAR HomeAfterScan=0;
		UCHAR MotorMove=0;
        BOOL  First=TRUE;
        UCHAR ROffset=32;
		UCHAR RGain;
		UCHAR GOffset=32;
		UCHAR GGain;
		UCHAR BOffset=32;
		UCHAR BGain;
		
		UCHAR iobuffer[64];

		USHORT realw;
		USHORT realh;
	    USHORT XDPI=CalDPI;
		USHORT YDPI=CalDPI;
		USHORT RAvg,GAvg,BAvg;
		USHORT Check1,Check2,Check3,Check4,Check;
		UCHAR  *pCheck;
		
        USHORT i;
		USHORT   gaindist;
		USHORT   offsetdist;
	    
		UCHAR *RBuffer;  // for white
		UCHAR *GBuffer;
		UCHAR *BBuffer;
		UCHAR *RBuffer2; // for black
		UCHAR *GBuffer2;
		UCHAR *BBuffer2;

		USHORT RMinBlack,GMinBlack,BMinBlack;
		USHORT RMaxWhite,GMaxWhite,BMaxWhite;
	//	USHORT RMinBlack2,GMinBlack2,BMinBlack2;
		//USHORT RMaxWhite2,GMaxWhite2,BMaxWhite2;

		USHORT RGAIN_INIT=6;
		USHORT BGAIN_INIT=6;
		USHORT GGAIN_INIT=6;
#ifdef WIN32
        char   iniSection[10]="GTK";
        char   iniFile[100]="gtk.ini";
#endif
		USHORT      LEVEL2DONE=0;
		BOOL        AdjExp=FALSE;

        USHORT	    L1_R_W_MAX=240;
        USHORT      L1_R_W_MIN=230;
        USHORT      L2_R_W_MAX=240;
        USHORT      L2_R_W_MIN=230;

        USHORT      L1_G_W_MAX=240;
        USHORT      L1_G_W_MIN=230;
        USHORT      L2_G_W_MAX=240;
        USHORT      L2_G_W_MIN=230;

        USHORT      L1_B_W_MAX=240;
        USHORT      L1_B_W_MIN=230;
        USHORT      L2_B_W_MAX=240;
        USHORT      L2_B_W_MIN=230;

        USHORT      L1_R_D_MAX=15;
        USHORT      L1_R_D_MIN=5;
        USHORT      L2_R_D_MAX=15;
        USHORT      L2_R_D_MIN=5;

        USHORT      L1_G_D_MAX=15;
        USHORT      L1_G_D_MIN=5;
        USHORT      L2_G_D_MAX=15;
        USHORT      L2_G_D_MIN=5;

        USHORT      L1_B_D_MAX=15;
        USHORT      L1_B_D_MIN=5;
        USHORT      L2_B_D_MAX=15;
        USHORT      L2_B_D_MIN=5;

		USHORT      LEFTBOUND=50;

	    USHORT      LEDSTOP=6000;
		USHORT      LEDBOUND=((6000-500)/16);

        USHORT      exposurecount=0;		
		USHORT	    DarkAvg;
		USHORT	    CISVSAT;
		USHORT      CISSat;
		USHORT      RedBound;
		USHORT      GreenBound;
		USHORT      BlueBound;

#ifdef	WIN32		
		HMODULE hModule;
#endif		
//#ifndef WIN32
//		StartY = 100;
//#endif
//---------------------------------------------------
		//GetCurrentDirectory(100,iniFile);
        //strcat(iniFile,"\\GTK.INI");
//---------------------------------------------------
#ifdef WIN32

#ifdef MUSINI

        hModule=GetModuleHandle(SPINAME);
		GetModuleFileName(hModule,iniFile,100);
		for(i=strlen(iniFile);i>0;i--){
			if(iniFile[i] == '\\'){
				iniFile[i]='\0';
				break;
			}
		}
		strcat(iniFile,GTINI);
#else
        strcpy(iniFile,"gtk.ini");
#endif
		CISGAINSTEP=GetPrivateProfileInt(iniSection,
							 "CISGAINSTEP",
							 2,
							 iniFile);
		CISEXPSTEP=GetPrivateProfileInt(iniSection,
							 "CISEXPSTEP",
							 10,
							 iniFile);
		RAWDATA=GetPrivateProfileInt(iniSection,
							 "RAWDATA",
							 0,
							 iniFile);
       
		FACTOR=GetPrivateProfileInt(iniSection,
							 "FACTOR",
							 100,
							 iniFile);

		LEFTBOUND=GetPrivateProfileInt(iniSection,
							 "LEFTBOUND",
							 50,
							 iniFile);
		StartY=GetPrivateProfileInt(iniSection,
							 "KSTARTY",
							 0,
							 iniFile);
		LEDSTOP=GetPrivateProfileInt(iniSection,
							 "LEDSTOP",
							 6000,
							 iniFile);

		AdjExp=GetPrivateProfileInt(iniSection,
							 "ADJEXPOSURE",
							 1,
							 iniFile);

		LEVEL2DONE=GetPrivateProfileInt(iniSection,
							 "LEVEL2DONE",
							 1,
							 iniFile);

		L1_R_W_MAX=GetPrivateProfileInt(iniSection,
							 "L1_R_W_MAX",
							 235,
							 iniFile);
		L1_R_W_MIN=GetPrivateProfileInt(iniSection,
							 "L1_R_W_MIN",
							 225,
							 iniFile);
		L2_R_W_MAX=GetPrivateProfileInt(iniSection,
							 "L2_R_W_MAX",
							 235,
							 iniFile);
		L2_R_W_MIN=GetPrivateProfileInt(iniSection,
							 "L2_R_W_MIN",
							 225,
							 iniFile);
///////////////////////////////////////////////////////////
		L1_G_W_MAX=GetPrivateProfileInt(iniSection,
							 "L1_G_W_MAX",
							 235,
							 iniFile);
		L1_G_W_MIN=GetPrivateProfileInt(iniSection,
							 "L1_G_W_MIN",
							 225,
							 iniFile);
		L2_G_W_MAX=GetPrivateProfileInt(iniSection,
							 "L2_G_W_MAX",
							 235,
							 iniFile);
		L2_G_W_MIN=GetPrivateProfileInt(iniSection,
							 "L2_G_W_MIN",
							 225,
							 iniFile);
//-------------------------------------------------------
    	L1_B_W_MAX=GetPrivateProfileInt(iniSection,
							 "L1_B_W_MAX",
							 235,
							 iniFile);
		L1_B_W_MIN=GetPrivateProfileInt(iniSection,
							 "L1_B_W_MIN",
							 225,
							 iniFile);
		L2_B_W_MAX=GetPrivateProfileInt(iniSection,
							 "L2_B_W_MAX",
							 235,
							 iniFile);
		L2_B_W_MIN=GetPrivateProfileInt(iniSection,
							 "L2_B_W_MIN",
							 225,
							 iniFile);
//----------------------------------------------------
//----------------------------------------------------
		L1_R_D_MAX=GetPrivateProfileInt(iniSection,
							 "L1_R_D_MAX",
							 25,
							 iniFile);
		L1_R_D_MIN=GetPrivateProfileInt(iniSection,
							 "L1_R_D_MIN",
							 15,
							 iniFile);
		L2_R_D_MAX=GetPrivateProfileInt(iniSection,
							 "L2_R_D_MAX",
							 25,
							 iniFile);
		L2_R_D_MIN=GetPrivateProfileInt(iniSection,
							 "L2_R_D_MIN",
							 15,
							 iniFile);
///////////////////////////////////////////////////////////
		L1_G_D_MAX=GetPrivateProfileInt(iniSection,
							 "L1_G_D_MAX",
							 25,
							 iniFile);
		L1_G_D_MIN=GetPrivateProfileInt(iniSection,
							 "L1_G_D_MIN",
							 15,
							 iniFile);
		L2_G_D_MAX=GetPrivateProfileInt(iniSection,
							 "L2_G_D_MAX",
							 25,
							 iniFile);
		L2_G_D_MIN=GetPrivateProfileInt(iniSection,
							 "L2_G_D_MIN",
							 15,
							 iniFile);
//-------------------------------------------------------
    	L1_B_D_MAX=GetPrivateProfileInt(iniSection,
							 "L1_B_D_MAX",
							 25,
							 iniFile);
		L1_B_D_MIN=GetPrivateProfileInt(iniSection,
							 "L1_B_D_MIN",
							 15,
							 iniFile);
		L2_B_D_MAX=GetPrivateProfileInt(iniSection,
							 "L2_B_D_MAX",
							 25,
							 iniFile);
		L2_B_D_MIN=GetPrivateProfileInt(iniSection,
							 "L2_B_D_MIN",
							 15,
							 iniFile);
		RGAIN_INIT=GetPrivateProfileInt(iniSection,
							 "RGAIN_INIT",
							 2,
							 iniFile);
		GGAIN_INIT=GetPrivateProfileInt(iniSection,
							 "GGAIN_INIT",
							 2,
							 iniFile);
		BGAIN_INIT=GetPrivateProfileInt(iniSection,
							 "BGAIN_INIT",
							 2,
							 iniFile);
		CISVSAT=GetPrivateProfileInt(iniSection,
							 "CISVSAT",
							 15,
							 iniFile);


#endif
//----------------------------------------------------
#ifdef MAC
	char iniSection[128];
	CProfile* m_pProfile;
	bool successtest;
	//FILE * myfile;
	//myfile=fopen("MTWM.ini","r");
	m_pProfile=new CProfile();
	//successtest=m_pProfile->\ofile("GTps2.ini");
		successtest=m_pProfile->LoadProfile(GTINI);//("gtsb.ini");
	m_pProfile->GetProfileString("GTK","iniSection","GTK",iniSection,128);
	RGAIN_INIT=m_pProfile->GetProfileInt(iniSection,"RGAIN_INIT",4);
	GGAIN_INIT=m_pProfile->GetProfileInt(iniSection,"GGAIN_INIT",4);
	BGAIN_INIT=m_pProfile->GetProfileInt(iniSection,"BGAIN_INIT",4);
	CISGAINSTEP=m_pProfile->GetProfileInt(iniSection,"CISGAINSTEP",2);
	LEDSTOP=m_pProfile->GetProfileInt(iniSection,"LEDSTOP",6000);
#endif
#ifdef LINUX
#ifdef PS2
	RGAIN_INIT=12;
	GGAIN_INIT=12;
	BGAIN_INIT=12;
#endif
#ifdef PS1
	RGAIN_INIT=6;
	GGAIN_INIT=6;
	BGAIN_INIT=6;
#endif
	CISGAINSTEP=2;
#endif	
	LEDBOUND=((LEDSTOP-500)/16);
        // led full turn on
	gRedStart=4;
        gRedStop=LEDBOUND;
        gGreenStart=4;
        gGreenStop=LEDBOUND;
        gBlueStart=4;
        gBlueStop=LEDBOUND;
//----------------------------------------------------
        
				
		
			ROffset=32;
		    GOffset=32;
		    BOffset=32;
		
		RBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		GBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		BBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);

		RBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		GBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		BBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
//-------------------------------------------------------------------------------------------------
//CIS DARK BEGIN
CISDARKBEGIN:
        offsetdist=(64)/2; 	
		ROffset=32;
		GOffset=32;
		BOffset=32;
		RGain=(UCHAR)RGAIN_INIT;
		GGain=(UCHAR)GGAIN_INIT;
        BGain=(UCHAR)BGAIN_INIT;
       
//----------------offset begin----------------------------------------------------------------------		
		   
		   for(i=0;i<6;i++)
		   {
		   	long starttick;
		   	long endtick;
			   offsetdist=(offsetdist)/2;
			   if(First)
			   {
                 HomeBeforeScan=0;
                 HomeAfterScan=1;
				 MotorMove=0;
				 
			     
			   }else
			   {
                 HomeBeforeScan=1;
                 HomeAfterScan=1; 
				 MotorMove=1;

			   }
			   starttick = GetTickCount();
			   read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
			 
			   if(!mysuccess)
			   {
				   goto haveerror;
			   }
			   if(First)
			   {
                 HomeBeforeScan=1;
                 HomeAfterScan=1;
				 MotorMove=1;
				 First=FALSE;
			     
			   }
			   if(DeviceType==DT_CIS)
			   {
			   read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer2,GBuffer2,BBuffer2,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  1,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
			   if(!mysuccess)
			   {
				   goto haveerror;
			   }
			   }
			   endtick = GetTickCount();
			   //printf("start = %ld, end = %ld.\n",starttick,endtick);

		      	   
              calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
              calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
              calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);

			 // sprintf(DebugBuffer2,"GMinBlack %d",GMinBlack);
			 // MessageBox(NULL,DebugBuffer2,"",MB_OK);
			 // sprintf(DebugBuffer2,"GMaxWhite %d",GMaxWhite);
			 // MessageBox(NULL,DebugBuffer2,"",MB_OK);
			 // sprintf(DebugBuffer2,"GOffset %d",GOffset);
			 // MessageBox(NULL,DebugBuffer2,"",MB_OK);
			  if(DeviceType==DT_CCD)
			  {
////////////////////////////////////////////////////////////                 
			     if(RAvg<124)
				 {
                     ROffset+=offsetdist;
				 }else if(RAvg<132)
				 {
                //nothing
				 }else
				 {
                     ROffset-=offsetdist; 
				 }
				 ///////////////////////////
				 if(GAvg<124)
				 {
                     GOffset+=offsetdist;
				 }else if(GAvg<132)
				 {
                //nothing
				 }else
				 {
                     GOffset-=offsetdist; 
				 }
				 //////////////////////////////
				 if(BAvg<124)
				 {
                     BOffset+=offsetdist;
				 }else if(BAvg<132)
				 {
                //nothing
				 }else
				 {
                     BOffset-=offsetdist; 
				 }
			  }else
			  {
				  if((RMinBlack<L1_R_D_MIN) )
				  {
                     ROffset+=offsetdist; 
				 }else if((RMinBlack<L1_R_D_MAX) )
				 {
                //nothing
				 }else
				 {
                     ROffset-=offsetdist;
				 }
		        //------------------
		        if((GMinBlack<L1_G_D_MIN) )
				 {
                     GOffset+=offsetdist; 
				 }else if((GMinBlack<L1_G_D_MAX) )
				 {
                //nothing
				 }else
				 {
                     GOffset-=offsetdist; 
				 }
		        //------------------
		       if((BMinBlack<L1_B_D_MIN) )
				 {
                     BOffset+=offsetdist; 
				 }else if((BMinBlack<L1_B_D_MAX) )
				 {
                //nothing
				 }else
				 {
                     BOffset-=offsetdist;  
				 }
		        //------------------

			  }
			  
			 
			  
		   }
		   
//---------------------------------------------------------------------------------------------------
         
//------------------offset end--------------------------------------------------------------------
//------------------gain begin------------------------------------  

if(DeviceType==DT_CCD)
{
           RGain=24;
		   GGain=24;
		   BGain=24;
		   gaindist=(48+1)/2;

		   for(i=0;i<6;i++)
		   {
             gaindist=(gaindist+1)/2;
			 if(gaindist<1) gaindist=1;
             read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
				if(!mysuccess)
			   {
				   goto haveerror;
			   }
			 
            calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
            calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
            calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);
            
			
		         if((RMaxWhite<L1_R_W_MIN) )
				 {
                     RGain+=gaindist;
				 }else if((RMaxWhite<L1_R_W_MAX) )
				 {
                //nothing
				 }else
				 {
                     RGain-=gaindist; 
				 }
		        //------------------
		        if((GMaxWhite<L1_G_W_MIN) )
				{
                     GGain+=gaindist;
				}else if((GMaxWhite<L1_G_W_MAX) )
				{
                    //nothing
				}else
				{
                     GGain-=gaindist; 
				}
          		    //------------------
		       if((BMaxWhite<L1_B_W_MIN) )
			   {
                     BGain+=gaindist;
			   }else if((BMaxWhite<L1_B_W_MAX) )
			   {
                   //nothing
			   }else
			   {
                     BGain-=gaindist; 
			   } 
			
			
		         //------------------
			
		   }  // end for
//---------------------gain 1 end----------------------------------
//---------------------gain 2 begin------------------------------------  
         if(LEVEL2DONE)
		 {
		   gaindist=(12+1)/2;
           if(abs((float)(RAvg-128)) >6)
		   {
			   if(RAvg>128)
			   {
                  ROffset--;
			   }else
			   {
                  ROffset++;
			   }
		   }
		   if(abs((float)(GAvg-128)) >6)
		   {
			   if(GAvg>128)
			   {
                  GOffset--;
			   }else
			   {
                  GOffset++;
			   }
		   }
		   if(abs((float)(BAvg-128)) >6)
		   {
			   if(BAvg>128)
			   {
                  BOffset--;
			   }else
			   {
                  BOffset++;
			   }
		   }


		   for(i=0;i<5;i++)
		   {
             gaindist=(gaindist+1)/2;
			 if(gaindist<1) gaindist=1;
             read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
			 if(!mysuccess)
			   {
				   goto haveerror;
			   }
			 
            calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
            calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
            calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);

		    
			
		         if((RMaxWhite<L2_R_W_MIN) )
				 {
                     RGain+=gaindist;
				 }else if((RMaxWhite<L2_R_W_MAX) )
				 {
                //nothing
				 }else
				 {
                     RGain-=gaindist; 
				 }
		        //------------------
		        if((GMaxWhite<L2_G_W_MIN) )
				{
                     GGain+=gaindist;
				}else if((GMaxWhite<L2_G_W_MAX) )
				{
                    //nothing
				}else
				{
                     GGain-=gaindist; 
				}
          		    //------------------
		       if((BMaxWhite<L2_B_W_MIN) )
			   {
                     BGain+=gaindist;
			   }else if((BMaxWhite<L2_B_W_MAX) )
			   {
                   //nothing
			   }else
			   {
                     BGain-=gaindist; 
			   } 
		
		
			
		 }  // end for
		}
}  // end if(DeviceType==DT_CCD)
//---------------------gain end----------------------------------


//--------------------exposure time begin------------------------
if(DeviceType==DT_CIS)
{
//#ifdef PS2
	 SearchTmax=FALSE;
//#endif
	 if(SearchTmax)
	 {
		// CISSat=CISVSAT*255/2/10;
		 CISSat=180;
		 if(CISSat>240)
		 {
			 CISSat=240;
		 }
	     gRedStop/=2;
         gGreenStop/=2;
	     gBlueStop/=2;
         ExpDist=gRedStop; 
		 while((RMaxWhite>(CISSat+10) || RMaxWhite<(CISSat)) ||
			   (GMaxWhite>(CISSat+10) || GMaxWhite<(CISSat)) ||
			   (BMaxWhite>(CISSat+10) || BMaxWhite<(CISSat))
			 )
		{
				read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  2,//RGain,
						  GOffset,
		                  2,//GGain,
						  BOffset,
		                  2,//BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
		if(!mysuccess)
		{
				   goto haveerror;
		}
		
		  calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
          calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
          calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);

		  ExpDist/=2;
		  if(ExpDist<5)
		  {
			  break;
		  }

			if(RMaxWhite>(CISSat+10))
			{
               gRedStop-=ExpDist;
			}else if(RMaxWhite<CISSat)
			{
                gRedStop+=ExpDist;
			}else
			{
				// nothing
			}
            //////////////////////////////////
			if(GMaxWhite>(CISSat+10))
			{
               gGreenStop-=ExpDist;
			}else if(GMaxWhite<CISSat)
			{
                gGreenStop+=ExpDist;
			}else
			{
				// nothing
			}
            ///////////////////////////////////
			if(BMaxWhite>(CISSat+10))
			{
               gBlueStop-=ExpDist;
			}else if(BMaxWhite<CISSat)
			{
                gBlueStop+=ExpDist;
			}else
			{
				// nothing
			}
			

		  //exposurecount++;
		  //if(exposurecount>10)
		  //{
		   // 	break;
		 // }

		}
         RedBound=gRedStop;
		 GreenBound=gGreenStop;
		 BlueBound=gBlueStop;

		 SearchTmax=FALSE;
	 }
//----------------------------------------------------------------


	  		
		read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
		if(!mysuccess)
		{
				   goto haveerror;
		}
		
		
   
        calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
        calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
        calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);
        
		if(!(RMaxWhite>240 && GMaxWhite>240 && BMaxWhite>240))
		{
			if(RMaxWhite<240)
			{
				RGAIN_INIT+=CISGAINSTEP;
			}
			if(GMaxWhite<240)
			{
				GGAIN_INIT+=CISGAINSTEP;
			}
			if(BMaxWhite<240)
			{
				BGAIN_INIT+=CISGAINSTEP;
			}
			if((BGAIN_INIT>20) || (GGAIN_INIT>20) || (BGAIN_INIT>20))
			{
				
			}else
			{
			    goto CISDARKBEGIN;
			}
		}
//////////////////////////////////////////////////////////////

		gRedStop/=2;
        gGreenStop/=2;
		gBlueStop/=2;
        ExpDist=gRedStop; 

        while( (RMaxWhite>L1_R_W_MAX || RMaxWhite<L1_R_W_MIN) ||
			   (GMaxWhite>L1_G_W_MAX || GMaxWhite<L1_G_W_MIN) ||
			   (BMaxWhite>L1_B_W_MAX || BMaxWhite<L1_B_W_MIN)
			 )
		{
				read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XDPI,
						  YDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );
		if(!mysuccess)
		{
				   goto haveerror;
		}
		
		  calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,CalDPI);
          calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,CalDPI);
          calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,CalDPI);

		  ExpDist/=2;
		  if(ExpDist<5)
		  {
			  break;
		  }

			if(RMaxWhite>L1_R_W_MAX)
			{
               gRedStop-=ExpDist;
			}else if(RMaxWhite<L1_R_W_MIN)
			{
                gRedStop+=ExpDist;
			}else
			{
				// nothing
			}
            //////////////////////////////////
			if(GMaxWhite>L1_G_W_MAX)
			{
               gGreenStop-=ExpDist;
			}else if(GMaxWhite<L1_G_W_MIN)
			{
                gGreenStop+=ExpDist;
			}else
			{
				// nothing
			}
            ///////////////////////////////////
			if(BMaxWhite>L1_B_W_MAX)
			{
               gBlueStop-=ExpDist;
			}else if(BMaxWhite<L1_B_W_MIN)
			{
                gBlueStop+=ExpDist;
			}else
			{
				// nothing
			}
			

		  //exposurecount++;
		  //if(exposurecount>10)
		  //{
		   // 	break;
		 // }

		}
        
        
}
//--------------------exposure end-------------------------------
//---------------------search left--------------------------------
          read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  600,
						  600,
						  &realw,
						  &realh,
						  0,
						  0,
						  MotorMove,
						  (UCHAR)IsPixel,
						  CalWidth,
						  HomeBeforeScan,
                          HomeAfterScan,
						  ScanType
						  );

          
		  if(DeviceType==DT_CCD)
			{
		      for(i=(realw/8);i>0;i--)
			  {
                pCheck=RBuffer+i;
			    Check1=*pCheck;
			    Check2=*(pCheck-1);
			    Check3=*(pCheck-2);
			    Check4=*(pCheck-3);
			    Check=(Check1+Check2+Check3+Check4)/4;
                if(Check<LEFTBOUND)
				{
                 *leftbound=i;
                  break;
				}
			  }
		      if(*leftbound==0)
			  {
				for(i=(realw/8);i>0;i--)
				{
				   pCheck=GBuffer+i;
				   Check1=*pCheck;
				   Check2=*(pCheck-1);
				   Check3=*(pCheck-2);
				   Check4=*(pCheck-3);
				   Check=(Check1+Check2+Check3+Check4)/4;
				   if(Check<LEFTBOUND)
				   {
					 *leftbound=i;
					 break;
				   }
				}
			  }
		      if(*leftbound==0)
			  {
		        for(i=(realw/8);i>0;i--)
				{
                  pCheck=BBuffer+i;
			      Check1=*pCheck;
			      Check2=*(pCheck-1);
			      Check3=*(pCheck-2);
			      Check4=*(pCheck-3);
			      Check=(Check1+Check2+Check3+Check4)/4;
                  if(Check<LEFTBOUND)
				  {
                    *leftbound=i;
                    break;
				  }
				}
			  }
			}
//-----------search left end---------------------
		  if(DeviceType==DT_CCD)
		  {
			  DarkAvg =0;
			  for(i=1;i<6;i++)
				DarkAvg += (USHORT)(*(RBuffer+i));
			  RDark = (UCHAR)(DarkAvg/5);
			  DarkAvg =0;
			  for(i=1;i<6;i++)
				DarkAvg += (USHORT)(*(GBuffer+i));
			  GDark = (UCHAR)(DarkAvg/5);
			  DarkAvg =0;
			  for(i=1;i<6;i++)
				DarkAvg += (USHORT)(*(BBuffer+i));
			  BDark = (UCHAR)(DarkAvg/5);
		  }
//-----------search Drak Value end---------------------
		   if(ROffset<1)  ROffset=1;
		   if(ROffset>63) ROffset=63;
		   if(GOffset<1)  GOffset=1;
		   if(GOffset>63) GOffset=63;
		   if(BOffset<1)  BOffset=1;
		   if(BOffset>63) BOffset=63;

		   if(RGain<1)    RGain=1;
		   if(RGain>63)   RGain=63;
		   if(GGain<1)    GGain=1;
		   if(GGain>63)   GGain=63;
		   if(BGain<1)    BGain=1;
		   if(BGain>63)   BGain=63;
		   

		   *R_Offset=ROffset;
		   *R_Gain=RGain;
		   *G_Offset=GOffset;
		   *G_Gain=GGain;
		   *B_Offset=BOffset;
		   *B_Gain=BGain;
#ifdef WIN32
		   WritePrivateProfileString(iniSection,
							         "RGAIN",
							         itoa(RGain,(char *)iobuffer,10),
						        	 iniFile);
           WritePrivateProfileString(iniSection,
							         "ROFFSET",
							         itoa(ROffset,(char *)iobuffer,10),
						        	 iniFile);
		   
		    WritePrivateProfileString(iniSection,
							         "GGAIN",
							         itoa(GGain,(char *)iobuffer,10),
						        	 iniFile);
		   WritePrivateProfileString(iniSection,
							         "GOFFSET",
							         itoa(GOffset,(char *)iobuffer,10),
						        	 iniFile);
		  
		   WritePrivateProfileString(iniSection,
							         "BGAIN",
							         itoa(BGain,(char *)iobuffer,10),
						        	 iniFile);
		   WritePrivateProfileString(iniSection,
							         "BOFFSET",
							         itoa(BOffset,(char *)iobuffer,10),
						        	 iniFile);
		   WritePrivateProfileString(iniSection,
							         "REDTIME",
							         itoa(gRedStop,(char *)iobuffer,10),
						        	 iniFile);
		   WritePrivateProfileString(iniSection,
							         "GREENTIME",
							         itoa(gGreenStop,(char *)iobuffer,10),
						        	 iniFile);
		   WritePrivateProfileString(iniSection,
							         "BLUETIME",
							         itoa(gBlueStop,(char *)iobuffer,10),
						        	 iniFile);
#endif		   

#ifdef MAC
	char iniSection1[128];
	CProfile* m_pProfile1;
	bool success1;
	FILE * myfile;
	//myfile=fopen("MTWM.ini","r");
	m_pProfile1=new CProfile();
	success1=m_pProfile1->LoadProfile(GTINI);//success1=m_pProfile1->LoadProfile("gtsb.ini");
	m_pProfile1->GetProfileString("GTK","iniSection","GTK",iniSection1,128);
	m_pProfile1->WriteProfileInt(iniSection1,"RGAIN",RGain);
	m_pProfile1->WriteProfileInt(iniSection1,"ROFFSET",ROffset);
	m_pProfile1->WriteProfileInt(iniSection1,"GGAIN",GGain);
	m_pProfile1->WriteProfileInt(iniSection1,"GOFFSET",GOffset);
	m_pProfile1->WriteProfileInt(iniSection1,"BGAIN",BGain);
	m_pProfile1->WriteProfileInt(iniSection1,"BOFFSET",BOffset);
	m_pProfile1->WriteProfileInt(iniSection1,"REDTIME",gRedStop);
	m_pProfile1->WriteProfileInt(iniSection1,"GREENTIME",gGreenStop);
	m_pProfile1->WriteProfileInt(iniSection1,"BLUETIME",gBlueStop);
	m_pProfile1->SaveProfile(GTINI);//("gtsb.ini");

#endif	
				    
haveerror:            
    	free(RBuffer);
	    free(GBuffer);
	    free(BBuffer);
		free(RBuffer2);
	    free(GBuffer2);
	    free(BBuffer2);

    	*_RedStop=gRedStop;
	*_GreenStop=gGreenStop;
	*_BlueStop =gBlueStop;

    return mysuccess;
}



BOOL CreateShaddingTable(HANDLE ScannerHandle,
						USHORT StartY,
						USHORT CalibrateH,
						USHORT DeviceType,
						UCHAR  R_Offset,
				        UCHAR  R_Gain,
				        UCHAR  G_Offset,
				        UCHAR  G_Gain,
				        UCHAR  B_Offset,
				        UCHAR  B_Gain,
				        PUCHAR *RShadding,
				        PUCHAR *GShadding,
				        PUCHAR *BShadding,
				        USHORT XDPI,
				        USHORT YDPI,
				        USHORT StartX,
				        UCHAR  IsPixel,
						USHORT CalWidth,
						USHORT ScanType
				   )
{
	   // USHORT ScanType=ColorMode;       
		USHORT realh;
		USHORT realw;
	//	UCHAR iobuffer[64];
	    
		UCHAR *RBuffer;
		UCHAR *GBuffer;
		UCHAR *BBuffer;

		UCHAR *RBuffer2;
		UCHAR *GBuffer2;
		UCHAR *BBuffer2;
	//	BOOL  success; 
//////////////////////////////////
      //  int begintime,endtime,totaltime;
      //  char outbuf[50];       

//		BOOL  mysuccess;  
        
//		UCHAR iobuffer[64]; 
//        begintime=GetTickCount();
		RBuffer=(UCHAR *)malloc(MAXWIDTH*40);
		GBuffer=(UCHAR *)malloc(MAXWIDTH*40);
		BBuffer=(UCHAR *)malloc(MAXWIDTH*40);

		RBuffer2=(UCHAR *)malloc(MAXWIDTH*40);
		GBuffer2=(UCHAR *)malloc(MAXWIDTH*40);
		BBuffer2=(UCHAR *)malloc(MAXWIDTH*40);



	    
if(RBuffer==NULL ||	GBuffer==NULL ||BBuffer==NULL 
	 || RBuffer2==NULL ||	GBuffer2==NULL ||BBuffer2==NULL )
		return FALSE;	    
		//if(DeviceType==DT_CIS)
		{

		     read_calibrate(ScannerHandle,
				           StartY,
						   CalibrateH,
						   DeviceType,
						   RBuffer,
						   GBuffer,
						   BBuffer,
						   R_Offset,
						   R_Gain,
						   G_Offset,
						   G_Gain,
						   B_Offset,
						   B_Gain,
						   XDPI,
						   YDPI,
						   //XMAXDPI,
						   &realw,
						   &realh,
						   StartX,
						   0,
						   0,
						   (UCHAR)IsPixel,
						   CalWidth,
						   0, //1
						   1,
						   ScanType);  //1
			

		}
        if(!mysuccess)
		{
            goto shadeerror;
		}		
#ifndef OSLO
		    	read_calibrate(ScannerHandle,
			           StartY,
					   CalibrateH,
					   DeviceType,
					   RBuffer2,
					   GBuffer2,
					   BBuffer2,
			           R_Offset,
		               R_Gain,
					   G_Offset,
		               G_Gain,
					   B_Offset,
		               B_Gain,
					   XDPI,
					   YDPI,
					   //XMAXDPI,
					   &realw,
					   &realh,
					   StartX,
					   1,
					   0,
					   (UCHAR)IsPixel,
					   CalWidth,
					   1,
					   0,
					   ScanType);  //1 

				      
#endif
		   
			if(!mysuccess)
			{
               goto shadeerror;
			}
#ifndef OSLO
			if(!RAWDATA)
			{
               calc_shadding3(RBuffer,RBuffer2,realw,realh,RShadding,DeviceType,RDark);
               calc_shadding3(GBuffer,GBuffer2,realw,realh,GShadding,DeviceType,GDark);
	           calc_shadding3(BBuffer,BBuffer2,realw,realh,BShadding,DeviceType,BDark);
			}
#else        
			if(!RAWDATA)
			{
               calc_shadding4(RBuffer,RBuffer2,realw,realh,RShadding,DeviceType,RDark);
               calc_shadding4(GBuffer,GBuffer2,realw,realh,GShadding,DeviceType,GDark);
	           calc_shadding4(BBuffer,BBuffer2,realw,realh,BShadding,DeviceType,BDark);
			}

#endif
//        endtime=GetTickCount();
		//totaltime=endtime-begintime;
		//sprintf(outbuf,"\ntotaltime %d\n",totaltime);
		//OutputDebugString(outbuf);

	//	if(DeviceType==DT_CCD)
	//	   {
      //     
		//   iobuffer[0]=0x03;
		  // success=ProcessCommandMiscControl(NULL,
			//		       FALSE,
			//		       ScannerHandle,
			//		       GrandTech_Scanner_Vendor_USB_Send_Command,
              //             0x25,
				//		   0x25,
				//		   iobuffer,
				//		   iobuffer);
		  // }
           
	  
shadeerror:
         
    	free(RBuffer);
	    free(GBuffer);
	    free(BBuffer); 
		free(RBuffer2);
        free(GBuffer2);
	    free(BBuffer2); 
    return mysuccess;

}


int CreateGainOffsetTable(HANDLE ScannerHandle,
						  USHORT StartY,
						  USHORT CalibrateH,
						  USHORT DeviceType,
				          UCHAR  IsPixel,
						  UCHAR  OffsetStart,
						  UCHAR  OffsetEnd,
					      UCHAR  GainStart,
						  UCHAR  GainEnd)
{
	    UCHAR ROffset;
		UCHAR RGain;
		UCHAR GOffset;
		UCHAR GGain;
		UCHAR BOffset;
		UCHAR BGain;

		USHORT  RGainTbl[2][64];
		USHORT  GGainTbl[2][64];
		USHORT  BGainTbl[2][64];

		USHORT  realw,realh;
		
        USHORT i,j;
		

		USHORT RAvg;
		USHORT GAvg;
		USHORT BAvg;
	    
		UCHAR *RBuffer;
		UCHAR *GBuffer;
		UCHAR *BBuffer;

		UCHAR *RBuffer2;
		UCHAR *GBuffer2;
		UCHAR *BBuffer2;

		char filename[20];

		USHORT RMinBlack,GMinBlack,BMinBlack;
		USHORT RMaxWhite,GMaxWhite,BMaxWhite;
	    FILE *stream;
		char OutBuf[65];
		sprintf(filename,"c:\\tbl.txt",ROffset);
		stream=fopen(filename, "w+" );

		

		RBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		GBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		BBuffer=(UCHAR *)malloc(MAXWIDTH*CalibrateH);

		RBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		GBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
		BBuffer2=(UCHAR *)malloc(MAXWIDTH*CalibrateH);
	    for(j=OffsetStart;j<OffsetEnd;j+=1)
		{
		  ROffset=(UCHAR)j;
		  GOffset=(UCHAR)j;
		  BOffset=(UCHAR)j;

		for(i=GainStart;i<GainEnd;i++)
        {
           RGain=(UCHAR)i;
		   GGain=(UCHAR)i;
		   BGain=(UCHAR)i;
     	   read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer,GBuffer,BBuffer,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XMAXDPI,
						  XMAXDPI,
						  &realw,
						  &realh,
						  0,
						  0,
						  1,
						  (UCHAR)IsPixel,
						  MAXWIDTH,
						  0,
						  0,
						  ColorMode
						 );
		   if(DeviceType==DT_CIS)
		   {
			   read_calibrate(ScannerHandle,StartY,CalibrateH,DeviceType,RBuffer2,GBuffer2,BBuffer2,
			              ROffset,
		                  RGain,
						  GOffset,
		                  GGain,
						  BOffset,
		                  BGain,
						  XMAXDPI,
						  XMAXDPI,
						  &realw,
						  &realh,
						  0,
						  1,
						  1,
						  (UCHAR)IsPixel,
						  MAXWIDTH,
						  0,
						  0,
						  ColorMode
						  );	
		   }
            calc_blackwhite(RBuffer,RBuffer2,CalibrateH,&RAvg,&RMinBlack,&RMaxWhite,DeviceType,realw,realh,600);
            calc_blackwhite(GBuffer,GBuffer2,CalibrateH,&GAvg,&GMinBlack,&GMaxWhite,DeviceType,realw,realh,600);
            calc_blackwhite(BBuffer,BBuffer2,CalibrateH,&BAvg,&BMinBlack,&BMaxWhite,DeviceType,realw,realh,600);

           RGainTbl[0][i]=RMinBlack;
		   RGainTbl[1][i]=RMaxWhite;
		   GGainTbl[0][i]=GMinBlack;
		   GGainTbl[1][i]=GMaxWhite;
		   BGainTbl[0][i]=BMinBlack;
		   BGainTbl[1][i]=BMaxWhite;
		   sprintf(OutBuf,"Offset%2d Gain%2d RB %3d RW %3d GB %3d GW %3d BB %3d BW %3d \n",ROffset,RGain,RMinBlack,RMaxWhite,GMinBlack,GMaxWhite,BMinBlack,BMaxWhite);
		   fwrite( OutBuf, sizeof( char ), 60, stream );
	   
		}
		   
		   fwrite( "\n",sizeof( char ),2, stream );
		}
    	free(RBuffer);
	    free(GBuffer);
	    free(BBuffer); 
		free(RBuffer2);
	    free(GBuffer2);
	    free(BBuffer2); 
		fclose(stream);
    return 1;

}
