/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


/*

Copyright (c) 1998-2000	 Grandtech Semiconductor Corp.

Module Name:

   GT680x.H

Notes:

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (c)	1998-2000 Grandtech Semiconductor Corporation.
  All Rights Reserved.

Author:

  C. C.	Chang

Revision History:

    12/20/99 : created

--*/

#ifndef __GT680x_H__
#define __GT680x_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "BaseTypedef.h"

ULONG
EnumScannerDevices(
	IN	ULONG	BusProtocol,
	IN	PULONG	PDeviceIndexTable
        );
BOOL
ModifyOpenCommunicationBusWaitingCount(
	IN	BOOLEAN	Read,
        IN      PULONG  PWaitingCount
        );

HANDLE
STI_OpenCommunicationBus(
	IN	ULONG	BusProtocol,
        IN      ULONG   PP_Base_Address,
	IN	ULONG	DeviceIndex,
	IN	BOOLEAN	OverlappedFlag
        );

HANDLE
OpenCommunicationBus(
	IN	ULONG	BusProtocol,
        IN      ULONG   PP_Base_Address,
        IN      ULONG   DeviceIndex,
	IN	BOOLEAN	OverlappedFlag
        );

BOOL
CloseCommunicationBus(
        IN      HANDLE  ScannerHandle,
	IN	ULONG	BusProtocol,
        IN      ULONG   PP_Base_Address,
        IN      ULONG   DeviceIndex,
	IN	BOOLEAN	OverlappedFlag
        );

BOOL
SWSendUSBCommand(
        IN      HANDLE  USBHandle,
        IN      ULONG   CommandNumber,
        IN      PUCHAR  InputBuffer,
        IN      USHORT  InputBufferLength,
        IN      PUCHAR  OutputBuffer,
        IN      USHORT  OutputBufferLength,
        IN      PULONG  nBytesRead
        );

BOOL
STISendUSBCommand(
        IN      HANDLE  USBHandle,
        IN      ULONG   CommandNumber,
        IN      PUCHAR  InputBuffer,
        IN      USHORT  InputBufferLength,
        IN      PUCHAR  OutputBuffer,
        IN      USHORT  OutputBufferLength,
        IN      PULONG  nBytesRead
        );

BOOL
SendUSBCommand(
        IN      HANDLE  USBHandle,
        IN      ULONG   CommandNumber,
        IN      PUCHAR  InputBuffer,
        IN      USHORT  InputBufferLength,
        IN      PUCHAR  OutputBuffer,
        IN      USHORT  OutputBufferLength,
        IN      PULONG  nBytesRead
        );

BOOL
GTReadImage(
	IN	ULONG	     BusProtocol,
        IN      ULONG        ResdueBytesPerRead,
        IN      HANDLE       hFile,
        IN      LPVOID       lpBuffer,
        IN      DWORD        nNumberOfBytesToRead,
        OUT     LPDWORD      lpNumberOfBytesRead,
        IN      LPOVERLAPPED lpOverlapped
        );

BOOL
GTDownloadFirmware(
        IN      HANDLE  USBHandle,
	IN	ULONG	BusProtocol,
        IN      PUCHAR  DownLoadFWBuffer,
        IN      USHORT  DownLoadFWSize,
        IN      PULONG  nBytesDownloaded
        );

BOOL
__CC__ReadFileFromAnyWhere(
        IN		PUCHAR	FileName,
        IN		PUCHAR	DownLoadFWBuffer,
        IN		PULONG  PDownLoadFWSize
	);
        
#ifdef __cplusplus
}
#endif

#endif
