/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include "BaseTypedef.h"

#define LINUX

#define MAXSHIDDING 256
#define MAXBUFFERNUMBER 40
#define TESTMODE	TestModeDisable	
//////////set model///////////////////////////////

#ifndef PS1
#define PS1
#endif

#ifndef PS2
//#define PS2
#endif

///////////set model end//////////////////////////
#ifdef PS1
	#ifdef	LINUX
	   #define FWFILENAME "/usr/local/bin/ps1fw.usb"  
	#endif
	#ifdef	WIN32
	   #define FWFILENAME "ps1fw.usb"
	#endif
	#ifdef	MAC
		#define FWFILENAME "\pps1fw.usb"
	#endif
   #define _CIS_SCANNER_
#endif

#ifdef PS2
	#ifdef	WIN32
	   	#define FWFILENAME "ps2fw.usb"
	#endif
	#ifdef	MAC
		#define FWFILENAME "\ps2fw.usb"
	#endif
	#ifdef	LINUX
		#define FWFILENAME "ps2fw.usb"
	#endif

   #define	_1200DPI_
   #define _CIS_SCANNER_
#endif

#ifdef _1200DPI_
#define MAXWIDTH	10240 
#define XMAXDPI		1200
#define YMAXDPI		1200
#else
#define XMAXDPI		600
#define YMAXDPI		600
#define MAXWIDTH	5120 
#endif

#ifdef _CCD_SCANNER_
	#define SENSORTYPE	DT_CCD
	#ifdef _1200DPI_
		#define LAMPSTEP	12
		#define	LAMPORDER	LampOrder_RGB
	#else
		#define LAMPSTEP	8
		#define	LAMPORDER	LampOrder_RGB
	#endif
#else
	#define SENSORTYPE	DT_CIS
	#define LAMPSTEP	0
	#define	LAMPORDER	LampOrder_BGR
#endif

BOOL GTInitialation(ULONG BusProtocol,PUCHAR WorkingBuffer);
PUCHAR InitialationShiddingData(PUCHAR	*RColorTable,
				PUCHAR	*GColorTable,
				PUCHAR	*BColorTable,
				PUCHAR	*RImageBuffer,
				PUCHAR	*GImageBuffer,
				PUCHAR	*BImageBuffer);
