/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


/**
 * main.c
 * 
 * This is the main entry source for Panel, responsible for
 * pieceing together the user interface of the application. 
 * User interface signals are responded to in their own source files 
 **/

#include <gnome.h>
#include <libgnomeui/gnome-init.h>
#include "mainwindow.h"
#include "g_procedure.h"

/** Statics for application name and version **/
static gchar app_name[] = { "panel" };
static gchar app_version[] = { "1.0" };

struct poptOption options[] = {
   {
     NULL,
     'c',
     POPT_ARG_STRING,
     NULL,
     0,
     NULL,
     NULL
   },
   { 
     NULL,
     'f',
     POPT_ARG_STRING,
     NULL,
     0,
     NULL,
     NULL
   },
   { 
     NULL,
     'm',
     POPT_ARG_STRING,
     NULL,
     0,
     NULL,
     NULL
   },
   {
     NULL,
     'p',
     POPT_ARG_STRING,
     NULL,
     0,
     NULL,
     NULL
   },
   {
     NULL,
     'c',
     POPT_ARG_STRING,
     NULL,
     0,
     NULL,
     NULL
   }
 };



/** The ubiquitous main() function **/
gint main ( gint argc, gchar * argv[] )
{
   char ** args;
   poptContext ctx;
   int i;

   if( PanelAlreadyRun() ) { return 0; }
 
   bindtextdomain (app_name, GNOMELOCALEDIR);
   textdomain (app_name);
   gnome_init_with_popt_table(app_name, app_version, argc, argv, 
                              options, 0, &ctx);
   args = poptGetArgs(ctx);
  
   if (args != NULL)
   {
       i = 0;
       switch(*args[i])
       {
          case 's':
	    parse_cmd("s");
	    break;
          case 'm':
	    parse_cmd("m");
	    break;
          case 'c':
	    parse_cmd("c");
	    break;
          case 'f':
	    parse_cmd("f");
	    break;
          case 'p':
	    parse_cmd("p");
	    break;
       }
   }
   
   BuildMainWindow ( app_name, app_version );
   Create1200UBDir();
   InitSettingFile();
   
  
   poptFreeContext(ctx);

   gtk_main ();
   return 0;
}











