/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#ifndef __scanner_h__
#define __scanner_h__

#include "sci.h"
#include "gt680x.h"
#include "scanner.h"

USHORT BusProtocol	= GrandTech_Scanner_Vendor_USB_Send_Command;
ULONG DeviceIndexTable[128];
ULONG DeviceIndex;
ULONG DeviceCount;
ULONG nBytesRead;
HANDLE ScannerHandle;
UCHAR Return_Info[64];
BOOL success;

BOOL _Open(void)
{
	DeviceIndex = 0;
	DeviceCount = 0;
//	DeviceCount = EnumScannerDevices(BusProtocol, DeviceIndexTable);
	ScannerHandle = OpenCommunicationBus(BusProtocol, 0x378, DeviceIndexTable[DeviceCount], FALSE);
//	ScannerHandle = NULL;
	success = TRUE;
	if (ScannerHandle != INVALID_HANDLE_VALUE)
	{
		Return_Info[0] = 0x50;
		Return_Info[1] = 0x01;
		Return_Info[2] = 0x80;
		Return_Info[3] = 0x00;
		
		success = SendUSBCommand(ScannerHandle,
					GrandTech_Scanner_Vendor_USB_Send_Command,
					Return_Info,
					64,
					Return_Info,
					64,
					&nBytesRead);
		if (Return_Info[1] != 0x50)
		{
			success = ProcessCommandDownloadFirmware( 
				(HWND)NULL,
				FALSE,
				ScannerHandle,
				BusProtocol,
				"ps1fw.usb",
				0);
		}
	} else 
			success = FALSE;
			
	return success;	
		
}
BOOL _Close(void)
{
	CloseCommunicationBus(ScannerHandle,
		BusProtocol,
		0x378,
		DeviceIndexTable[DeviceIndex],
		FALSE);
	return TRUE;
}

#define FUNC_1	0x10
#define FUNC_2  0x14
#define FUNC_3	0x12
#define FUNC_4  0x18
#define FUNC_5	0x11

#define FC_SCANTOAP	1
#define FC_COPY		2
#define FC_FAX		3
#define FC_EMAIL	4
#define FC_STARTUP	5

BOOL CheckFunctionKey(BYTE *bFunction)
{
	BYTE FunctionKey = 0x00;
	
	Return_Info[0] = 0x74;
	Return_Info[1] = 0x01;
	success = STISendUSBCommand(
		ScannerHandle,
		BusProtocol,
		Return_Info,
		64,
		Return_Info,
		64,
		&nBytesRead);
		
	FunctionKey = (BYTE) Return_Info[2];
	
	
	if (FunctionKey == FUNC_1)
		*bFunction = FC_SCANTOAP;
	else if (FunctionKey == FUNC_2)
		*bFunction = FC_COPY;
	else if (FunctionKey == FUNC_3)
		*bFunction = FC_FAX;
	else if (FunctionKey == FUNC_4)
		*bFunction = FC_EMAIL;
	else if (FunctionKey == FUNC_5)
		*bFunction = FC_STARTUP;						
	else
		*bFunction = 0;
	return TRUE;
}











#endif
