/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


/*

Copyright (c) 1998-2000  Grandtech Semiconductor Corp.

Module Name:

   SCI.H

Notes:

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (c) 1998-2000 Grandtech Semiconductor Corporation.
  All Rights Reserved.

Author:

  C. C. Chang

Revision History:

    12/20/99 : created

--*/

#ifndef __SCI_H__
#define __SCI_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "BaseTypedef.h"

// Definition for Endian Parameter
//#define LITTLE_ENDIAN   0
//#define BIG_ENDIAN      1


// Definitions for ShowMessageFlag in Functions
#define SHOW_NONE               0  // Compatiable with earlier version, ie., FALSE
#define SHOW_ONERROR            1  // Compatiable with earlier version, ie., TRUE
#define SHOW_ONSUCCESSERROR     2
#define SHOW_ONSUCCESS          3


// Definitions for ProcessCommandMiscControl Control Definitions
#define COMMAND_MISC_CONTROL_MOTOR              0x0000
#define COMMAND_MISC_CONTROL_LAMP               0x0001
#define COMMAND_MISC_CONTROL_LED_CIS_R          0x0002
#define COMMAND_MISC_CONTROL_LED_CIS_G          0x0003
#define COMMAND_MISC_CONTROL_LED_CIS_B          0x0004
#define COMMAND_MISC_CONTROL_POWER              0x0005
#define COMMAND_MISC_CONTROL_BUTTON             0x0006


// Definitions for ProcessCommandMiscControl Function Definitions
#define COMMAND_MISC_CONTROL_MOTOR_HOME                 0x0024  // 0x0000
#define COMMAND_MISC_CONTROL_MOTOR_STOP_WHITE           0x001E  // 0x0001
#define COMMAND_MISC_CONTROL_MOTOR_STOP_BLACK           0x001F  // 0x0002
#define COMMAND_MISC_CONTROL_MOTOR_FORWARD              0x0014  // 0x0003
#define COMMAND_MISC_CONTROL_MOTOR_STILL                        // 0x0004
#define COMMAND_MISC_CONTROL_MOTOR_BACKWARD             0x0015  // 0x0005
#define COMMAND_MISC_CONTROL_MOTOR_ON                   0x0012  // 0x0006
#define COMMAND_MISC_CONTROL_MOTOR_OFF                  0x0013  // 0x0007
//#define COMMAND_MISC_CONTROL_MOTOR_SPEED                0x002F  // 0x0008
#define COMMAND_MISC_CONTROL_MOTOR_FREERUN              0x0016  // 0x0009
#define COMMAND_MISC_CONTROL_MOTOR_BACKSTEPS                    // 0x000A
#define COMMAND_MISC_CONTROL_MOTOR_STATUS               0x0017  // 0x000B
#define COMMAND_MISC_CONTROL_MOTOR_SPEED                        // 0x000C  // TBD
#define COMMAND_MISC_CONTROL_LAMP_ON_OFF                0x0025  // 0x0000
#define COMMAND_MISC_CONTROL_LAMP_OFF                           // 0x0001
#define COMMAND_MISC_CONTROL_LAMP_FLASH                         // 0x0002
#define COMMAND_MISC_CONTROL_LAMP_FREQUENCY                     // 0x0003
#define COMMAND_MISC_CONTROL_LAMP_CATEGORY                      // 0x0004
#define COMMAND_MISC_CONTROL_LAMP_WATCHDOG              0x0027  // 0x0005
#define COMMAND_MISC_CONTROL_LAMP_STATUS                0x0028  // 0x0006
#define COMMAND_MISC_CONTROL_LED_CIS_R_ON                       // 0x0000
#define COMMAND_MISC_CONTROL_LED_CIS_R_OFF                      // 0x0001
#define COMMAND_MISC_CONTROL_LED_CIS_R_FLASH                    // 0x0002
#define COMMAND_MISC_CONTROL_LED_CIS_R_FREQUENCY                // 0x0003
#define COMMAND_MISC_CONTROL_LED_CIS_G_ON                       // 0x0000
#define COMMAND_MISC_CONTROL_LED_CIS_G_OFF                      // 0x0001
#define COMMAND_MISC_CONTROL_LED_CIS_G_FLASH                    // 0x0002
#define COMMAND_MISC_CONTROL_LED_CIS_G_FREQUENCY                // 0x0003
#define COMMAND_MISC_CONTROL_LED_CIS_B_ON                       // 0x0000
#define COMMAND_MISC_CONTROL_LED_CIS_B_OFF                      // 0x0001
#define COMMAND_MISC_CONTROL_LED_CIS_B_FLASH                    // 0x0002
#define COMMAND_MISC_CONTROL_LED_CIS_B_FREQUENCY                // 0x0003
#define COMMAND_MISC_CONTROL_POWER_ON                           // 0x0000
#define COMMAND_MISC_CONTROL_POWER_OFF                          // 0x0001
#define COMMAND_MISC_CONTROL_POWER_ALARM                        // 0x0002
#define COMMAND_MISC_CONTROL_POWER_FREQUENCY                    // 0x0003
#define COMMAND_MISC_CONTROL_POWER_CATEGORY                     // 0x0004
#define COMMAND_MISC_CONTROL_BUTTON_INQUIRE             0x0029  // 0x0000


// Definition for LampOrder Parameter
#define LampOrder_RGB   0
#define LampOrder_RBG   1
#define LampOrder_GRB   2
#define LampOrder_GBR   3
#define LampOrder_BRG   4
#define LampOrder_BGR   5

// Definition for LampColor Parameter
#define LC_BlueLamp     1
#define LC_GreenLamp    2
#define LC_RedLamp      3

// Definition for ScanType
#define LineArt         0
#define BlueMode        1
#define GreenMode       2
#define RedMode         3
#define ColorMode       4

// Definition for DataBusType
#define DBT_08_08_06    0
#define DBT_16_10_07    1
#define DBT_XX_12_08    2
#define DBT_XX_XX_10    3
#define DBT_16_16_16    4

// Definition for CompressType
#define CompressDisable 0
#define CompressEnable  1

// Definition for RawDataFormat
#define RDF_Optimize    0
#define RDF_16Bits      1

// Definition for TestMode
#define TestModeDisable 0
#define TestModeEnable  1

// Definition for BufferSize
#define BufferSize16K   0
#define BufferSize64K   1

// Definition for DataAttribute
#define DA_Normal       0
#define DA_Invert       1

// Definition for BusProtocol
#define GrandTech_Scanner_Vendor_EPP_Send_Command       0x00
#define GrandTech_Scanner_Vendor_ECP_Send_Command       0x01
#define GrandTech_Scanner_Vendor_PS2_Send_Command       0x02
#define GrandTech_Scanner_Vendor_BPP_Send_Command       0x03
#define GrandTech_Scanner_Vendor_USB_Send_Command       0x04
#define GrandTech_Scanner_Vendor_USB_Old_Send_Command   0x09

// Definition for DeviceType
#define DT_CCD          0
#define DT_CIS          1

// Definition for StillAfterScan
#define SAS_OFF         0
#define SAS_ON          1

// Definition for StillBeforeScan
#define SBS_OFF         0
#define SBS_ON          1

// Definition for StillOnScan
#define SOS_OFF         0
#define SOS_ON          1

// Definition for BackingIfBufFull
#define BIBF_OFF        0
#define BIBF_ON         1

// Definition for LampOffOnScan
#define LOOS_OFF        0
#define LOOS_ON         1

// Definition for AutoBandwidth
#define ABW_OFF         0
#define ABW_ON          1

// Definition for Pixel/Line Mode located in bit 0 of MiscReserved
#define LINEMODE        0
#define PIXELMODE       1

// Definition for ShaddingBit located in bit 1 of MiscReserved
#define SHADDINGENABLE  0
#define SHADDINGDISABLE 1


typedef struct _SCANNER_INFO {
        USHORT  XDPI;
        USHORT  YDPI;
        USHORT  MaximumWidth;
        USHORT  MaximumHeight;
        USHORT  TopMargin;
        USHORT  BottomMargin;
        USHORT  LeftMargin;
        USHORT  RightMargin;
        USHORT  BufferSize;
        USHORT  SensorID;
        USHORT  BackwardSteps;
        UCHAR   LampOrder;
        UCHAR   LampSteps;
        UCHAR   Endian;
        UCHAR   DummyPixels;
        USHORT  FirmwareCheckSum;
        USHORT  AFEGainRangeRed;
        USHORT  AFEOffsetRangeRed;
        USHORT  AFEGainRangeGreen;
        USHORT  AFEOffsetRangeGreen;
        USHORT  AFEGainRangeBlue;
        USHORT  AFEOffsetRangeBlue;
        USHORT  AFEGainUnit;
        USHORT  AFEOffsetUnit;
        USHORT  MotorRange;
        USHORT  MotorUnit;
        USHORT  ExposureTimeRange;
        USHORT  ExposureTimeUnit;
        USHORT  LineTimeRange;
        USHORT  LineTimeUnit;
        UCHAR   OpticalBlackPixelStart;
        UCHAR   OpticalBlackPixelEnd;
} SCANNER_INFO, *PSCANNER_INFO;


BOOL
ProcessCommandDownloadFirmware(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  FirmwareFileName,
        IN      USHORT  DownloadMethod
        );
        
BOOL
ProcessCommandRetrievePaperSizeByDPI(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  DPI,
        IN      USHORT  EstimatedWidth,
        IN      USHORT  EstimatedHeight,
        IN      PUSHORT PHWWidth,
        IN      PUSHORT PHWHeight,
        IN      PUSHORT PSWWidth,
        IN      PUSHORT PSWHeight
        );

BOOL
ProcessCommandRetrieveNecessaryInfo(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   LampOrder,
        IN      UCHAR   LampStep,
        IN      USHORT  ScanType,
        IN      USHORT  DPI,
        IN      USHORT  EstimatedWidth,
        IN      USHORT  EstimatedHeight,
        IN      PUSHORT PHWWidth,
        IN      PUSHORT PHWHeight,
        IN      PUSHORT PSWWidth,
        IN      PUSHORT PSWHeight,
        IN      PVOID   PWorkingBuffer
        );

BOOL
ProcessCommandGetLineAndColor(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  AccessNumber,
        IN      PVOID   PWorkingBuffer,
        IN      PUSHORT PSWLineNumber,
        IN      PUCHAR  PLampColor
        );

BOOL
ProcessCommandSetAFEGain(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   R_Offset,
        IN      UCHAR   R_Gain,
        IN      UCHAR   G_Offset,
        IN      UCHAR   G_Gain,
        IN      UCHAR   B_Offset,
        IN      UCHAR   B_Gain
        );

BOOL
ProcessCommandSetScanWindow(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  StartX,
        IN      USHORT  StartY,
        IN      USHORT  Width,
        IN      USHORT  Height,
        IN      USHORT  DPI,
        IN      USHORT  SWWidth,
        IN      USHORT  SWHeight,
        IN      USHORT  ScanType,
        IN      USHORT  DataWidth,
        IN      USHORT  ModeReserved1,
        IN      USHORT  TestMode,
        IN      USHORT  BufferSize,
        IN      USHORT  DataAttribute,
        IN      USHORT  BusProtocol,
        IN      USHORT  DeviceType,
        IN      USHORT  ModeReserved3,
        IN      UCHAR   StillAfterScan,
        IN      UCHAR   StillBeforeScan,
        IN      UCHAR   StillOnScan,
        IN      UCHAR   BackingIfBufFull,
        IN      UCHAR   MotorReserved,
        IN      UCHAR   LampOffOnScan,
        IN      UCHAR   AutoBandwidth,
        IN      UCHAR   MiscReserved
        );

BOOL
ProcessCommandSetStartScan(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol
        );
        
BOOL
ProcessCommandWaitScannerReady(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  PollingPeriod
        );
        
BOOL
ProcessCommandSetEndScan(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol
        );
        
BOOL
ProcessCommandSendUserCommand(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   Command,
        IN      PUCHAR  InputBuffer,
        IN      ULONG   InputBufferLength,
        IN      PUCHAR  OutputBuffer,
        IN      ULONG   OutputBufferLength
        );

BOOL
ProcessCommandAccessDriverFlag(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      BOOLEAN Read,
        IN      PUCHAR  PFlag
        );

BOOL
ProcessCommandGetInformation(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   GetInfoNumber,
        IN      PUCHAR  PReturnedInfo   // Point to a buffer(>= 64 bytes).
        );

BOOL
ProcessCommandSTIGetInformation(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   GetSTIInfoNumber,
        IN      PUCHAR  PReturnedInfo
        );

BOOL
ProcessCommandGetID(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUSHORT PVendorID,
        IN      PUSHORT PProductID,
        IN      PULONG  PDeviceID
        );

BOOL
ProcessCommandGetAllID(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUSHORT PVendorID,
        IN      PUSHORT PProductID,
        IN      PUSHORT PFirmwareID,
        IN      PUSHORT PHardwareID,
        IN      PULONG  PDeviceID
        );

BOOL
ProcessCommandSetEndian(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   Endian
        );

BOOL
ProcessCommandReadImage(
        IN      HWND         ShowMessagehWnd,
        IN      BOOLEAN      ShowMessageFlag,
        IN      HANDLE       ScannerHandle,
        IN      ULONG        CommunicationProtocol,
        IN      USHORT       DataWidth,
        IN      USHORT       SWWidth,
        IN      PUCHAR       ImageBuffer,
        IN      ULONG        SizeInBytesToRead,
        IN      PULONG       PSizeInBytesRead,
        IN      LPOVERLAPPED lpOverlapped
        );

BOOL
ProcessCommandDecompression(
        IN      PUCHAR  ImageBufferOut,
        IN      PUCHAR  ImageBufferIn,
        IN      ULONG   ImageWidth,
        IN      ULONG   ImageHeight,
        IN      ULONG   ImageBPP,
        IN      PULONG  PBytesUsed
        );

//========================================

BOOL
ProcessCommandGetScannerInfo(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PVOID   PScannerInformation
        );

BOOL
ProcessCommandRetrieveNecessaryInfo2(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   LampOrder,
        IN      UCHAR   LampStep,
        IN      USHORT  ScanType,
        IN      USHORT  XMaxDPI,
        IN      USHORT  YMaxDPI,
        IN      USHORT  XUserDPI,
        IN      USHORT  YUserDPI,
        IN      USHORT  EstimatedWidth,
        IN      USHORT  EstimatedHeight,
        IN      PUSHORT PHWWidth,
        IN      PUSHORT PHWHeight,
        IN      PUSHORT PSWWidth,
        IN      PUSHORT PSWHeight,
        IN      PVOID   PWorkingBuffer
        );

BOOL
ProcessCommandRetrieveNecessaryInfo3(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   LampOrder,
        IN      UCHAR   LampStep,
        IN      USHORT  ScanType,
        IN      USHORT  XMaxDPI,
        IN      USHORT  YMaxDPI,
        IN      USHORT  XUserDPI,
        IN      USHORT  YUserDPI,
        IN      USHORT  SWWidth,
        IN      USHORT  SWHeight,
        IN      PUSHORT PHWWidth,
        IN      PUSHORT PHWHeight,
        IN      PVOID   PWorkingBuffer
        );

BOOL
ProcessCommandRetrieveNecessaryInfo4(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   LampOrder,
        IN      UCHAR   LampStep,
        IN      USHORT  ScanType,
        IN      USHORT  XMaxDPI,
        IN      USHORT  YMaxDPI,
        IN      USHORT  XUserDPI,
        IN      USHORT  YUserDPI,
        IN      USHORT  EstimatedWidth,
        IN      USHORT  EstimatedHeight,
        IN      PUSHORT PHWWidth,
        IN      PUSHORT PHWHeight,
        IN      PUSHORT PSWWidth,
        IN      PUSHORT PSWHeight,
        IN      PVOID   PWorkingBuffer
        );

BOOL
ProcessCommandSetScanWindow2(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  StartX,
        IN      USHORT  StartY,
        IN      USHORT  Width,
        IN      USHORT  Height,
        IN      USHORT  DPI,
        IN      USHORT  SWWidth,
        IN      USHORT  SWHeight,
        IN      USHORT  ScanType,
        IN      USHORT  DataWidth,
        IN      USHORT  ModeReserved1,
        IN      USHORT  TestMode,
        IN      USHORT  BufferSize,
        IN      USHORT  DataAttribute,
        IN      USHORT  BusProtocol,
        IN      USHORT  DeviceType,
        IN      USHORT  ModeReserved3,
        IN      UCHAR   StillAfterScan,
        IN      UCHAR   StillBeforeScan,
        IN      UCHAR   StillOnScan,
        IN      UCHAR   BackingIfBufFull,
        IN      UCHAR   MotorReserved,
        IN      UCHAR   LampOffOnScan,
        IN      UCHAR   AutoBandwidth,
        IN      UCHAR   MiscReserved,
        IN      USHORT  YDPI,
        IN      USHORT  MotorBackwardStepsIfBufferFull
        );

BOOL
ProcessCommandSetScanWindow3(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  StartX,
        IN      USHORT  StartY,
        IN      USHORT  Width,
        IN      USHORT  Height,
        IN      USHORT  DPI,
        IN      USHORT  SWWidth,
        IN      USHORT  SWHeight,
        IN      USHORT  ScanType,
        IN      USHORT  DataWidth,
        IN      USHORT  ModeReserved1,
        IN      USHORT  TestMode,
        IN      USHORT  BufferSize,
        IN      USHORT  DataAttribute,
        IN      USHORT  BusProtocol,
        IN      USHORT  DeviceType,
        IN      USHORT  ModeReserved3,
        IN      UCHAR   StillAfterScan,
        IN      UCHAR   StillBeforeScan,
        IN      UCHAR   StillOnScan,
        IN      UCHAR   BackingIfBufFull,
        IN      UCHAR   MotorReserved,
        IN      UCHAR   LampOffOnScan,
        IN      UCHAR   AutoBandwidth,
        IN      UCHAR   MiscReserved,
        IN      USHORT  YDPI,
        IN      USHORT  MotorBackwardStepsIfBufferFull,
        IN      USHORT  RawDataFormat
        );

BOOL
ProcessCommandSetScanWindow4(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  ScannerHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  StartX,
        IN      USHORT  StartY,
        IN      USHORT  Width,
        IN      USHORT  Height,
        IN      USHORT  DPI,
        IN      USHORT  SWWidth,
        IN      USHORT  SWHeight,
        IN      USHORT  ScanType,
        IN      USHORT  DataWidth,
        IN      USHORT  ModeReserved1,
        IN      USHORT  TestMode,
        IN      USHORT  BufferSize,
        IN      USHORT  DataAttribute,
        IN      USHORT  BusProtocol,
        IN      USHORT  DeviceType,
        IN      USHORT  ModeReserved3,
        IN      UCHAR   StillAfterScan,
        IN      UCHAR   StillBeforeScan,
        IN      UCHAR   StillOnScan,
        IN      UCHAR   BackingIfBufFull,
        IN      UCHAR   MotorReserved,
        IN      UCHAR   LampOffOnScan,
        IN      UCHAR   AutoBandwidth,
        IN      UCHAR   MiscReserved,
        IN      USHORT  YDPI,
        IN      USHORT  MotorBackwardStepsIfBufferFull,
        IN      USHORT  RawDataFormat,
        IN      USHORT  XMaxDPI,
        IN      USHORT  YMaxDPI,
        IN      USHORT  LampStep
        );

BOOL
ProcessCommandSetExposureTime(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  RedStart,
        IN      USHORT  RedStop,
        IN      USHORT  GreenStart,
        IN      USHORT  GreenStop,
        IN      USHORT  BlueStart,
        IN      USHORT  BlueStop
        );

BOOL
ProcessCommandSetLineTime(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      ULONG   LineTime
        );

BOOL
ProcessCommandMiscControl(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      USHORT  Control,
        IN      USHORT  Function,
        IN      PVOID   PInputBuffer,
        IN      PVOID   POutputBuffer
        );

BOOL
ProcessCommandGetVersion(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PLibraryVersion,
        IN      PUCHAR  PDriverVersion,
        IN      PUCHAR  PFirmwareBootIDB0,
        IN      PUCHAR  PHardwareBootIDB1
        );

BOOL
ProcessCommandGetSensorTiming(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PULONG  PSensorRed,
        IN      PULONG  PSensorGreen,
        IN      PULONG  PSensorBlue
        );

BOOL
ProcessCommandSetSensorTiming(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      ULONG   SensorRed,
        IN      ULONG   SensorGreen,
        IN      ULONG   SensorBlue
        );

BOOL
ProcessCommandReadRegister(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   RegisterIndex,
        IN      PUCHAR  PRegisterValue
        );

BOOL
ProcessCommandWriteRegister(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      UCHAR   RegisterIndex,
        IN      UCHAR   RegisterValue
        );


// Can be used before firmware downloaded
BOOL
ProcessCommandSTIGetOnLineStatus(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  POnLineStatus           // 0x01:Success, 0x00:Fail
        );

// Can be used before firmware downloaded
BOOL
ProcessCommandSTIDiagnostic(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PDiagnosticStatus       // 0x01:Success, 0x00:Fail
        );

// Can be used before firmware downloaded
BOOL
ProcessCommandSTIReset(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PResetStatus            // 0x01:Success, 0x00:Fail
        );

// Can be used before firmware downloaded
BOOL
ProcessCommandGetVersion(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PLibraryVersion,
        IN      PUCHAR  PDriverVersion,
        IN      PUCHAR  PFirmwareBootID0,
        IN      PUCHAR  PFirmwareBootID1
        );

// Can be used before firmware downloaded
BOOL
ProcessCommandSTIGetButtonStatus(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PButtonStatus,
        IN      ULONG   NumberOfButtons
        );

BOOL
ProcessCommandGetLastError(
        IN      HWND    ShowMessagehWnd,
        IN      ULONG   ShowMessageFlag,
        IN      HANDLE  DeviceHandle,
        IN      ULONG   CommunicationProtocol,
        IN      PUCHAR  PLastError
        );

#ifdef __cplusplus
}
#endif

#endif
