/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "setting.h"
#include "g_procedure.h"


#define Scan_scan_mode 0
#define Scan_resolution 1
#define Scan_program_to_run 2
#define Mail_scan_mode 3
#define Mail_mail_program 4

GtkWidget * ChkButton;
GtkWidget * g_pWindow;
GtkWidget * g_pCombo[4];   /**
			      =========scan==========
			      g_pCombo[0]:scan mode
			      g_pCombo[1]:resolution
			      g_pCombo[2]:program to run
			      =========Mail==========
			      g_pCombo[3]:scan mode
			      //g_pCombo[4]:Mail program
			   **/



void CloseTheSettingDialog ( GtkWidget * widget, gpointer data )
{
  gtk_main_quit ();
}


/** Write option to file. The file name is setting
 *
 **/
void Setting_OkClicked ( GtkButton * button, gpointer data )
{
  
  FILE * lpfp = NULL;
  char chFile[256];


  Get1200UBPath(chFile);
  strcat(chFile, "/setting");
  
  if( ( lpfp = fopen( chFile, "w+" ) ) == NULL ) {
    printf("Cannot open file.\n");
    exit(1);
  }
  
  /**===============Scan==============**/
  fputs( "[Scan]\n", lpfp );
  fputs( "ScanMode=", lpfp );
  fputs( strcat( gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( g_pCombo[0] ) -> entry ) ), "\n"), lpfp );
  fputs( "Resolution=", lpfp );
  fputs( strcat( gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( g_pCombo[1] ) -> entry ) ), "\n"), lpfp );
  fputs( "ProgramToRun=", lpfp );
  fputs( strcat( gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( g_pCombo[2] ) -> entry ) ), "\n"), lpfp );
  fputs( "\n", lpfp );  // Separator


  /**============ Preview ============**/
  fputs( "[Preview]\n", lpfp );
  fputs( "ScanPreview=", lpfp );
  if (GTK_TOGGLE_BUTTON (ChkButton)->active)
  {
      fputs( "TRUE\n", lpfp );
  }
  else
  {
      fputs( "FALSE\n", lpfp );
  }
  
  fputs( "\n", lpfp );  // Separator

  
  /**===============Mail==============**/
  fputs( "[Mail]\n", lpfp );
  fputs( "ScanMode=", lpfp );
  fputs( strcat( gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( g_pCombo[3] ) -> entry ) ), "\n"), lpfp );
  //fputs( "MailProgram=", lpfp );
  //fputs( strcat( gtk_entry_get_text ( GTK_ENTRY ( GTK_COMBO ( g_pCombo[4] ) -> entry ) ), "\n"), lpfp );
  
  
  fclose(lpfp);
  gtk_widget_destroy ( g_pWindow );
}


void Setting_CancelClicked ( GtkButton * button, gpointer data )
{
  gtk_widget_destroy ( g_pWindow );
}


void CreateLabelInTable ( GtkWidget* table, const gchar* caption, gint left,
			  gint right, gint top, gint bottom )
{
  GtkWidget* Label;

  Label=NULL;
  Label=gtk_label_new( caption );
  gtk_table_attach_defaults ( GTK_TABLE ( table ), Label, left, right, top, bottom );
}


void CreateButtonInTable ( GtkWidget* table, const gchar* caption, gint left,
			   gint right, gint top, gint bottom )
{
  GtkWidget* button;
  
  button=gtk_button_new_with_label ( caption );
  if( caption == "OK" )
    {
      gtk_signal_connect ( GTK_OBJECT ( button ),
			   "clicked", GTK_SIGNAL_FUNC ( Setting_OkClicked ),
			   NULL );
    }
  else if( caption == "Cancel" )
    {
      gtk_signal_connect ( GTK_OBJECT ( button ),
			   "clicked", GTK_SIGNAL_FUNC ( Setting_CancelClicked ),
			   NULL );
    }
  
  
  gtk_table_attach_defaults ( GTK_TABLE ( table ), button, left, right, top, bottom );
}


void CreateFrameInTable ( GtkWidget* table, const gchar* caption, gint left,
			  gint right, gint top, gint bottom )
{
  GtkWidget* Frame;
  Frame=gtk_frame_new ( caption );
  gtk_frame_set_shadow_type ( GTK_FRAME ( Frame ), GTK_SHADOW_ETCHED_IN );
  gtk_table_attach_defaults ( GTK_TABLE ( table ), Frame, left, right, top, bottom );
}


void CreateFrameOutTable ( GtkWidget* table, const gchar* caption, gint left,
			   gint right, gint top, gint bottom )
{
  GtkWidget* Frame;
  Frame=gtk_frame_new ( caption );
  gtk_frame_set_shadow_type ( GTK_FRAME ( Frame ), GTK_SHADOW_ETCHED_OUT );
  gtk_table_attach_defaults ( GTK_TABLE ( table ), Frame, left, right, top, bottom );
}


void CreateComboInTable ( int index, GtkWidget * table, GList * combolist, gint left,
			  gint right, gint top, gint bottom )
{
  g_pCombo[index]=gtk_combo_new();
  gtk_combo_set_popdown_strings ( GTK_COMBO ( g_pCombo[index] ), combolist );
  gtk_table_attach_defaults ( GTK_TABLE ( table ), g_pCombo[index], left, right, top, bottom );
  g_list_free( combolist );
}


void CreateChkButtonInTable ( GtkWidget* table, const gchar* caption, gint left,
			      gint right, gint top, gint bottom )
{
 
  ChkButton = NULL;
  ChkButton = gtk_check_button_new_with_label( caption );
  gtk_table_attach_defaults ( GTK_TABLE ( table ), ChkButton, left, right, top, bottom );
}


void SettingDialog(  gint argc, gchar * argv[] )
{

  GtkWidget * table;
  GList * combolist;
  char * lpchOption;
 
  gtk_init ( &argc, &argv );
  
  g_pWindow = gtk_window_new ( GTK_WINDOW_DIALOG );
  gtk_window_set_policy(GTK_WINDOW(g_pWindow), FALSE, FALSE, FALSE );
  gtk_window_set_default_size ( GTK_WINDOW ( g_pWindow ), 150, 300 );
  gtk_window_set_title (GTK_WINDOW ( g_pWindow ), "Setting" );
  gtk_container_set_border_width ( GTK_CONTAINER ( g_pWindow ), 10 );
  gtk_window_set_position ( GTK_WINDOW ( g_pWindow ), GTK_WIN_POS_MOUSE );
  gtk_window_set_modal ( GTK_WINDOW ( g_pWindow ), TRUE );
  gtk_signal_connect (GTK_OBJECT ( g_pWindow ), "destroy",
		      GTK_SIGNAL_FUNC ( CloseTheSettingDialog ), NULL );
  table = gtk_table_new ( 14, 18, TRUE );
  
  /**=============== button layer =================**/
  CreateButtonInTable ( table, "OK", 8, 14, 1, 2 );       // "ok" button and position
  CreateButtonInTable ( table, "Cancel", 15, 21, 1, 2 );   // "cancel" button 
  CreateFrameInTable ( table, 0, 7, 22, 0, 3 );          // frame,around "ok" and "cancel"

  
  /**============== scan layer =====================**/
  CreateFrameInTable ( table, "Scan", 0, 22, 3, 11 );     // scan frame
  CreateLabelInTable ( table, "Scan mode", 1, 7, 4, 5 );   // "Scan mode" label 
  combolist=NULL;
  combolist=g_list_append ( combolist, "Color24" );
  combolist=g_list_append ( combolist, "Gray8" );
  combolist=g_list_append ( combolist,"Lineart" );
  CreateComboInTable ( Scan_scan_mode, table, combolist, 7, 18, 4, 5 );     // "Scan mode" combobox.
  lpchOption = Option("[Scan]","ScanMode");
  if(lpchOption != NULL)
  {
      gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( g_pCombo[Scan_scan_mode] )->entry ),lpchOption ); 
      free(lpchOption);
      lpchOption = NULL;
  }

  
  CreateLabelInTable ( table, "Resolution", 1, 7, 6, 7 );   // "Resolution" label
  combolist=NULL;
  combolist=g_list_append ( combolist, "Normal" );
  combolist=g_list_append ( combolist, "Fine" );
  combolist=g_list_append ( combolist, "Super fine");
  CreateComboInTable ( Scan_resolution, table, combolist, 7, 18, 6, 7 );     // "Resolution" combobox
  lpchOption = Option("[Scan]","Resolution");
  if(lpchOption != NULL)
  {
      gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( g_pCombo[Scan_resolution] )->entry ),lpchOption ); 
      free(lpchOption);
      lpchOption = NULL;
  }
  

  CreateLabelInTable ( table, "Program to run", 1, 7, 8, 9 );     // "Program to run" label
  combolist=NULL;
  combolist=g_list_append ( combolist, "Panel" );
  combolist=g_list_append ( combolist, "The GIMP" );
  CreateComboInTable ( Scan_program_to_run, table, combolist , 7, 18, 8, 9 );   // "Program to run" combobox
  lpchOption = Option("[Scan]","ProgramToRun");
  if(lpchOption != NULL)
  {
      gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( g_pCombo[Scan_program_to_run] )->entry ),lpchOption ); 
      free(lpchOption);
      lpchOption = NULL;
  }

  CreateChkButtonInTable ( table, "Scan Preview", 3, 15, 9, 10 );
  

  /**============== Scan Preview ===================**/
  lpchOption = Option("[Preview]","ScanPreview");
  if( !strcmp(lpchOption, "TRUE") )
  {
      gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ChkButton), TRUE );
      free(lpchOption);
      lpchOption = NULL;
  }
  else
  {
      gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(ChkButton), FALSE );
      free(lpchOption);
      lpchOption = NULL;
  }
  

  /**============== mail layer ======================**/
  CreateFrameInTable ( table, "Mail", 0, 22, 11, 16 );         // Mail frame
  CreateLabelInTable ( table, "Scan mode", 1, 7, 12, 13 );      // "Scan mode" label
  combolist=NULL;
  combolist=g_list_append ( combolist, "Color24" );
  combolist=g_list_append ( combolist, "Gray8" );
  //  combolist=g_list_append ( combolist, "Lineart" );
  CreateComboInTable ( Mail_scan_mode, table, combolist, 7, 18, 12, 13 );       // "Scan mode" combobox
  lpchOption = Option("[Mail]","ScanMode");
  if(lpchOption != NULL)
  {
      gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( g_pCombo[Mail_scan_mode] )->entry ),lpchOption ); 
      free(lpchOption);
      lpchOption = NULL;
  }

  /*
  CreateLabelInTable ( table, "Mail program", 1, 7, 13, 14);    // "Mail program" label
  combolist=NULL;
  combolist=g_list_append ( combolist, "Sendmail" );
  CreateComboInTable ( Mail_mail_program, table, combolist, 7, 18, 13, 14 );   // "Mail program" combobox
  lpchOption = Option("[Scan]","MailProgram");
  if(lpchOption != NULL)
  {
      gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( g_pCombo[Mail_mail_program] )->entry ),lpchOption ); 
      free(lpchOption);
      lpchOption = NULL;
  }
  */

  
  gtk_container_add (GTK_CONTAINER ( g_pWindow ), table );
  gtk_widget_show_all( g_pWindow );
  gtk_main();
}














