/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include <ctype.h>
#include <stdio.h>

#include "BaseTypedef.h"

#include "gain.h"
#include "gtscanner.h"

#include "SpExport.h"
#include "sci.h"
#include "gt680x.h"

#define OPENFLAG TRUE
UCHAR   FWVersion[4];
static char    versionbuffer[96];
ULONG   WaitingCount=1;
int     myscantotaltime;
int     oncebegintime,onceendtime;
char    DebugBuffer[30];
typedef int	bool;

#ifdef GT6816
	UCHAR	DownLoadMethod=1;
#else
	UCHAR	DownLoadMethod=0;
#endif

BOOL    FirstScan=FALSE;
BOOL    FirstCalibrate=TRUE;
HANDLE	ScannerHandle = INVALID_HANDLE_VALUE;
ULONG	nBytesRead;


USHORT  HeightMinus;
//#ifndef WIN32
	USHORT	KSTARTY;
	USHORT	TopAdd;
//#endif

ULONG	BusProtocol = GrandTech_Scanner_Vendor_USB_Send_Command;
UCHAR	WorkingBuffer[64*1024*4];
USHORT	LineArt_Threshold;
USHORT	RXDPI,RYDPI,ScanLine,LineBytes,CopyLineBytes;

USHORT	TotalReadLine=0,ScalingLines;
UCHAR	*ImageBuffer,*TempImageBuffer;
UCHAR	*RImageBuffer[MAXBUFFERNUMBER];
UCHAR	*GImageBuffer[MAXBUFFERNUMBER];
UCHAR	*BImageBuffer[MAXBUFFERNUMBER];
BOOL	RImageFlag[MAXBUFFERNUMBER];
BOOL	GImageFlag[MAXBUFFERNUMBER];
BOOL	BImageFlag[MAXBUFFERNUMBER];
UCHAR	R_Offset = 32;
UCHAR	R_Gain = 2;
UCHAR	G_Offset = 32;
UCHAR	G_Gain = 2;
UCHAR	B_Offset = 32;
UCHAR	B_Gain = 2 ;
USHORT  RedStop;
USHORT  GreenStop;
USHORT  BlueStop;
USHORT	Left,Right,Top,Bottom;
USHORT  DataAttribute;
USHORT	RawDataFormat;
USHORT	ScanMode;
USHORT	*RInfo_48Bit,*GInfo_48Bit,*BInfo_48Bit;
USHORT	Width,Height,HWWidth,HWHeight;
UCHAR	*RColorTable[MAXWIDTH];
UCHAR	*GColorTable[MAXWIDTH];
UCHAR	*BColorTable[MAXWIDTH];
WORD	*GammaTable;
BOOL	GammaFlag;
UCHAR	DiffLine;
USHORT	ScanType;
USHORT	leftbound;
int		Red,Green,Bule;
UCHAR	BufferFullFlag;
/*****Thread Funcation use ******************************/
#ifdef WIN32
HANDLE  hThread;
ULONG	ThreadSleepMiniSecond = 25;
DWORD   ThreadID;
DWORD   WaitReturnValue;
#endif
USHORT	TotalReadColorLine;
BOOL	EndScan;

/***********************************/

UCHAR	Return_Info[64];
BOOL	success;
USHORT	DataWidth;
USHORT	SWWidth,SWHeight,SMWidth;
USHORT	LeftAdd;
//BOOL	ScalingFlag;
//char	*ImageScalingBuff1,*ImageScalingBuff2;
//UCHAR	*ScalingData;
BOOL	PixelModeFlag;

UCHAR   ibuffer[64];        // howard add
UCHAR   obuffer[64];        // howard add
BOOL ReadimageFail;
//BOOL LINEMODE;

/***Get Line Sub Funcation*****************************************************************************************/
typedef BOOL(* GETLINEDATA)(LPSTR Buf_Address);
GETLINEDATA GetLineData;
#ifdef WIN32
typedef DWORD (WINAPI *GETIMAGEDATA)(LPVOID temp);
#else
typedef DWORD ( *GETIMAGEDATA)(LPVOID temp);
#endif
GETIMAGEDATA ReadImageDataThread;

BOOL Get8BitsColorImageLine(LPSTR Buf_Address);
BOOL Get8BitsGrayImageLine(LPSTR Buf_Address);
BOOL GetLineArtImageLine(LPSTR Buf_Address);
BOOL Get48BitsColorImageByPixel(LPSTR Buf_Address);
BOOL Get48BitsColorImageByLine(LPSTR Buf_Address);
void Grenerator48Bitinfo(USHORT StartX);
BOOL GetPixelModeImageLine(LPSTR Buf_Address);
//BOOL GetScalingImageLine(LPSTR Buf_Address);
/***Get Line Thread Funcation*****************************************************************************************/
#ifdef WIN32
DWORD WINAPI Get8BitColorLineThread(LPVOID temp);
DWORD WINAPI GetPixelColorLineThread(LPVOID temp);
#else
DWORD Get8BitColorLineThread(LPVOID temp);
DWORD GetPixelColorLineThread(LPVOID temp);
#endif
/********************************************************************************************/
int	GetTopBound(USHORT	XDPI);
WORD SetByDPI(WORD inDPI);

#ifdef WIN32
BOOL WINAPI DllMain(HINSTANCE hInstance,DWORD tdwReason,LPVOID pvReserved)
{
	return(TRUE);
}
#endif


BOOL GTInitialation(ULONG BusProtocol,PUCHAR WorkingBuffer)
{
	BOOL	success;
	BOOL    success2;
	ULONG	Device_Number;
	char	FW_Path[255];
	UCHAR   DriverFlag=0x55;
	int		i;
	int 	Test;
	int 	Test1;
	ULONG	DeviceIndexTable[128];
	ULONG	DeviceIndex;
	bool	successtest;
#ifndef WIN32
	FILE * myfile;
	myfile=fopen("MTWM.ini","r+");
/* --- PS2 Definition --- */
	KSTARTY=200;
	TopAdd=350;
	LeftAdd=0;

	if (myfile) fclose(myfile);
#endif
	
#ifdef WIN32
	HMODULE hModule;
	char	iniSection[10]="GTK";
	char	iniFile[100];
	hModule=GetModuleHandle(SPINAME);
	GetModuleFileName(hModule,iniFile,100);
	for(i=strlen(iniFile);i>0;i--){
		if(iniFile[i] == '\\'){
			iniFile[i]='\0';
			break;
		}
	}
	strcat(iniFile,GTINI);

	LeftAdd =0;
	LeftAdd = GetPrivateProfileInt(	iniSection,
									"LEFTADD",
									0,
									iniFile);
	TopAdd  = GetPrivateProfileInt(	iniSection,
									"TOPADD",
									120,
									iniFile);

    	KSTARTY  = GetPrivateProfileInt(iniSection,
									"KSTARTY",
									0,
									iniFile);
#endif

	Device_Number = EnumScannerDevices(BusProtocol,(PULONG)(WorkingBuffer));
	ScannerHandle = INVALID_HANDLE_VALUE;

#ifdef WIN32
	ScannerHandle = OpenCommunicationBus(BusProtocol,0x378,*WorkingBuffer,OPENFLAG);
    
	if(ScannerHandle==INVALID_HANDLE_VALUE)
	{
		return FALSE;
    	}
	GetWindowsDirectory((LPSTR)FW_Path, sizeof(FW_Path));
	lstrcat(FW_Path, "\\system32\\drivers\\");
    	lstrcat(FW_Path,FWFILENAME);
	success2=ProcessCommandAccessDriverFlag(
                                           (HWND)NULL,
									&DriverFlag);
	ibuffer[0]=0x50;
	ibuffer[1]=0x01;
	ibuffer[2]=0x80;
	ibuffer[3]=0x00;
	obuffer[0]=0x00;
	obuffer[1]=0x00;
	obuffer[2]=0x00;
	obuffer[3]=0x00;

	if(DriverFlag != 0x55)
	{
	success = ProcessCommandDownloadFirmware((HWND)NULL,
											 FALSE,
											 ScannerHandle,
											 BusProtocol,
											 (PUCHAR)FW_Path,
											 DownLoadMethod);
	Sleep(100);
	if(success==FALSE)
	{
		ScannerHandle = INVALID_HANDLE_VALUE;
	   return FALSE;
	}
	
	DriverFlag = 0x55;   
	success2=ProcessCommandAccessDriverFlag(
                                           		(HWND)NULL,
										FALSE,
										ScannerHandle,
										BusProtocol,
                                           		0, // write
										&DriverFlag);
	}
		
#else
	
DeviceIndex=0;
	ScannerHandle = OpenCommunicationBus(BusProtocol,
									 0x378,
									 DeviceIndexTable[DeviceIndex],
									 FALSE);

	if(ScannerHandle==INVALID_HANDLE_VALUE)
	{
		return FALSE;
    	}

	success = ProcessCommandDownloadFirmware((HWND)NULL,
										FALSE,
										ScannerHandle,
										BusProtocol,
										"ps1fw.usb",//"\psbfw.usb",
										DownLoadMethod);
	if(success==FALSE)
	{
		ScannerHandle = INVALID_HANDLE_VALUE;
		return FALSE;
	}

#endif
	return success;
}




EXPORT BOOL SpicallOpen(void)
{
BOOL	success;

	success=TRUE;
	success = GTInitialation(BusProtocol,WorkingBuffer);
	  
	if(!success)
	{
		return FALSE;
	}

	ImageBuffer = InitialationShiddingData( RColorTable,
										GColorTable,
										BColorTable,
										RImageBuffer,
										GImageBuffer,
										BImageBuffer);
	TempImageBuffer = (UCHAR *)malloc(MAXWIDTH*3);
	return success;
}

EXPORT BOOL GetVersionInfo(LPVERSION lpVersionInfo)
{
	char   TempBuffer[20];
	int		i,j;
#ifdef WIN32
	HMODULE hModule;
	char	iniSection[10]="GTK";
	char	iniFile[100];

	hModule=GetModuleHandle(SPINAME);
	GetModuleFileName(hModule,iniFile,100);
	for(i=strlen(iniFile);i>0;i--){
		if(iniFile[i] == '\\'){
			iniFile[i]='\0';
			break;
		}
	}
	strcat(iniFile,GTINI);

	char Version[12][20] = {"FW_Customer",
						    "FW_Model",
							"FW_Chip",
							"FW_Ver",
							"Driver_Customer",
							"Driver_Model",
							"Driver_Chip",
							"Driver_Ver",
							"AP_Customer",
							"AP_Model",
							"AP_Chip",
							"AP_Ver"};

#endif	
	lpVersionInfo->ecErrorCode = ERR_SPI_NONE;
	ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x73,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x73,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	FWVersion[0]=Return_Info[0];
	FWVersion[1]=Return_Info[2];
	FWVersion[2]=Return_Info[4];
	FWVersion[3]=Return_Info[6];	
	lpVersionInfo->bMajor = Return_Info[15];
	lpVersionInfo->bMinor = Return_Info[16];

//#ifdef WIN32
	Return_Info[17]=0x02;
	Return_Info[18]=0x00;
	Return_Info[19]=0x01;
	Return_Info[20]=0x00;
	Return_Info[21]=0x01;
	Return_Info[22]=0x68;
	Return_Info[23]=0x02;  // dll version low byte
	Return_Info[24]=0x02;
#ifdef WIN32
	hModule=GetModuleHandle(SPINAME);
		GetModuleFileName(hModule,iniFile,100);
		for(i=strlen(iniFile);i>0;i--){
			if(iniFile[i] == '\\'){
				iniFile[i]='\0';
				break;
			}
		}
		strcat(iniFile,GTINI);

	
	for(i=0,j=1;i<12;i++,j+=2)
	{
		switch(i%4)
		{
		case 0:
			sprintf(TempBuffer,"%2.2d%2.2d",Return_Info[j+1],Return_Info[j]);
			break;
		case 1:
			sprintf(TempBuffer,"%2.2d%2.2d",Return_Info[j+1],Return_Info[j]);
			break;
		case 2:
			sprintf(TempBuffer,"%2.2x%2.2x",Return_Info[j+1],Return_Info[j]);
			break;
		case 3:
			sprintf(TempBuffer,"%2.2x.%2.2x",Return_Info[j+1],Return_Info[j]);
			break;
		}
    	WritePrivateProfileString("VERSION",
					          Version[i],
							  TempBuffer,
						      iniFile);
	}
#endif
	return TRUE;
}

EXPORT	BOOL GetDeviceInfo(LPDEVICEINFO lpDeviceInfo)
{
#ifdef WIN32	
	ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x73,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	_itoa( Return_Info[2],&versionbuffer[32],10);
	_itoa( Return_Info[1],&versionbuffer[33],10);
	_itoa( Return_Info[4],&versionbuffer[34],10);
	_itoa( Return_Info[3],&versionbuffer[35],10);

#endif	
	lpDeviceInfo->ecErrorCode = ERR_SPI_NONE;
	lpDeviceInfo->iiInterface = 2;
	lpDeviceInfo->wPortAddr = 0;
	lpDeviceInfo->pmParallelMode = 0;
	lpDeviceInfo->wSizeOfInfo = 96;
	lpDeviceInfo->sbSlideKitInstalled = 0;
	lpDeviceInfo->sbADFInstalled = 0;
	lpDeviceInfo->sbDownLoadGamma = 1;
	lpDeviceInfo->bInputGammaBits = 8;
	lpDeviceInfo->bOutputGammaBits = 8;
	lpDeviceInfo->sbCanTriggerPrescan = 0;
	lpDeviceInfo->sbCanTriggerscan = 0;
	lpDeviceInfo->sbCanTriggerAP =0;
	return TRUE;
}

EXPORT BOOL GetGammaInfo(LPGAMMAINFO lpGammaInfo)
{
	lpGammaInfo->ecErrorCode = ERR_SPI_NONE;
	switch(lpGammaInfo->smScanMode)
	{
	case 0:
	case 1:
	case 2:
		lpGammaInfo->wInputGammaBits = 8;
		lpGammaInfo->wOutputGammaBits =8;
		break;
	case 10:
		lpGammaInfo->wInputGammaBits = 8;
		lpGammaInfo->wOutputGammaBits =8;
		break;
	default:
		lpGammaInfo->wInputGammaBits = 8;
		lpGammaInfo->wOutputGammaBits =8;
		break;
	}
	return TRUE;
}
EXPORT BOOL SetParameters(LPSETPARAMETERS lpSetPar)
{
	int	i;
	UCHAR   DriverFlag;
	ULONG	Device_Number;
	char	FW_Path[255];
//	ULONG   nBytesRead; 

#ifdef WIN32
	myscantotaltime=0;	
        DriverFlag=0x00;
	success=ProcessCommandAccessDriverFlag(
                                           		(HWND)NULL,
										FALSE,
										ScannerHandle,
										BusProtocol,
                                           		1,
										&DriverFlag);
	ibuffer[0]=0x50;
	ibuffer[1]=0x01;
	ibuffer[2]=0x80;
	ibuffer[3]=0x00;
	obuffer[0]=0x00;
	obuffer[1]=0x00;
	obuffer[2]=0x00;
	obuffer[3]=0x00;

	if(DriverFlag != 0x55)
	{
		Device_Number = EnumScannerDevices(BusProtocol,(PULONG)(WorkingBuffer));
	        ScannerHandle = OpenCommunicationBus(BusProtocol,0x378,WorkingBuffer[0],OPENFLAG);
            	if(ScannerHandle==INVALID_HANDLE_VALUE)
		          return FALSE;

	        GetWindowsDirectory((LPSTR)FW_Path, sizeof(FW_Path));
            	lstrcat(FW_Path, "\\system32\\drivers\\");
                lstrcat(FW_Path,FWFILENAME);
	        success = ProcessCommandDownloadFirmware((HWND)NULL,
											 FALSE,
											 ScannerHandle,
											 BusProtocol,
											 (PUCHAR)FW_Path,
											 DownLoadMethod);
           
             	Sleep(100);
		DriverFlag = 0x55;  
		success=ProcessCommandAccessDriverFlag(
                                         			(HWND)NULL,
										   	FALSE,
										   	ScannerHandle,
										  	BusProtocol,
                                           			0,
										   	&DriverFlag); 
	}
#endif
	for(i=0;i<MAXBUFFERNUMBER;i++)
	{
		RImageFlag[i] = TRUE;
		GImageFlag[i] = TRUE;
		BImageFlag[i] = TRUE;
	}
#ifdef WIN32
	memset(ImageBuffer,0,(MAXWIDTH * MAXBUFFERNUMBER*3));
#endif	

	GammaTable = (WORD *)lpSetPar->pGammaTable;

	if((lpSetPar->pGammaTable == NULL))
	{
		GammaFlag = TRUE;
		GammaTable = (WORD *)malloc(MAXSHIDDING*2*3);
		for(i=0;i<MAXSHIDDING;i++)
		{
			*(GammaTable+i) = i;
			*(GammaTable+i+256) = i;
			*(GammaTable+i+512) = i;
		}
	}
	else
	{
		GammaFlag = FALSE;
	}



	Left = (USHORT)(lpSetPar->fmArea.x1 * XMAXDPI /300);
    	Top = (USHORT)(lpSetPar->fmArea.y1  * YMAXDPI /300);

	Right = lpSetPar->fmArea.x2;
	

	Bottom = lpSetPar->fmArea.y2;
	Width = (lpSetPar->fmArea.x2 - lpSetPar->fmArea.x1);
	Height = (lpSetPar->fmArea.y2 - lpSetPar->fmArea.y1);
	PixelModeFlag = LINEMODE;

	lpSetPar->wTargetDPI = SetByDPI(lpSetPar->wTargetDPI);

	if((lpSetPar->smScanMode!=2) && (lpSetPar->smScanMode!=10))
		PixelModeFlag = LINEMODE;
#ifndef WIN32
//	BufferFullFlag = BIBF_OFF;
#endif
	lpSetPar->ecErrorCode =  ERR_SPI_NONE;
	
	LineArt_Threshold = lpSetPar->wLinearThreshold;
	DataAttribute = lpSetPar->pfPixelFlavor;
	SMWidth = Width * lpSetPar->wTargetDPI /300;
	ScanLine = Height * lpSetPar->wTargetDPI /300;
	RXDPI = lpSetPar->wTargetDPI;
	RYDPI = lpSetPar->wTargetDPI;
	Width = Width*(XMAXDPI/300);
	Height = Height*(XMAXDPI/300);
	DiffLine = LAMPSTEP * lpSetPar->wTargetDPI / XMAXDPI;
	SWWidth = (((SMWidth+1)>>1)<<1);
	Height = Height+LAMPSTEP*2 + 1;
	SWHeight = ScanLine+DiffLine*2 + 1;

	switch(lpSetPar->smScanMode)
	{
	case 0:  // line art
	//	BufferFullFlag = BIBF_ON;
		ScanType = GreenMode;
		DataWidth = 8;
		RawDataFormat = RDF_Optimize;
		Width = ((Width+7) >>3)<<3;
		SMWidth = ((SMWidth +7) >>3)<<3;
		SWWidth = (((SMWidth+1)>>1)<<1);
		CopyLineBytes = LineBytes = SMWidth/8;
		GetLineData = GetLineArtImageLine;
#ifdef WIN32
		ReadImageDataThread = GetPixelColorLineThread;
#endif
		ScanMode = 0;
		break;
	case 1:   // gray
	//	BufferFullFlag = BIBF_ON;
		ScanType = GreenMode;
		DataWidth = 8;
		CopyLineBytes = LineBytes = SMWidth;
		
		RawDataFormat = RDF_Optimize;
		GetLineData = Get8BitsGrayImageLine;
#ifdef WIN32
		ReadImageDataThread = GetPixelColorLineThread;
#endif
		ScanMode = 1;
				break;
	case 2:   // 24 bit color
		ScanType = ColorMode;
		DataWidth = 8;
		CopyLineBytes = LineBytes = SMWidth * 3;
		RawDataFormat = RDF_Optimize;
		if(PixelModeFlag)
		{
			GetLineData = GetPixelModeImageLine;
#ifdef WIN32
			ReadImageDataThread = GetPixelColorLineThread;
#endif
		}
		else
		{
#ifdef WIN32
 				ReadImageDataThread = Get8BitColorLineThread;
#endif
				GetLineData = Get8BitsColorImageLine; // line mode
		}
		ScanMode =2;
		break;
	case 10:   // 48 bit
		ScanType = ColorMode;
		DataWidth = 8;
		CopyLineBytes = LineBytes = SMWidth * 6;
		RawDataFormat = RDF_Optimize;
		if(PixelModeFlag)
		{
			GetLineData = Get48BitsColorImageByPixel;
#ifdef WIN32
			ReadImageDataThread = GetPixelColorLineThread;
#endif
		}
		else
		{
#ifdef WIN32
				ReadImageDataThread = Get8BitColorLineThread;
#endif
				GetLineData = Get48BitsColorImageByLine;
		}
		ScanMode = 10;
		break;
	}
	TotalReadColorLine =0;	
	return success;
}
EXPORT BOOL GetParameters(LPGETPARAMETERS lpGetPar)
{		
	lpGetPar->ecErrorCode = ERR_SPI_NONE;
	lpGetPar->wSourceXDPI = RXDPI;
	lpGetPar->wSourceYDPI = RYDPI;
	lpGetPar->dwLength = (WORD)(ScanLine);
	lpGetPar->dwLineByteWidth = (DWORD)(LineBytes);
	
	return TRUE;
}
EXPORT BOOL StartScan(LPCOMMON lpStartScan)
{
	int  TopLine;
	int  myStarty;
	USHORT kline;
//	UCHAR iobuffer[64]; 
	USHORT	cDPI;
	int test0,test1,test2,test3,test4,test5;

#ifdef WIN32
	lpStartScan->ecErrorCode= ERR_SPI_ACKPROGRESSCALLBACK;
#else
	lpStartScan->ecErrorCode = ERR_SPI_NONE;
#endif

//--------------------------------------------------------------------------------
	leftbound =0;
	TopLine = 0;
	ReadimageFail = FALSE;

//#ifdef	_1200DPI_
//	if(RXDPI == 1200)
	if(RXDPI>=1200)
		cDPI = 1200;
	else
		//cDPI=600;
		cDPI=RXDPI;
//#else
//	cDPI = 600;
//#endif
	leftbound =0;
   
	if(FirstCalibrate)
	{
	
	success=gtcalibrate(ScannerHandle,
				KSTARTY,
				2,//1,
				SENSORTYPE,
				(&R_Offset),
				(&R_Gain),
				(&G_Offset),
				(&G_Gain),
				(&B_Offset),
				(&B_Gain),
				15,

#ifndef _CCD_SCANNER_      // CIS
                            
				(UCHAR)LINEMODE,
				(USHORT)600,
#else                     // CCD 
				PixelModeFlag,
				cDPI,//XMAXDPI,
#endif
				&leftbound,
				MAXWIDTH,
				&RedStop,
				&GreenStop,
				&BlueStop,
#ifndef _CCD_SCANNER_ 
				4//ColorMode
#else
			    ScanType	
#endif
				);

	
	test0=R_Gain;
	test1=G_Gain;
	test2=B_Gain;
	test3=R_Offset;
	test4=G_Offset;
	test5=B_Offset;
	
#ifndef _CCD_SCANNER_
       FirstCalibrate=FALSE;	   
#endif

	}
				
	if(!success)
	{
		return FALSE;
	}
				
#ifdef _CCD_SCANNER_
//#ifdef	_1200DPI_
	if(leftbound>400)
		leftbound = 340;
	else{
		leftbound*=2;
	}
	TopLine = GetTopBound(600); 
	TopLine = TopLine*2;
#else
	leftbound=0;
	TopLine=0;
#endif
    if(RXDPI<=300)
	{
		kline=150;
	}else
	{
		kline=40;
	}
#ifdef A1
	kline=50;
#endif	
	
	success=CreateShaddingTable(ScannerHandle,
						(USHORT)KSTARTY,
						(USHORT)kline,//50,
						(USHORT)SENSORTYPE,
						R_Offset,
						R_Gain,
						G_Offset,
						G_Gain,
						B_Offset,
						B_Gain,
						RColorTable,
						GColorTable,
						BColorTable,
						(USHORT)RXDPI,
						(USHORT)RYDPI,
                        (USHORT)(Left + leftbound + LeftAdd),
    #ifndef _CCD_SCANNER_ 
    					(UCHAR)LINEMODE,
    #else					                    
						(UCHAR)PixelModeFlag,
	#endif					
						(USHORT)Width,
		#ifndef _CCD_SCANNER_ 
						ColorMode
		#else
					    (USHORT)ScanType	
		#endif						
						);
						
						
	if(!success)
	{
		return FALSE;
	}
				
////////////////////////////////////////////////

	if(ScanMode ==10)
	{
		Grenerator48Bitinfo((Left + leftbound));
	}
//	if(SWWidth <64)
//		SWWidth = 64;
#ifdef	_1200DPI_
	HeightMinus = (USHORT)(10 * XMAXDPI / RXDPI);
#else
	if(RXDPI >= 600)
	{
		HeightMinus=10;
	}
	else if(RXDPI >= 300)
	{
		HeightMinus=20;
	}else if(RXDPI >= 150)
	{
		HeightMinus=40;
	}else if(RXDPI >= 75)
	{
		HeightMinus=80;
	}else if(RXDPI >= 50)
	{
		HeightMinus=120;
	}else
	{
		HeightMinus=120;
	}
#endif
	SWHeight+=10;
	FirstScan=TRUE; 
	ProcessCommandRetrieveNecessaryInfo2(
					 (HWND)NULL,
					 FALSE,
					 ScannerHandle,
					 BusProtocol,
					 LAMPORDER,
					 LAMPSTEP,
					 ScanType,
					 XMAXDPI,
					 YMAXDPI,
					 RXDPI,
					 RYDPI,
					 Width,
					 (Height+HeightMinus),
					 &HWWidth,
					 &HWHeight,
					 &SWWidth,
					 &SWHeight,
					 WorkingBuffer);
    myStarty=(Top+TopLine+TopAdd)-HeightMinus;
	if(myStarty < 0) myStarty=0;
	success = ProcessCommandSetScanWindow3(
				   (HWND)NULL,
				   FALSE,
				   ScannerHandle,
				   BusProtocol,
				   (Left + leftbound + LeftAdd),
				   (USHORT)myStarty,
				   HWWidth,
				   HWHeight,
				   RXDPI,
				   SWWidth,									   
				   SWHeight+4,
				   ScanType,
				   DataWidth,
				   0,
				   TESTMODE,
				   BufferSize16K,
				   DataAttribute,
				   (USHORT)(BusProtocol),
				   SENSORTYPE,
				   0,
				   SAS_OFF,
				   SBS_OFF,
				   SOS_OFF,
				   BufferFullFlag,
				   0,
				   LOOS_OFF,
				   ABW_OFF,
				   PixelModeFlag,
				   RYDPI,

#ifdef _CCD_SCANNER_
				   60,
#else
				   16,//motor back step if BIBF=ON;
#endif
				   RawDataFormat);
	success = ProcessCommandSetGTAFEGain(
									   (HWND)NULL,
									   FALSE,
									   ScannerHandle,
									   BusProtocol,
									   (UCHAR)R_Offset,
									   (UCHAR)R_Gain,
									   (UCHAR)G_Offset,
									   (UCHAR)G_Gain,
									   (UCHAR)B_Offset,
									   (UCHAR)B_Gain);
#ifndef _CCD_SCANNER_
	success=ProcessCommandSetExposureTime(
                         (HWND)NULL,
                         FALSE,
                         ScannerHandle,
                         BusProtocol,
                         4,
                         RedStop,
                         4,
                         GreenStop,
                         4,
                         BlueStop);

#endif
	EndScan = FALSE;

#ifdef GT6816
	success=PollingMotor(ScannerHandle);
#endif
//---------------------------------------------------------------------------------------
	success = ProcessCommandSetStartScan(
									(HWND)NULL,
									FALSE,		
									ScannerHandle,
									BusProtocol);

	
	TotalReadLine = 0;
	ScalingLines = 0;

#ifdef WIN32
	hThread = CreateThread(	NULL,
						0x01,
						ReadImageDataThread,
						NULL,
						0,
						&ThreadID);
#else
success = ProcessCommandWaitScannerReady(
								(HWND)NULL,
								FALSE,
								ScannerHandle,
								BusProtocol,
								1000);


#endif
	return success;
}
EXPORT BOOL CarriageHome(LPCOMMON lpCommon)
{
	lpCommon->ecErrorCode = ERR_SPI_NONE;
#ifndef GT6816
	success = ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x12,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	success = ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x24,
								 Return_Info,
								 64,
								 Return_Info,
								 64);

#endif
	return success;
}
EXPORT BOOL StopScan(LPCOMMON lpCommon)
{
	lpCommon->ecErrorCode = ERR_SPI_NONE;
	EndScan = TRUE;

#ifdef WIN32
	sprintf(DebugBuffer,"my scan total time %d",myscantotaltime);
	WaitForSingleObject(hThread,5000);
//	MessageBox(NULL,"endscan ","",MB_OK);
	CloseHandle(hThread);
#endif
#ifdef GT6816
	success=EndScan41(ScannerHandle);
#else	
	
	success = ProcessCommandSetEndScan(
										(HWND)NULL,
										FALSE,
										ScannerHandle,
										BusProtocol);
	
#endif
#ifdef WIN32
		Return_Info[0] = 0x74;
		Return_Info[1] = 0x01;
        
		success=DeviceIoControl(ScannerHandle,
		                   IOCTL_GrandTech_Scanner_STI_Send_Command,
		                   Return_Info,
		                   64,
		                   Return_Info,
		                   64,
		                   &nBytesRead,
		                   NULL);
		success=DeviceIoControl(ScannerHandle,
		                   IOCTL_GrandTech_Scanner_STI_Get_Status,
		                   Return_Info,
		                   64,
		                   Return_Info,
		                   64,
		                   &nBytesRead,
		                   NULL);

#endif	
	if(GammaFlag)
		free(GammaTable);
	if(ScanMode == 10)
	{
		free(RInfo_48Bit);
		free(GInfo_48Bit);
		free(BInfo_48Bit);
	}
	return success;
}
#ifdef WIN32
EXPORT BOOL SpicallClose(void)
{
    

	//OutputDebugString("----------------Close\n");  
	if(ScannerHandle != INVALID_HANDLE_VALUE)
	{
	   // MessageBox(NULL,"close","",MB_OK);
       
	  success = CloseCommunicationBus(
									ScannerHandle,
									BusProtocol,
									0x378,
									0,
									FALSE);
	 
	 ScannerHandle = INVALID_HANDLE_VALUE  ;

	for(int i =0;i<(MAXWIDTH);i++)
	{
		free(*(RColorTable+i));
		free(*(GColorTable+i));
		free(*(BColorTable+i));
	}

	free(ImageBuffer);
	free(TempImageBuffer);	
	}else
	{
	}
  return success;
}
#else
EXPORT BOOL SpicallClose(void)
{
    

	//OutputDebugString("----------------Close\n");  
	if(ScannerHandle != INVALID_HANDLE_VALUE)
	{
	   // MessageBox(NULL,"close","",MB_OK);
       
	  success = CloseCommunicationBus(
									ScannerHandle,
									BusProtocol,
									0x378,
									0,
									FALSE);
	 
	 ScannerHandle = INVALID_HANDLE_VALUE  ;


	free(ImageBuffer);
	free(TempImageBuffer);	
	}else
	{
	}
  return success;
}
#endif
//-----Get a image for line by Lineart mode----------------------------------------
BOOL GetLineArtImageLine(LPSTR Buf_Address)
{
#ifdef WIN32
	int		i,j;
	UCHAR	Temp;

	if(!ReadimageFail)
	{
		while(RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE)
		{
			Sleep(100);
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return TRUE;
		}
		for(Temp=0,i=0,j=0;i<SMWidth;i++)
		{

			if( (BYTE)(*(GammaTable + *(GColorTable[i] + *(ImageBuffer + SWWidth*(TotalReadLine % MAXBUFFERNUMBER)+i))))>LineArt_Threshold) 
				Temp = (Temp <<1 )+1;
			else
				Temp = (Temp <<1 );
			if(((i%8)==7)&&(i>0)) 
			{
				*(Buf_Address+j) = Temp;
				j++;
				Temp =0;
			}
		}
		*(Buf_Address+j) = Temp;
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else
		return FALSE;
#else
	ULONG	SizeInBytesToRead,SizeInBytesRead;
	UCHAR	*RColor,*GColor,*BColor,Temp;
	int		i,j,k;
	
	SizeInBytesToRead = SWWidth;
	if(!ReadimageFail)
	{
		while((RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
		
			ProcessCommandReadImage(
									(HWND)NULL,
									FALSE,
									ScannerHandle,
									GrandTech_Scanner_Vendor_USB_Send_Command,
									DataWidth,
									SWWidth,//SizeInBytesToRead,
									(ImageBuffer + SizeInBytesToRead*(TotalReadColorLine % MAXBUFFERNUMBER)),
									SizeInBytesToRead,
									&SizeInBytesRead,
									NULL);
									
			RImageFlag[(TotalReadColorLine % MAXBUFFERNUMBER)] = FALSE;
			TotalReadColorLine++;
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
		}
		for(Temp=0,i=0,j=0;i<SMWidth;i++)
		{

			if( (BYTE)(*(GammaTable + *(GColorTable[i] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+i))))>LineArt_Threshold) 
				Temp = (Temp <<1 )+1;
			else
				Temp = (Temp <<1 );
			if(((i%8)==7)&&(i>0)) 
			{
				*(Buf_Address+j) = Temp;
				j++;
				Temp =0;
			}
		}
		*(Buf_Address+j) = Temp;

		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else 
		return FALSE;

#endif		
}

BOOL Get8BitsColorImageLine(LPSTR	Buf_Address)
{
#ifdef WIN32
	WORD	j,k;
	if(!ReadimageFail)
	{
#ifdef _CCD_SCANNER_
		while((BImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (GImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
#else
		while((RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) ||
			  (GImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) ||
			  (BImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
#endif
				{
				Sleep(100);
				if(EndScan==TRUE)
					break;
				if(ReadimageFail)
					return FALSE;
			}
		for(j=0,k=0;j<CopyLineBytes;j+=3,k++)
		{
#ifdef _1200DPI_
	#ifdef _CCD_SCANNER_
			  *(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] +*(RImageBuffer[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)]+k))));
			  *(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] +*(RImageBuffer[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)]+k))));	
			  *(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] +*(RImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+k))));
		#else
				*(Buf_Address+Bule+j) =  (BYTE)(*(GammaTable + *(BColorTable[k] + *(BImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
				*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(GImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
				*(Buf_Address+Red+j) =   (BYTE)(*(GammaTable + *(RColorTable[k] + *(RImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
		#endif
#else
		#ifdef _CCD_SCANNER_
				*(Buf_Address+Bule+j) =  (BYTE)(*(GammaTable + *(BColorTable[k] + *(BImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+k))));
				*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(GImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+k))));
				*(Buf_Address+Red+j) =   (BYTE)(*(GammaTable + *(RColorTable[k] + *(RImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+k))));
		#else
				*(Buf_Address+Bule+j) =  (BYTE)(*(GammaTable + *(BColorTable[k] + *(BImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
				*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(GImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
				*(Buf_Address+Red+j) =   (BYTE)(*(GammaTable + *(RColorTable[k] + *(RImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+ k))));
		#endif
#endif
			}
			RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
			GImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
			BImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else
		return FALSE;
#else
	ULONG	SizeInBytesToRead,SizeInBytesRead;
	UCHAR	*RColor,*GColor,*BColor;
	int		j,k;
	
	SizeInBytesToRead = SWWidth*3;
	//if(RYDPI<50) 
	//{TotalReadLine*=2;
		//CopyLineBytes*=2;
	//	}
	if(!ReadimageFail)
	{
		while((RImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
		
			ProcessCommandReadImage(
									(HWND)NULL,
									FALSE,
									ScannerHandle,
									GrandTech_Scanner_Vendor_USB_Send_Command,
									DataWidth,
									SWWidth,//SizeInBytesToRead,
									(ImageBuffer + SizeInBytesToRead*(TotalReadColorLine % MAXBUFFERNUMBER)),
									SizeInBytesToRead,
									&SizeInBytesRead,
									NULL);
									
			RImageFlag[(TotalReadColorLine % MAXBUFFERNUMBER)] = FALSE;
			TotalReadColorLine++;
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
		}
		for(j=0,k=0;j<CopyLineBytes;j+=3,k++)
		{

	#ifdef _CCD_SCANNER_
			*(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
			*(Buf_Address+Bule+j) = (BYTE)(*(GammaTable + *(BColorTable[k] +*(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
	#else
			RColor = RColorTable[k];
			GColor = GColorTable[k];
			BColor = BColorTable[k];
//			*(Buf_Address+Red+j)   = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(RColor + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
//			*(Buf_Address+Green+j) = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
//			*(Buf_Address+Bule+j)  = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(BColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
			*(Buf_Address+Red+j)   = (BYTE)(*(GammaTable + *(RColor + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+k+SWWidth*2))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable+256 + *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+k+SWWidth))));
			*(Buf_Address+Bule+j)  = (BYTE)(*(GammaTable +512+ *(BColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+k))));
	#endif
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else 
		return FALSE;
#endif		
	return TRUE;		
}





BOOL Get8BitsGrayImageLine(LPSTR	Buf_Address)
{
#ifdef WIN32
	int i;
	if(!ReadimageFail)
	{
//#ifdef _1200DPI_
//		while((BImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
//			  (GImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
//			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
//#else
		while(RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) 
//			  (GImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) ||
//			  (BImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
//#endif
			{
				Sleep(100);
				if(EndScan==TRUE)
					break;
				if(ReadimageFail)
					return FALSE;
			}
		for(i=0;i<CopyLineBytes,i++)
		{
	
			*(Buf_Address+i) = (BYTE)(*(GammaTable + *(GColorTable[i] + *(ImageBuffer + SWWidth*(TotalReadLine % MAXBUFFERNUMBER)+i))));
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
		TotalReadLine++;
		return TRUE;
	
	}
	else
		return FALSE;
#else
	ULONG	SizeInBytesToRead,SizeInBytesRead;
	UCHAR	*RColor,*GColor,*BColor;
	int		j,k;
	SizeInBytesToRead = SWWidth;
	if(!ReadimageFail)
	{
//		while((RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
	/*	GTReadImage((ULONG) GrandTech_Scanner_Vendor_USB_Send_Command,
        			 (ULONG)      NULL,
        			       ScannerHandle,
        			      (void *)(ImageBuffer + SizeInBytesToRead*(TotalReadColorLine % MAXBUFFERNUMBER)),
        				      SizeInBytesToRead,
      					      &SizeInBytesRead,
        					(void *)	 NULL );

	*/	
		
			ProcessCommandReadImage(
									(HWND)NULL,
									FALSE,
									ScannerHandle,
									GrandTech_Scanner_Vendor_USB_Send_Command,
									DataWidth,
									SWWidth,//SizeInBytesToRead,
									(ImageBuffer + SizeInBytesToRead*(TotalReadColorLine % MAXBUFFERNUMBER)),
									SizeInBytesToRead,
									&SizeInBytesRead,
									NULL);
									
			RImageFlag[(TotalReadColorLine % MAXBUFFERNUMBER)] = FALSE;
			TotalReadColorLine++;
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
		}
		for(j=0,k=0;j<CopyLineBytes;j++,k++)
		{

	//#ifdef _1200DPI_
	#ifdef _CCD_SCANNER_
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j))));
	#else
			GColor = GColorTable[k];
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+k))));
			//*(Buf_Address+Green+j) = (BYTE)(*(GammaTable+ *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+k+SWWidth*3))));
	#endif
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else 
		return FALSE;
#endif		
	return TRUE;		
}

void Grenerator48Bitinfo(USHORT StartX)
{

#ifdef WIN32
	OVERLAPPED    h_Overlapped;
	HANDLE        h_hEvents;
	DWORD         status;
	DWORD         h_dwError;
	PUCHAR        TempBuffer;
	int			  i,j,k,jj;
	DWORD         nBytesRead; 
	USHORT		  SWWidth,SWHeight;
    
    /*
	ProcessCommandRetrieveNecessaryInfo3(
										 NULL,
										 FALSE,
										 ScannerHandle,
										 BusProtocol,
										 LAMPORDER,
										 LAMPSTEP,
										 ScanType,
										 XMAXDPI,
										 YMAXDPI,
										 RXDPI,
										 600,
										 SWWidth,
										 128,
										 &HWWidth,
										 &HWHeight,
										 WorkingBuffer);
	*/									 
   
	ProcessCommandRetrieveNecessaryInfo2(
										 (HWND)NULL,
										 FALSE,
										 ScannerHandle,
										 BusProtocol,
										 LAMPORDER,
										 LAMPSTEP,
										 ScanType,
										 XMAXDPI,
										 YMAXDPI,
										 RXDPI,
										 YMAXDPI,
										 Width,
										 128,//Height
										 &HWWidth,
										 &HWHeight,
										 &SWWidth,
										 &SWHeight,
										 WorkingBuffer);
     
	RInfo_48Bit = (USHORT *)calloc(SWWidth,2);
	GInfo_48Bit = (USHORT *)calloc(SWWidth,2);
	BInfo_48Bit = (USHORT *)calloc(SWWidth,2);
	TempBuffer = (PUCHAR)malloc((SWWidth*3 * 32));
	for(j=0;j<2;j++)
	{
	success = ProcessCommandSetScanWindow3(
										   (HWND)NULL,
										   FALSE,
										   ScannerHandle,
										   BusProtocol,
										   StartX,
										   KSTARTY,
										   HWWidth,
										   HWHeight,
									       RXDPI,
										   SWWidth,
										   SWHeight+10,
										   ScanType,
										   DataWidth,
										   0,
										   TESTMODE,
										   BufferSize16K,
										   DataAttribute,
										   (USHORT)(BusProtocol),
										   SENSORTYPE,
										   0,
										   SAS_OFF,
										   SBS_OFF,
										   SOS_OFF,
#ifdef WIN32
										   BufferFullFlag,
#else
										   BufferFullFlag,//BIBF_OFF,
#endif
										   0,
										   LOOS_OFF,
										   ABW_OFF,
										   PixelModeFlag,
										   600,
										   16,//0,
										   RawDataFormat);
	success = ProcessCommandSetGTAFEGain(
									   NULL,
									   FALSE,
									   ScannerHandle,
									   BusProtocol,
									   (UCHAR)R_Offset,
									   (UCHAR)R_Gain,
									   (UCHAR)G_Offset,
									   (UCHAR)G_Gain,
									   (UCHAR)B_Offset,
									   (UCHAR)B_Gain);
#ifndef _CCD_SCANNER_
	success=ProcessCommandSetExposureTime(
                         NULL,
                         FALSE,
                         ScannerHandle,
                         BusProtocol,
                         4,
                         RedStop,
                         4,
                         GreenStop,
                         4,
                         BlueStop);
#endif
#ifdef GT6816
	success=PollingMotor(ScannerHandle);
#endif

	success = ProcessCommandSetStartScan(
										 NULL,
										 FALSE,
										 ScannerHandle,
										 BusProtocol);
	success = ProcessCommandWaitScannerReady(
											 NULL,
											 FALSE,
											 ScannerHandle,
											 BusProtocol,
											 1000);

	Sleep(100);

	for(i=0;i<4;i++)
	{
		 h_hEvents=CreateEvent(NULL,TRUE,FALSE,NULL); 
	     h_Overlapped.hEvent = h_hEvents;
         h_Overlapped.Offset = 0;
		 ReadFile(ScannerHandle,
		          TempBuffer,
		          (SWWidth*3*32), 
		          &h_dwError,
                  &h_Overlapped); 
		 status=WaitForSingleObject(h_hEvents,12000);
		 GetOverlappedResult(ScannerHandle,&h_Overlapped,&nBytesRead,TRUE);
		 for(jj=0;jj<32;jj++)
		 {
			if(PixelModeFlag==PIXELMODE)
			 {
			 for(k=0;k<SWWidth;k++)
			 {
				 *(RInfo_48Bit+k) += *(GammaTable + *(RColorTable[k] + *(TempBuffer+k*3+0 + SWWidth*3*jj)));
				 *(GInfo_48Bit+k) += *(GammaTable + 256 + *(GColorTable[k] + *(TempBuffer+k*3+1 + SWWidth*3*jj)));
				 *(BInfo_48Bit+k) += *(GammaTable + 512 + *(BColorTable[k] + *(TempBuffer+k*3+2 + SWWidth*3*jj)));
			 }
			}else
			{
			  for(k=0;k<SWWidth;k++)
			   {
				 *(RInfo_48Bit+k) += *(GammaTable + *(RColorTable[k] + *(TempBuffer+k + SWWidth*3*jj)));
				 *(GInfo_48Bit+k) += *(GammaTable + 256 + *(GColorTable[k] + *(TempBuffer+SWWidth+k  + SWWidth*3*jj)));
				 *(BInfo_48Bit+k) += *(GammaTable + 512 + *(BColorTable[k] + *(TempBuffer+SWWidth*2+k+ SWWidth*3*jj)));
			   }
			}

		 }
	}
#ifdef GT6816
	success=EndScan41(ScannerHandle);
#else		
	success = ProcessCommandSetEndScan(
										NULL,
										FALSE,
										ScannerHandle,
										BusProtocol);
#endif	
	}
	free(TempBuffer);
#endif
}
BOOL Get48BitsColorImageByPixel(LPSTR	Buf_Address)
{

	WORD	i,j,k;
	ULONG	SizeInBytesToRead;
	float	Temp;
	SizeInBytesToRead = SWWidth*3;
	if(!ReadimageFail)
	{
		while((RImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
			Sleep(100);
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
		}

		for(i=0,j=0,k=0;j<CopyLineBytes;j+=6,i++,k+=3)
		{
			Temp = (float)(*(GammaTable + *(RColorTable[i] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+k)))) * 256 / (float)(*(RInfo_48Bit+i));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Red*2)+j)     = LOBYTE((WORD)(Temp * 65535 ) );
			*(Buf_Address+(Red*2)+j+1)   = HIBYTE((WORD)(Temp * 65535) );
			Temp = (float)(*(GammaTable + 256 + *(GColorTable[i] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+k+1)))) * 256 / (float)(*(GInfo_48Bit+i));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Green*2)+j)   = LOBYTE((WORD)(Temp*65535) );
			*(Buf_Address+(Green*2)+j+1) = HIBYTE((WORD)(Temp*65535) );
			Temp = (float)(*(GammaTable + 512 + *(BColorTable[i] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+k+2)))) * 256 / (float)(*(BInfo_48Bit+i));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Bule*2)+j)	 = LOBYTE((WORD)(Temp*65535) );
			*(Buf_Address+(Bule*2)+j+1)  = HIBYTE((WORD)(Temp*65535) );
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else
		return FALSE;

}
BOOL Get48BitsColorImageByLine(LPSTR	Buf_Address)
{
	WORD	j,k;
	float	Temp;
	if(!ReadimageFail)
	{
#ifdef _CCD_SCANNER_
		while((BImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (GImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
#else
		while((RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) ||
			  (GImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE) ||
			  (BImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
#endif
			{
				Sleep(100);
				if(EndScan==TRUE)
					break;
				if(ReadimageFail)
					return FALSE;
			}
		for(j=0,k=0;j<CopyLineBytes;j+=6,k++)
		{
			Temp = (float)(*(GammaTable + *(RColorTable[k] + *(RImageBuffer[(TotalReadLine % MAXBUFFERNUMBER)]+k)))) * 256 / (float)(*(GInfo_48Bit+k));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Red*2)+j)     = LOBYTE((WORD)(Temp * 65535));
			*(Buf_Address+(Red*2)+j+1)   = HIBYTE((WORD)(Temp * 65535));
			Temp = (float)(*(GammaTable + 256 + *(GColorTable[k] + *(GImageBuffer[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)]+k)))) * 256 / (float)(*(GInfo_48Bit+k));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Green*2)+j)   = LOBYTE((WORD)(Temp * 65535));
			*(Buf_Address+(Green*2)+j+1) = HIBYTE((WORD)(Temp * 65535));
			Temp = (float)(*(GammaTable + 512 + *(BColorTable[k] + *(BImageBuffer[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)]+k)))) * 256 / (float)(*(BInfo_48Bit+k));
			if(Temp > 1.0F)
				Temp = 1.0;
			*(Buf_Address+(Bule*2)+j)	 = LOBYTE((WORD)(Temp * 65535));
			*(Buf_Address+(Bule*2)+j+1)  = HIBYTE((WORD)(Temp * 65535));
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
		GImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
		BImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else
		return FALSE;
}

BOOL GetPixelModeImageLine(LPSTR	Buf_Address)
{
#ifdef WIN32
	ULONG	SizeInBytesToRead;
	int		j,k;
	SizeInBytesToRead = SWWidth*3;
	if(!ReadimageFail)
	{
		while((RImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
				Sleep(100);
		}
		for(j=0,k=0;j<CopyLineBytes;j+=3,k++)
		{

	#ifdef _1200DPI_
			*(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
			*(Buf_Address+Bule+j) = (BYTE)(*(GammaTable + *(BColorTable[k] +*(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
	#else
			*(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
			*(Buf_Address+Bule+j) = (BYTE)(*(GammaTable + *(BColorTable[k] +*(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
	#endif
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else 
		return FALSE;
#else
	ULONG	SizeInBytesToRead,SizeInBytesRead;
	UCHAR	*RColor,*GColor,*BColor;
	int		j,k;
	SizeInBytesToRead = SWWidth*3;
	if(!ReadimageFail)
	{
		while((RImageFlag[((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)] == TRUE) ||
			  (RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] == TRUE))
		{
		
			ProcessCommandReadImage(
									(HWND)NULL,
									FALSE,
									ScannerHandle,
									GrandTech_Scanner_Vendor_USB_Send_Command,
									DataWidth,
									SWWidth,//SizeInBytesToRead,
									(ImageBuffer + SizeInBytesToRead*(TotalReadColorLine % MAXBUFFERNUMBER)),
									SizeInBytesToRead,
									&SizeInBytesRead,
									NULL);
									
			RImageFlag[(TotalReadColorLine % MAXBUFFERNUMBER)] = FALSE;
			TotalReadColorLine++;
			if(EndScan==TRUE)
				return TRUE;
			if(ReadimageFail)
				return FALSE;
		}
		for(j=0,k=0;j<CopyLineBytes;j+=3,k++)
		{

//	#ifdef _1200DPI_
	#ifdef _CCD_SCANNER_
			*(Buf_Address+Red+j) = (BYTE)(*(GammaTable + *(RColorTable[k] + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColorTable[k] + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
			*(Buf_Address+Bule+j) = (BYTE)(*(GammaTable + *(BColorTable[k] +*(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
	#else
			RColor = RColorTable[k];
			GColor = GColorTable[k];
			BColor = BColorTable[k];
//			*(Buf_Address+Red+j)   = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(RColor + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
//			*(Buf_Address+Green+j) = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
//			*(Buf_Address+Bule+j)  = (BYTE)(k%255);//(BYTE)(*(GammaTable + *(BColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
			*(Buf_Address+Red+j)   = (BYTE)(*(GammaTable + *(RColor + *(ImageBuffer + SizeInBytesToRead*(TotalReadLine % MAXBUFFERNUMBER)+j))));
			*(Buf_Address+Green+j) = (BYTE)(*(GammaTable + *(GColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine) % MAXBUFFERNUMBER)+j+1))));
			*(Buf_Address+Bule+j)  = (BYTE)(*(GammaTable + *(BColor + *(ImageBuffer + SizeInBytesToRead*((TotalReadLine+DiffLine*2) % MAXBUFFERNUMBER)+j+2))));
	#endif
		}
		RImageFlag[(TotalReadLine % MAXBUFFERNUMBER)] = TRUE;
	TotalReadLine++;
	return TRUE;
	}
	else 
		return FALSE;
	return TRUE;
#endif		

  }

/*
BOOL GetScalingColorLine(LPSTR	Buf_Address)
{
	ImageScalingBuff2 = (char *)malloc(LineBytes);
	if(PixelModeFlag)
		GetPixelModeImageLine(ImageScalingBuff2);
	else
		Get8BitsColorImageLine(ImageScalingBuff2);

	free(ImageScalingBuff2);
}

BOOL GetScalingImageLine(LPSTR	Buf_Address)
{
	int i,j,k;
	if(*(ScalingHeight+ScalingLines))
	{
		memcpy(Buf_Address,ImageScalingBuff1,LineBytes);
	}
	else
	{
		if(PixelModeFlag)
			GetPixelModeImageLine(ImageScalingBuff2);
		else
			Get8BitsColorImageLine(ImageScalingBuff2);
		
		for(i=0,j=0,k=0;i<LineBytes;i+=3,j++)
		{
			if(*(ScalingWidth+j))
			{
				*(Buf_Address+i+0) = *(Buf_Address+(i-3)+0);
				*(Buf_Address+i+1) = *(Buf_Address+(i-3)+1);
				*(Buf_Address+i+2) = *(Buf_Address+(i-3)+2);
			}
			else
			{
				*(Buf_Address+i+0) = *(ImageScalingBuff2+k+0);
				*(Buf_Address+i+1) = *(ImageScalingBuff2+k+1);
				*(Buf_Address+i+2) = *(ImageScalingBuff2+k+2);
				k+=3;
			}
		}
	}
	memcpy(ImageScalingBuff1,Buf_Address,LineBytes);
	ScalingLines++;
	return TRUE;
}
*/
EXPORT BOOL ReadScannedData(LPIMAGEROWS lpImgStruct)
{
	int i;
	LPSTR Imageaddr;
	int j;
	lpImgStruct->ecErrorCode = ERR_SPI_NONE;

	if(lpImgStruct->roRgbOrder == 0)
	{
        	Red = 0;
		Green = 1;
		Bule = 2;
	}
	else
	{
		Red = 2;
		Green = 1;
		Bule = 0;
	}

	lpImgStruct->wXferedLineNum = 0;
	if(ReadimageFail)
	{
		lpImgStruct->ecErrorCode = ERR_SPI_READIMAGE;
		return FALSE;
	}
	Imageaddr = lpImgStruct->pBuffer;
	for(i=0 ;i<(lpImgStruct->wWantedLineNum);i++)
	{
		if(FirstScan)
		//if(0)
		{
			for(j=0;j<10;j++)
			{
              			(*GetLineData)(lpImgStruct->pBuffer);
			}
			FirstScan=FALSE;
		}
		if(!(*GetLineData)((Imageaddr+(i * LineBytes))))
		{
			lpImgStruct->ecErrorCode = ERR_SPI_READIMAGE;
			return TRUE;
		}
		lpImgStruct->wXferedLineNum = lpImgStruct->wXferedLineNum +1;
		
#ifdef WIN32		
		if((i%100)==0)
		{
			if((*ScanCallBack)(lpImgStruct->wXferedLineNum)==FALSE)
			{
				lpImgStruct->ecErrorCode = ERR_SPI_CANCELSCAN;
				return TRUE;
			}
		}	
#endif	
		}
	return TRUE;
}
EXPORT BOOL PowerControl(LPLAMPCONTROL lpPowerControl)
{
#ifdef _CCD_SCANNER_
	lpPowerControl->ecErrorCode = ERR_SPI_NONE;

	Return_Info[0] = lpPowerControl->sbTurnOn;
	success = ProcessCommandMiscControl(
										 (HWND)NULL,
										 FALSE,
										 ScannerHandle,
										 GrandTech_Scanner_Vendor_USB_Send_Command,
										 COMMAND_MISC_CONTROL_LAMP_ON_OFF,
										 COMMAND_MISC_CONTROL_LAMP_ON_OFF,
										 Return_Info,
										 Return_Info);//FW not ready
	return success;
#else
	if(lpPowerControl->sbTurnOn==1)
	{
          ProcessCommandSendUserCommand(
								 (HWND)NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x10,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	Sleep(50);								 

	}
	lpPowerControl->ecErrorCode = ERR_SPI_NONE;
	return TRUE;
#endif
}
EXPORT BOOL GetDeviceStatus(LPDEVICESTATUS lpDeviceStatus)
{
//	MessageBox(NULL,"get status","",MB_OK);
	if(ScannerHandle==INVALID_HANDLE_VALUE)
	{
	  lpDeviceStatus->ecErrorCode = ERR_SPI_NOTCONNECT;
//	  	MessageBox(NULL,"get status not connect ","",MB_OK);
	}else
	{
	   lpDeviceStatus->ecErrorCode = ERR_SPI_NONE;
	}
	
	lpDeviceStatus->sbTriggerPrescan =0;
	lpDeviceStatus->sbTriggerScan = 0;
	lpDeviceStatus->sbTriggerAP = 0;
	lpDeviceStatus->sbPaperLoadedInADF = 0;

	return TRUE;
}


int	GetTopBound(USHORT	iXDPI)
{
//	USHORT		  HWWidth,HWHeight;
//#ifndef _MAC_
int	i,j;
#ifdef WIN32
	OVERLAPPED    h_Overlapped;
	HANDLE        h_hEvents;
	DWORD         status;
	DWORD         h_dwError;
	PUCHAR        TempBuffer;
	
	DWORD         nBytesRead; 
	ULONG		  Avg;
	USHORT		  SWWidth,SWHeight,ReadBytes;
	BOOL		  ScanPixelModeFlag;
	
	ScanPixelModeFlag = LINEMODE;
	ProcessCommandRetrieveNecessaryInfo2(
										 NULL,
										 FALSE,
										 ScannerHandle,
										 BusProtocol,
										 LAMPORDER,
										 LAMPSTEP,
										 ScanType,
//										 ColorMode,
										 XMAXDPI,
										 YMAXDPI,
#ifdef _1200DPI_
										 iXDPI,
										 iXDPI,
										 64,
										 400,
#else
										 XMAXDPI,
										 YMAXDPI,
										 64,
										 200,
#endif
										 &HWWidth,
										 &HWHeight,
										 &SWWidth,
										 &SWHeight,
										 WorkingBuffer);
    
	TempBuffer = (PUCHAR)malloc(SWWidth*3);
	if(ScanType==GreenMode)
		ReadBytes = SWWidth;
	else
		ReadBytes = SWWidth*3;
	success = ProcessCommandSetScanWindow3(
										   NULL,
										   FALSE,
										   ScannerHandle,
										   BusProtocol,
#ifdef _1200DPI_                          
										   (leftbound-72),
#else
										   (leftbound-36),
#endif
										   0,
										   HWWidth,
										   HWHeight,
#ifdef _1200DPI_
										   iXDPI,
#else
										   XMAXDPI,
#endif
										   SWWidth,
										   SWHeight,
//										   ColorMode,
										   ScanType,
										   8,
										   0,
										   TESTMODE,
										   BufferSize16K,
										   0,
										   (USHORT)(BusProtocol),
										   SENSORTYPE,
										   0,
										   SAS_OFF,
										   SBS_ON,
										   SOS_OFF,
										   BIBF_OFF,
										   0,
										   LOOS_OFF,
										   ABW_OFF,
										   ScanPixelModeFlag,
//										   PixelModeFlag,
#ifdef _1200DPI_
										   iXDPI,
#else
										   YMAXDPI,
#endif
										   0,
										   RDF_Optimize);
	success = ProcessCommandSetGTAFEGain(
									   NULL,
									   FALSE,
									   ScannerHandle,
									   BusProtocol,
									   R_Offset,
									   R_Gain,
									   G_Offset,
									   G_Gain,
									   B_Offset,
									   B_Gain);
#ifndef _CCD_SCANNER_
	success=ProcessCommandSetExposureTime(
                         NULL,
                         FALSE,
                         ScannerHandle,
                         BusProtocol,
                         4,
                         RedStop,
                         4,
                         GreenStop,
                         4,
                         BlueStop);
#endif
#ifdef _CIS_SCANNER_
	  ProcessCommandSendUserCommand(
								 NULL,
								 FALSE,
								 ScannerHandle,
								 GrandTech_Scanner_Vendor_USB_Send_Command,
								 0x10,
								 Return_Info,
								 64,
								 Return_Info,
								 64);
	Sleep(50);							 
#endif
#ifdef GT6816
	success=PollingMotor(ScannerHandle);
#endif
	success = ProcessCommandSetStartScan(
										 NULL,
										 FALSE,
										 ScannerHandle,
										 BusProtocol);
	success = ProcessCommandWaitScannerReady(
											 NULL,
											 FALSE,
											 ScannerHandle,
											 BusProtocol,
											 1000);
	
	for(i=0;i<SWHeight;i++)
	{
		 h_hEvents=CreateEvent(NULL,TRUE,FALSE,NULL); 
	     h_Overlapped.hEvent = h_hEvents;
         h_Overlapped.Offset = 0;
		 
			 ReadFile(ScannerHandle,
		             TempBuffer,
		             ReadBytes, 
		             &h_dwError,
                     &h_Overlapped); 
			 status=WaitForSingleObject(h_hEvents,12000);
			 GetOverlappedResult(ScannerHandle,&h_Overlapped,&nBytesRead,TRUE);
			 if(nBytesRead != (DWORD)(ReadBytes))
			 {
				 free(TempBuffer);
				 return 0;

			 }
			 if(i==99)
			 {
				 i=i;
			 }
//		if(PixelModeFlag == LINEMODE)
		if(ScanPixelModeFlag == LINEMODE)
		{
			// 13+10+13 = 36 black have 36pixel 600 dpi
			for(j=0,Avg=0;j<10;j++)
			{
				//Avg = Avg +(ULONG)(*(TempBuffer+SWWidth*3-10-j));
				if(ScanType==GreenMode)
					Avg = Avg +(ULONG)(*(TempBuffer+13+j));
				else
					Avg = Avg +(ULONG)(*(TempBuffer+SWWidth*2+13+j));
				// G channel
			}
		}
		else
		{
			for(j=0,Avg=0;j<30;j+=3)
			{
				Avg = Avg +(ULONG)(*(TempBuffer+(13*3)+j+1));
				// G channel
			}
		}
		Avg = (ULONG)(Avg/10);
		if( Avg> 120)
			break; 
	}
#ifdef GT6816
	success=EndScan41(ScannerHandle);
#else		
	success = ProcessCommandSetEndScan(
										NULL,
										FALSE,
										ScannerHandle,
										BusProtocol);
#endif	
	free(TempBuffer);
#endif
	return i;
}


WORD SetByDPI(WORD inDPI)
{
#ifdef _CCD_SCANNER_

		if(inDPI >= 1200)
		{			
			BufferFullFlag = BIBF_OFF;
			PixelModeFlag = LINEMODE;
			return 1200;
		}
		else if(inDPI >= 600)
		{
		    BufferFullFlag = BIBF_OFF;
			PixelModeFlag = PIXELMODE;
			return 600;

		}
		else if(inDPI >= 300)
		{
			
			BufferFullFlag = BIBF_ON;
			PixelModeFlag = PIXELMODE;
			return 300;

		}else if(inDPI >= 200)
		{
            BufferFullFlag = BIBF_ON;
			PixelModeFlag = PIXELMODE;
			return 200;

		}else if(inDPI >= 100)
		{
            BufferFullFlag = BIBF_ON;
			PixelModeFlag = PIXELMODE;
			return 100;

		}else if(inDPI >= 50)
		{
            BufferFullFlag = BIBF_ON;
			PixelModeFlag = PIXELMODE;
			return 50;

		}else
		{
			//return inDPI;
			return 50;
		}
#endif

#ifdef A1
		
		if(inDPI >= 600)
		{
			PixelModeFlag = PIXELMODE;
			 BufferFullFlag = BIBF_OFF;			
			return 600;

		}else if(inDPI >= 300)
		{
			PixelModeFlag = PIXELMODE;
			 BufferFullFlag = BIBF_ON;	
			return 300;

		}
		else if(inDPI >= 150)
		{
		PixelModeFlag = PIXELMODE;
		 BufferFullFlag = BIBF_ON;	
			return 150;

		}else if(inDPI >= 75)
		{
		PixelModeFlag = PIXELMODE;
		BufferFullFlag = BIBF_ON;	
			return 75;

		}else if(inDPI >= 50)
		{
			PixelModeFlag = PIXELMODE;
			 BufferFullFlag = BIBF_ON;	
			return 50;

		}else
		{
//			return inDPI;
			return 50;
		}


#endif

#ifdef PS1
		BufferFullFlag = BIBF_ON;
		PixelModeFlag = LINEMODE;
		
		if(inDPI >= 600)
		{
			//BufferFullFlag = BIBF_ON;
			if(ScanMode==1)   // Gray
			{
              BufferFullFlag = BIBF_ON;
			}else
			{
			  BufferFullFlag = BIBF_OFF;
			}			
			return 600;

		}else if(inDPI >= 300)
		{
			return 300;

		}
		else if(inDPI >= 150)
		{
			return 150;

		}else if(inDPI >= 75)
		{
			return 75;

		}else if(inDPI >= 50)
		{
			return 50;

		}else
		{
//			return inDPI;
			return 50;
		}
#endif

#ifdef PS2
		BufferFullFlag = BIBF_OFF;
		PixelModeFlag = LINEMODE;
		if(inDPI >= 1200)
		{			
			
			return 1200;
		}
		else if(inDPI >= 600)
		{
			return 600;

		}else if(inDPI >= 300)
		{
			return 300;

		}
		else if(inDPI >= 200)
		{
			return 200;

		}else if(inDPI >= 150)
		{
			return 150;

		}else if(inDPI >= 100)
		{
			return 100;

		}else if(inDPI >= 50)
		{
			return 50;

		}else
		{
			//return inDPI;
		return 50;
		}
#endif
#ifdef SB
		BufferFullFlag = BIBF_ON;
		PixelModeFlag = LINEMODE;
		
		if(inDPI >= 600)
		{
			//BufferFullFlag = BIBF_ON;
			return 600;

		}else if(inDPI >= 300)
		{
			return 300;

		}
		else if(inDPI >= 150)
		{
			return 150;

		}else if(inDPI >= 75)
		{
			return 75;

		}else if(inDPI >= 50)
		{
			return 50;

		}else
		{
			//return inDPI;
			return 50;
		}
#endif
		
}
