/* BearPaw1200CU panel

   Copyright (C) 2001 Mustek. 
   Maintained by Tom Wang and Alex Lin
   <tom.wang@mustek.com.tw, alex_lin@mustek.com.tw>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
*/


#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include "scanner.h"

int main(int argc, char* argv[])
{
	
	BYTE bFunction;
	pid_t my_pid;
	pid_t ppid;
	pid_t fork_pid;
	
	DIR* proc_dir;
	struct dirent *next;
	char s_pid[256];
	char link[256], real[256];
	char my_path[256];
	char panel_path[256];
	char* index;
	
	my_pid = getpid();
	ppid = getppid();

	sprintf(link, "/proc/%d/exe",my_pid);
	sprintf(s_pid, "%d",my_pid);
	if (realpath(link,my_path) == NULL) {
		printf("Failed to get my executable path, /proc not mounted?\n"); 
		return 1;	
	}
	strcpy(panel_path, my_path);
	index = strrchr(panel_path,'/');
	index[1] = 0;
	chdir(panel_path);
	strcat(panel_path, "BearPaw1200CU_panel");
	proc_dir = opendir("/proc/");
	if (!proc_dir) {
		printf("fail to opendir for /proc.\n");
		return 1;
	}
	
	while ((next=readdir(proc_dir))!=NULL){
		if (strcmp(next->d_name,"self")!= 0 && 
		    strcmp(next->d_name,s_pid)!=0) {
			sprintf(link, "/proc/%s/exe",next->d_name);
			if (realpath(link,real)!=NULL) {
				if (strcmp(real, my_path) == 0) {
					printf("There is another watch running. Program terminated.\n");
					return 1;
				}
			}
		}
	} 
	closedir(proc_dir);
	sprintf(link, "/proc/%d/exe",ppid);
	while (1) {
		if (realpath(link,my_path) == NULL) {
			printf("parent process terminated."); 
			return 1;	
		}		
		Sleep(1000); // check key status every 1 second
		if(_Open()) {
			CheckFunctionKey(&bFunction);
			_Close();
			if (bFunction==1) { 
				fork_pid = fork();			
				if (fork_pid ==0) {
					execlp("xterm", "xterm", "-iconic", "-e",
						panel_path,"s",NULL);
				}
			}
			else if(bFunction==2) {
				fork_pid = fork();
				if (fork_pid ==0) {
				     execlp("xterm", "xterm", "-iconic", "-e",
					    panel_path,"c",NULL);
				}
			}
			else if(bFunction==3) {
				fork_pid = fork();
				if (fork_pid ==0) {
				     execlp("xterm", "xterm", "-iconic", "-e",
					    panel_path,"f",NULL);
				}
			}
			else if(bFunction==4) {
				fork_pid = fork();
				if (fork_pid ==0) {
				     execlp("xterm", "xterm", "-iconic", "-e",
					    panel_path,"m",NULL);
				}
			}
			else if(bFunction==5) {
				fork_pid = fork();
				if (fork_pid ==0) {
				     execlp("xterm", "xterm", "-iconic", "-e",
					    panel_path,"p",NULL);
				}
			}
				  
						
		}
	}
	return 1;
}

