/***************************************************************************
                          boeder.h  -  description
                             -------------------
    begin                : Tue Oct 9 2001
    copyright            : (C) 2001 by Anthony Sale
    email                : anthony_sale@jumble.i12.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#if !defined (__BOEDER__H__)

#include <stdio.h>
#include <stdlib.h>

#include "gt6801.h"

 /*
 * GT-6801 Methods for Boeder Sm@rtScan SlineLine Edition
 */

 #define __BOEDER__H__

#define COLOUR	0xE084
#define GREY			0xE082
#define LINE				0X0000

BOOLEAN startup(struct arguments *args, FILE *scanner);
BOOLEAN loadfirmware(struct arguments *args, FILE *scanner);
BOOLEAN configure(struct arguments *args, FILE *scanner);
BOOLEAN startscan(struct arguments *qrgs, FILE *scanner);

void logrecord(char outbuffer[0x40], char inbuffer[0x40]);

struct scan_details {
	__u16 instruction;
	__u16	ystart;
	__u16 yheight;
	__u16 xstart;
	__u16 xwidth;
	__u16 mode;
	__u16 resolution;
	__u16	unknown;
	__u16 scanwidth;
	__u16 scanlines;
	__u16	unknown2;
	__u16 unknown3;
};

//debug bits

static char firmbuffer[0x40];

static int dbgcount;

#endif